DefinitionBlock ("dsdt.aml", "DSDT", 2, "LENOVO", "SNB-CPT", 0x00000000)
{
    Method (DTGP, 5, NotSerialized)
    {
        If (LEqual (Arg0, Buffer (0x10)
                {
                    /* 0000 */    0xC6, 0xB7, 0xB5, 0xA0, 0x18, 0x13, 0x1C, 0x44, 
                    /* 0008 */    0xB0, 0xC9, 0xFE, 0x69, 0x5E, 0xAF, 0x94, 0x9B
                }))
        {
            If (LEqual (Arg1, One))
            {
                If (LEqual (Arg2, Zero))
                {
                    Store (Buffer (One)
                        {
                            0x03
                        }, Arg4)
                    Return (One)
                }
                If (LEqual (Arg2, One))
                {
                    Return (One)
                }
            }
        }
        Store (Buffer (One)
            {
                0x00
            }, Arg4)
        Return (Zero)
    }
    External (HNOT, MethodObj)    // 1 Arguments
    External (SNXD)
    External (HWID, IntObj)
    External (IDAB, MethodObj)    // 0 Arguments
    External (HDOS, MethodObj)    // 0 Arguments
    External (TNOT, MethodObj)    // 0 Arguments
    External (CFGD)
    External (PDC7)
    External (PDC6)
    External (PDC5)
    External (PDC4)
    External (PDC3)
    External (PDC2)
    External (PDC1)
    External (PDC0)
    External (\_PR_.CPU0._PPC)
    External (\_SB_.PCI0.PEG0.PEGP.DD02)
    Name (SS1, One)
    Name (SS2, Zero)
    Name (SS3, One)
    Name (SS4, One)
    Name (SP2O, 0x4E)
    Name (SP1O, 0x164E)
    Name (IO1B, 0x0600)
    Name (IO1L, 0x70)
    Name (IO2B, 0x0680)
    Name (IO2L, 0x20)
    Name (IO3B, 0x0290)
    Name (IO3L, 0x10)
    Name (SP3O, 0x2E)
    Name (IO4B, 0x0A20)
    Name (IO4L, 0x20)
    Name (MCHB, 0xFED10000)
    Name (MCHL, 0x8000)
    Name (EGPB, 0xFED19000)
    Name (EGPL, 0x1000)
    Name (DMIB, 0xFED18000)
    Name (DMIL, 0x1000)
    Name (IFPB, 0xFED14000)
    Name (IFPL, 0x1000)
    Name (PEBS, 0xF8000000)
    Name (PELN, 0x04000000)
    Name (SMBS, 0x0580)
    Name (SMBL, 0x20)
    Name (PBLK, 0x0410)
    Name (PMBS, 0x0400)
    Name (PMLN, 0x80)
    Name (LVL2, 0x0414)
    Name (LVL3, 0x0415)
    Name (LVL4, 0x0416)
    Name (SMIP, 0xB2)
    Name (GPBS, 0x0500)
    Name (GPLN, 0x80)
    Name (APCB, 0xFEC00000)
    Name (APCL, 0x1000)
    Name (PM30, 0x0430)
    Name (SRCB, 0xFED1C000)
    Name (SRCL, 0x4000)
    Name (HPTB, 0xFED00000)
    Name (HPTC, 0xFED1F404)
    Name (ACPH, 0xDE)
    Name (ASSB, Zero)
    Name (AOTB, Zero)
    Name (AAXB, Zero)
    Name (PEHP, One)
    Name (SHPC, One)
    Name (PEPM, One)
    Name (PEER, One)
    Name (PECS, One)
    Name (DSSP, Zero)
    Name (FHPP, Zero)
    Name (FMBL, One)
    Name (FDTP, 0x02)
    Name (FUPS, 0x03)
    Name (BSH, Zero)
    Name (BEL, One)
    Name (BEH, 0x02)
    Name (BRH, 0x03)
    Name (BTF, 0x04)
    Name (BHC, 0x05)
    Name (BYB, 0x06)
    Name (BPH, 0x07)
    Name (BSHS, 0x08)
    Name (BELS, 0x09)
    Name (BRHS, 0x0A)
    Name (BTFS, 0x0B)
    Name (BEHS, 0x0C)
    Name (BPHS, 0x0D)
    Name (BTL, 0x10)
    Name (BSR, 0x14)
    Name (BOF, 0x20)
    Name (BEF, 0x21)
    Name (BLLE, 0x22)
    Name (BLLC, 0x23)
    Name (BLCA, 0x24)
    Name (BLLS, 0x25)
    Name (BLLP, 0x26)
    Name (BLLD, 0x27)
    Name (BHBE, 0x30)
    Name (BHBC, 0x31)
    Name (BHBN, 0x32)
    Name (BHBM, 0x33)
    Name (TCGM, One)
    Name (TRTP, One)
    Name (WDTE, One)
    Name (TRTD, 0x02)
    Name (TRTI, 0x03)
    Name (PDBR, 0x4D)
    Name (DPPB, 0xFED98000)
    Name (DPPL, 0x8000)
    OperationRegion (GNVS, SystemMemory, 0xBAF3DE18, 0x01A6)
    Field (GNVS, AnyAcc, Lock, Preserve)
    {
        OSYS,   16, 
        SMIF,   8, 
        PRM0,   8, 
        PRM1,   8, 
        SCIF,   8, 
        PRM2,   8, 
        PRM3,   8, 
        LCKF,   8, 
        PRM4,   8, 
        PRM5,   8, 
        P80D,   32, 
        LIDS,   8, 
        PWRS,   8, 
        DBGS,   8, 
        THOF,   8, 
        ACT1,   8, 
        ACTT,   8, 
        PSVT,   8, 
        TC1V,   8, 
        TC2V,   8, 
        TSPV,   8, 
        CRTT,   8, 
        DTSE,   8, 
        DTS1,   8, 
        DTS2,   8, 
        DTSF,   8, 
                Offset (0x25), 
        REVN,   8, 
                Offset (0x28), 
        APIC,   8, 
        TCNT,   8, 
        PCP0,   8, 
        PCP1,   8, 
        PPCM,   8, 
        PPMF,   32, 
        C67L,   8, 
        NATP,   8, 
        CMAP,   8, 
        CMBP,   8, 
        LPTP,   8, 
        FDCP,   8, 
        CMCP,   8, 
        CIRP,   8, 
        SMSC,   8, 
        W381,   8, 
        SMC1,   8, 
        IGDS,   8, 
        TLST,   8, 
        CADL,   8, 
        PADL,   8, 
        CSTE,   16, 
        NSTE,   16, 
        SSTE,   16, 
        NDID,   8, 
        DID1,   32, 
        DID2,   32, 
        DID3,   32, 
        DID4,   32, 
        DID5,   32, 
        KSV0,   32, 
        KSV1,   8, 
                Offset (0x67), 
        BLCS,   8, 
        BRTL,   8, 
        ALSE,   8, 
        ALAF,   8, 
        LLOW,   8, 
        LHIH,   8, 
                Offset (0x6E), 
        EMAE,   8, 
        EMAP,   16, 
        EMAL,   16, 
                Offset (0x74), 
        MEFE,   8, 
        DSTS,   8, 
                Offset (0x78), 
        TPMP,   8, 
                Offset (0x7A), 
        MORD,   8, 
        TCGP,   8, 
        PPRP,   32, 
        PPRQ,   8, 
        LPPR,   8, 
        GTF0,   112, 
        GTF2,   56, 
        IDEM,   8, 
        GTF1,   56, 
        BID,    8, 
                Offset (0xAA), 
        ASLB,   32, 
        IBTT,   8, 
        IPAT,   8, 
        ITVF,   8, 
        ITVM,   8, 
        IPSC,   8, 
        IBLC,   8, 
        IBIA,   8, 
        ISSC,   8, 
        I409,   8, 
        I509,   8, 
        I609,   8, 
        I709,   8, 
        IPCF,   8, 
        IDMS,   8, 
        IF1E,   8, 
        HVCO,   8, 
        NXD1,   32, 
        NXD2,   32, 
        NXD3,   32, 
        NXD4,   32, 
        NXD5,   32, 
        NXD6,   32, 
        NXD7,   32, 
        NXD8,   32, 
        GSMI,   8, 
        PAVP,   8, 
                Offset (0xE1), 
        OSCC,   8, 
        NEXP,   8, 
        SBV1,   8, 
        SBV2,   8, 
                Offset (0xEB), 
        DSEN,   8, 
        ECON,   8, 
        GPIC,   8, 
        CTYP,   8, 
        L01C,   8, 
        VFN0,   8, 
        VFN1,   8, 
        VFN2,   8, 
        VFN3,   8, 
        VFN4,   8, 
                Offset (0x100), 
        NVGA,   32, 
        NVHA,   32, 
        AMDA,   32, 
        DID6,   32, 
        DID7,   32, 
        DID8,   32, 
        EBAS,   32, 
        CPSP,   32, 
        EECP,   32, 
        EVCP,   32, 
        XBAS,   32, 
        OBS1,   32, 
        OBS2,   32, 
        OBS3,   32, 
        OBS4,   32, 
        OBS5,   32, 
        OBS6,   32, 
        OBS7,   32, 
        OBS8,   32, 
                Offset (0x157), 
        ATMC,   8, 
        PTMC,   8, 
        ATRA,   8, 
        PTRA,   8, 
        PNHM,   32, 
        TBAB,   32, 
        TBAH,   32, 
        RTIP,   8, 
        TSOD,   8, 
        ATPC,   8, 
        PTPC,   8, 
        PFLV,   8, 
        BREV,   8, 
        SGMD,   8, 
        SGFL,   8, 
        PWOK,   8, 
        HLRS,   8, 
        DSEL,   8, 
        ESEL,   8, 
        PSEL,   8, 
        PWEN,   8, 
        PRST,   8, 
        MXD1,   32, 
        MXD2,   32, 
        MXD3,   32, 
        MXD4,   32, 
        MXD5,   32, 
        MXD6,   32, 
        MXD7,   32, 
        MXD8,   32, 
        GBAS,   16, 
                Offset (0x19D), 
        ALFP,   8, 
        IMON,   8, 
        PDTS,   8, 
        PKGA,   8, 
        PAMT,   8, 
        AC0F,   8, 
        AC1F,   8, 
        DTS3,   8, 
        DTS4,   8
    }
    OperationRegion (QNVS, SystemMemory, 0xBAF9D018, 0x1000)
    Field (QNVS, AnyAcc, NoLock, Preserve)
    {
                Offset (0x300), 
        WOLN,   8, 
        BRNS,   8, 
        ACST,   1, 
        BTLA,   1, 
        WLLA,   1, 
            ,   1, 
            ,   1, 
        TMCM,   1, 
        LIDF,   1, 
                Offset (0x303), 
        USBP,   8, 
        USG0,   1, 
        USG1,   1, 
        USG2,   1, 
        USG3,   1, 
        ESG0,   1, 
        ESG1,   1, 
        ESG2,   1, 
        ESG3,   1, 
        LANO,   1, 
        VCDB,   1, 
        C4WR,   1, 
        C4AC,   1, 
        OSC4,   1, 
        SPEN,   1, 
        SCRM,   1, 
        ODDS,   1, 
        BTMD,   1, 
        WLNP,   1, 
        WANP,   1, 
        MCMU,   1, 
        CMAB,   1, 
        WOFF,   1, 
        CMAT,   1, 
        BTHA,   1, 
        CBCI,   1, 
        CWAI,   1, 
        CBTP,   1, 
        WWAP,   1, 
        WANA,   1, 
        WWNA,   1, 
        WALA,   1, 
        BTHG,   1, 
        OSFG,   1, 
        BATB,   1, 
        SWDT,   1, 
                Offset (0x309), 
        BRTC,   8, 
        TJ90,   8, 
        SXFG,   8, 
        FTPS,   8, 
        CWAC,   1, 
        CWAS,   1, 
        CWUE,   1, 
        CWUS,   1, 
        C4NA,   1, 
                Offset (0x30E), 
        BFAD,   1, 
                Offset (0x30F), 
                Offset (0x310), 
                Offset (0x311), 
                Offset (0x312), 
                Offset (0x313), 
        DEDL,   8, 
        GCDE,   4, 
        DADD,   4, 
        IPMS,   8, 
        IPMB,   120, 
        IPMR,   24, 
        IPMO,   24, 
        IPMA,   8, 
        LIDX,   1, 
                Offset (0x32D), 
        AUMA,   1, 
                Offset (0x32E), 
        DPP0,   1, 
        DPP1,   1, 
        DPP2,   1, 
        DPP3,   1, 
        DPP4,   1, 
        DPP5,   1, 
                Offset (0x32F), 
                Offset (0x330), 
        BFWB,   296, 
                Offset (0x360), 
        FW00,   128, 
        CWAP,   16, 
        CWAT,   16, 
                Offset (0x380), 
        TPME,   8, 
        TCG0,   1, 
        TCG1,   1, 
                Offset (0x382), 
                Offset (0x3A0), 
        DB00,   8, 
        DB01,   8, 
        DB02,   8, 
        DB03,   8, 
        DB04,   8, 
        DB05,   8, 
        DB06,   8, 
        DB07,   8, 
        DB08,   8, 
        DB09,   8, 
        DB0A,   8, 
        DB0B,   8, 
        DB0C,   8, 
        DB0D,   8, 
        DB0E,   8, 
        DB0F,   8, 
        DB10,   8, 
        DB11,   8, 
        DB12,   8, 
        DB13,   8, 
        DB14,   8, 
        DB15,   8, 
        DB16,   8, 
        DB17,   8, 
        DB18,   8, 
        DB19,   8, 
        DB1A,   8, 
        DB1B,   8, 
        DB1C,   8, 
        DB1D,   8, 
        DB1E,   8, 
        DB1F,   8, 
                Offset (0x400), 
        CMD,    8, 
        ERR,    32, 
        PAR0,   32, 
        PAR1,   32, 
        PAR2,   32, 
        PAR3,   32, 
                Offset (0x500), 
        IF00,   128, 
        IF01,   128, 
        IF02,   128, 
        IF03,   128, 
        IF04,   128, 
        IF05,   128, 
        IF06,   128, 
        IF07,   128, 
        IF08,   128, 
        IF09,   128, 
        IF0A,   128, 
        IF0B,   128, 
        IF0C,   128, 
        IF0D,   128, 
        IF0E,   128, 
        IF0F,   128, 
        WITM,   8, 
        WSEL,   8, 
        WLS0,   8, 
        WLS1,   8, 
        WLS2,   8, 
        WLS3,   8, 
        WLS4,   8, 
        WLS5,   8, 
        WLS6,   8, 
        WLS7,   8, 
        WENC,   8, 
        WKBD,   8, 
        WPTY,   8, 
        WPAS,   1032, 
        WPNW,   1032, 
        WSPM,   8, 
        WSPS,   8, 
        WSMN,   8, 
        WSMX,   8, 
        WSEN,   8, 
        WSKB,   8, 
                Offset (0xB00), 
        VEDI,   1024
    }
    Scope (_SB)
    {
        Name (PR00, Package (0x1E)
        {
            Package (0x04)
            {
                0x001FFFFF, 
                Zero, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x03, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                Zero, 
                LNKH, 
                Zero
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001BFFFF, 
                Zero, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x0018FFFF, 
                Zero, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0019FFFF, 
                Zero, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                0x03, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x02, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x03, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR00, Package (0x1E)
        {
            Package (0x04)
            {
                0x001FFFFF, 
                Zero, 
                Zero, 
                0x15
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x03, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                Zero, 
                Zero, 
                0x17
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001BFFFF, 
                Zero, 
                Zero, 
                0x16
            }, 
            Package (0x04)
            {
                0x0018FFFF, 
                Zero, 
                Zero, 
                0x14
            }, 
            Package (0x04)
            {
                0x0019FFFF, 
                Zero, 
                Zero, 
                0x14
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                0x03, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                Zero, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                One, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x02, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x03, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR04, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR04, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR05, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKA, 
                Zero
            }
        })
        Name (AR05, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x10
            }
        })
        Name (PR06, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKB, 
                Zero
            }
        })
        Name (AR06, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x11
            }
        })
        Name (PR07, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKC, 
                Zero
            }
        })
        Name (AR07, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x12
            }
        })
        Name (PR08, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR08, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR09, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKA, 
                Zero
            }
        })
        Name (AR09, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x10
            }
        })
        Name (PR0E, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKB, 
                Zero
            }
        })
        Name (AR0E, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x11
            }
        })
        Name (PR0F, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKC, 
                Zero
            }
        })
        Name (AR0F, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x12
            }
        })
        Name (PR02, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR02, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR0A, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKA, 
                Zero
            }
        })
        Name (AR0A, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x10
            }
        })
        Name (PR0B, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKB, 
                Zero
            }
        })
        Name (AR0B, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x11
            }
        })
        Name (PR0C, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKC, 
                Zero
            }
        })
        Name (AR0C, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x12
            }
        })
        Name (PR01, Package (0x0C)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKH, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                LNKH, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                One, 
                LNKE, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x02, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x03, 
                LNKF, 
                Zero
            }
        })
        Name (AR01, Package (0x0C)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x15
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x16
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x17
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x14
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                Zero, 
                0x16
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                Zero, 
                0x15
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                Zero, 
                0x14
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                Zero, 
                0x17
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                One, 
                Zero, 
                0x14
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x02, 
                Zero, 
                0x16
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x03, 
                Zero, 
                0x15
            }
        })
        Name (PRSA, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {1,3,4,5,6,10,11,12,14,15}
        })
        Alias (PRSA, PRSB)
        Alias (PRSA, PRSC)
        Alias (PRSA, PRSD)
        Alias (PRSA, PRSE)
        Alias (PRSA, PRSF)
        Alias (PRSA, PRSG)
        Alias (PRSA, PRSH)
        Device (PCI0)
        {
            Name (_HID, EisaId ("PNP0A08"))
            Name (_CID, EisaId ("PNP0A03"))
            Name (_ADR, Zero)
            Method (^BN00, 0, NotSerialized)
            {
                Return (Zero)
            }
            Method (_BBN, 0, NotSerialized)
            {
                Return (BN00 ())
            }
            Name (_UID, Zero)
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR00 ())
                }
                Return (PR00 ())
            }
            OperationRegion (HBUS, PCI_Config, Zero, 0x0100)
            Field (HBUS, DWordAcc, NoLock, Preserve)
            {
                        Offset (0x40), 
                EPEN,   1, 
                    ,   11, 
                EPBR,   20, 
                        Offset (0x48), 
                MHEN,   1, 
                    ,   14, 
                MHBR,   17, 
                        Offset (0x50), 
                GCLK,   1, 
                        Offset (0x54), 
                D0EN,   1, 
                        Offset (0x60), 
                PXEN,   1, 
                PXSZ,   2, 
                    ,   23, 
                PXBR,   6, 
                        Offset (0x68), 
                DIEN,   1, 
                    ,   11, 
                DIBR,   20, 
                        Offset (0x70), 
                    ,   20, 
                MEBR,   12, 
                        Offset (0x80), 
                    ,   4, 
                PM0H,   2, 
                        Offset (0x81), 
                PM1L,   2, 
                    ,   2, 
                PM1H,   2, 
                        Offset (0x82), 
                PM2L,   2, 
                    ,   2, 
                PM2H,   2, 
                        Offset (0x83), 
                PM3L,   2, 
                    ,   2, 
                PM3H,   2, 
                        Offset (0x84), 
                PM4L,   2, 
                    ,   2, 
                PM4H,   2, 
                        Offset (0x85), 
                PM5L,   2, 
                    ,   2, 
                PM5H,   2, 
                        Offset (0x86), 
                PM6L,   2, 
                    ,   2, 
                PM6H,   2, 
                        Offset (0x87), 
                        Offset (0xA8), 
                    ,   20, 
                TUUD,   19, 
                        Offset (0xBC), 
                    ,   20, 
                TLUD,   12, 
                        Offset (0xC8), 
                    ,   7, 
                HTSE,   1
            }
            OperationRegion (MCHT, SystemMemory, 0xFED10000, 0x1100)
            Field (MCHT, ByteAcc, NoLock, Preserve)
            {
            }
            Name (BUF0, ResourceTemplate ()
            {
                WordBusNumber (ResourceProducer, MinFixed, MaxFixed, PosDecode,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x00FF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0100,             // Length
                    ,, )
                DWordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x00000000,         // Granularity
                    0x00000000,         // Range Minimum
                    0x00000CF7,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000CF8,         // Length
                    ,, , TypeStatic)
                IO (Decode16,
                    0x0CF8,             // Range Minimum
                    0x0CF8,             // Range Maximum
                    0x01,               // Alignment
                    0x08,               // Length
                    )
                DWordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x00000000,         // Granularity
                    0x00000D00,         // Range Minimum
                    0x0000FFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x0000F300,         // Length
                    ,, , TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000A0000,         // Range Minimum
                    0x000BFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00020000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000C0000,         // Range Minimum
                    0x000C3FFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000C4000,         // Range Minimum
                    0x000C7FFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000C8000,         // Range Minimum
                    0x000CBFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000CC000,         // Range Minimum
                    0x000CFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000D0000,         // Range Minimum
                    0x000D3FFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000D4000,         // Range Minimum
                    0x000D7FFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000D8000,         // Range Minimum
                    0x000DBFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000DC000,         // Range Minimum
                    0x000DFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000E0000,         // Range Minimum
                    0x000E3FFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000E4000,         // Range Minimum
                    0x000E7FFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000E8000,         // Range Minimum
                    0x000EBFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000EC000,         // Range Minimum
                    0x000EFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00004000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000F0000,         // Range Minimum
                    0x000FFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00010000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x00000000,         // Range Minimum
                    0xFEAFFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0xFEB00000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0xFED40000,         // Range Minimum
                    0xFED44FFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00005000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0xFEAFF000,         // Range Minimum
                    0xFEB00000,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00001001,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
            })
            Method (_CRS, 0, Serialized)
            {
                CreateWordField (BUF0, 0x0A, PBMX)
                Store (Subtract (ShiftRight (PELN, 0x14), 0x02), PBMX)
                CreateWordField (BUF0, 0x0E, PBLN)
                Store (Subtract (ShiftRight (PELN, 0x14), One), PBLN)
                If (PM1L)
                {
                    CreateDWordField (BUF0, 0x7C, C0LN)
                    Store (Zero, C0LN)
                }
                If (LEqual (PM1L, One))
                {
                    CreateBitField (BUF0, 0x0358, C0RW)
                    Store (Zero, C0RW)
                }
                If (PM1H)
                {
                    CreateDWordField (BUF0, 0x96, C4LN)
                    Store (Zero, C4LN)
                }
                If (LEqual (PM1H, One))
                {
                    CreateBitField (BUF0, 0x0428, C4RW)
                    Store (Zero, C4RW)
                }
                If (PM2L)
                {
                    CreateDWordField (BUF0, 0xB0, C8LN)
                    Store (Zero, C8LN)
                }
                If (LEqual (PM2L, One))
                {
                    CreateBitField (BUF0, 0x04F8, C8RW)
                    Store (Zero, C8RW)
                }
                If (PM2H)
                {
                    CreateDWordField (BUF0, 0xCA, CCLN)
                    Store (Zero, CCLN)
                }
                If (LEqual (PM2H, One))
                {
                    CreateBitField (BUF0, 0x05C8, CCRW)
                    Store (Zero, CCRW)
                }
                If (PM3L)
                {
                    CreateDWordField (BUF0, 0xE4, D0LN)
                    Store (Zero, D0LN)
                }
                If (LEqual (PM3L, One))
                {
                    CreateBitField (BUF0, 0x0698, D0RW)
                    Store (Zero, D0RW)
                }
                If (PM3H)
                {
                    CreateDWordField (BUF0, 0xFE, D4LN)
                    Store (Zero, D4LN)
                }
                If (LEqual (PM3H, One))
                {
                    CreateBitField (BUF0, 0x0768, D4RW)
                    Store (Zero, D4RW)
                }
                If (PM4L)
                {
                    CreateDWordField (BUF0, 0x0118, D8LN)
                    Store (Zero, D8LN)
                }
                If (LEqual (PM4L, One))
                {
                    CreateBitField (BUF0, 0x0838, D8RW)
                    Store (Zero, D8RW)
                }
                If (PM4H)
                {
                    CreateDWordField (BUF0, 0x0132, DCLN)
                    Store (Zero, DCLN)
                }
                If (LEqual (PM4H, One))
                {
                    CreateBitField (BUF0, 0x0908, DCRW)
                    Store (Zero, DCRW)
                }
                If (PM5L)
                {
                    CreateDWordField (BUF0, 0x014C, E0LN)
                    Store (Zero, E0LN)
                }
                If (LEqual (PM5L, One))
                {
                    CreateBitField (BUF0, 0x09D8, E0RW)
                    Store (Zero, E0RW)
                }
                If (PM5H)
                {
                    CreateDWordField (BUF0, 0x0166, E4LN)
                    Store (Zero, E4LN)
                }
                If (LEqual (PM5H, One))
                {
                    CreateBitField (BUF0, 0x0AA8, E4RW)
                    Store (Zero, E4RW)
                }
                If (PM6L)
                {
                    CreateDWordField (BUF0, 0x0180, E8LN)
                    Store (Zero, E8LN)
                }
                If (LEqual (PM6L, One))
                {
                    CreateBitField (BUF0, 0x0B78, E8RW)
                    Store (Zero, E8RW)
                }
                If (PM6H)
                {
                    CreateDWordField (BUF0, 0x019A, ECLN)
                    Store (Zero, ECLN)
                }
                If (LEqual (PM6H, One))
                {
                    CreateBitField (BUF0, 0x0C48, ECRW)
                    Store (Zero, ECRW)
                }
                If (PM0H)
                {
                    CreateDWordField (BUF0, 0x01B4, F0LN)
                    Store (Zero, F0LN)
                }
                If (LEqual (PM0H, One))
                {
                    CreateBitField (BUF0, 0x0D18, F0RW)
                    Store (Zero, F0RW)
                }
                CreateDWordField (BUF0, 0x01C2, M1MN)
                CreateDWordField (BUF0, 0x01C6, M1MX)
                CreateDWordField (BUF0, 0x01CE, M1LN)
                ShiftLeft (TLUD, 0x14, M1MN)
                Add (Subtract (M1MX, M1MN), One, M1LN)
                Return (BUF0)
            }
            Name (GUID, Buffer (0x10)
            {
                /* 0000 */    0x5B, 0x4D, 0xDB, 0x33, 0xF7, 0x1F, 0x1C, 0x40, 
                /* 0008 */    0x96, 0x57, 0x74, 0x41, 0xC0, 0x3D, 0xD7, 0x66
            })
            Name (SUPP, Zero)
            Name (CTRL, Zero)
            Method (_OSC, 4, Serialized)
            {
                Store (Arg3, Local0)
                CreateDWordField (Local0, Zero, CDW1)
                CreateDWordField (Local0, 0x04, CDW2)
                CreateDWordField (Local0, 0x08, CDW3)
                If (LAnd (LEqual (Arg0, GUID), NEXP))
                {
                    Store (CDW2, SUPP)
                    Store (CDW3, CTRL)
                    If (Not (And (CDW1, One)))
                    {
                        If (And (CTRL, One))
                        {
                            NHPG ()
                        }
                        If (And (CTRL, 0x04))
                        {
                            NPME ()
                        }
                    }
                    If (LNotEqual (Arg1, One))
                    {
                        Or (CDW1, 0x08, CDW1)
                    }
                    If (LNotEqual (CDW3, CTRL))
                    {
                        Or (CDW1, 0x10, CDW1)
                    }
                    Store (CTRL, CDW3)
                    Store (CTRL, OSCC)
                    Return (Local0)
                }
                Else
                {
                    Or (CDW1, 0x04, CDW1)
                    Return (Local0)
                }
            }
            Scope (\_SB.PCI0)
            {
                Method (AR00, 0, NotSerialized)
                {
                    Return (^^AR00)
                }
                Method (PR00, 0, NotSerialized)
                {
                    Return (^^PR00)
                }
                Method (AR01, 0, NotSerialized)
                {
                    Return (^^AR01)
                }
                Method (PR01, 0, NotSerialized)
                {
                    Return (^^PR01)
                }
                Method (AR02, 0, NotSerialized)
                {
                    Return (^^AR02)
                }
                Method (PR02, 0, NotSerialized)
                {
                    Return (^^PR02)
                }
                Method (AR04, 0, NotSerialized)
                {
                    Return (^^AR04)
                }
                Method (PR04, 0, NotSerialized)
                {
                    Return (^^PR04)
                }
                Method (AR05, 0, NotSerialized)
                {
                    Return (^^AR05)
                }
                Method (PR05, 0, NotSerialized)
                {
                    Return (^^PR05)
                }
                Method (AR06, 0, NotSerialized)
                {
                    Return (^^AR06)
                }
                Method (PR06, 0, NotSerialized)
                {
                    Return (^^PR06)
                }
                Method (AR07, 0, NotSerialized)
                {
                    Return (^^AR07)
                }
                Method (PR07, 0, NotSerialized)
                {
                    Return (^^PR07)
                }
                Method (AR08, 0, NotSerialized)
                {
                    Return (^^AR08)
                }
                Method (PR08, 0, NotSerialized)
                {
                    Return (^^PR08)
                }
                Method (AR09, 0, NotSerialized)
                {
                    Return (^^AR09)
                }
                Method (PR09, 0, NotSerialized)
                {
                    Return (^^PR09)
                }
                Method (AR0A, 0, NotSerialized)
                {
                    Return (^^AR0A)
                }
                Method (PR0A, 0, NotSerialized)
                {
                    Return (^^PR0A)
                }
                Method (AR0B, 0, NotSerialized)
                {
                    Return (^^AR0B)
                }
                Method (PR0B, 0, NotSerialized)
                {
                    Return (^^PR0B)
                }
            }
            Device (P0P1)
            {
                Name (_ADR, 0x001E0000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0B, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR01 ())
                    }
                    Return (PR01 ())
                }
            }
            Device (LPCB)
            {
                Name (_ADR, 0x001F0000)
                Scope (\_SB)
                {
                    Name (TCGP, Buffer (0x08)
                    {
                        /* 0000 */    0x1F, 0xE0, 0x1F, 0x01, 0x02, 0x04, 0x08, 0xF0
                    })
                    CreateByteField (TCGP, Zero, PPRQ)
                    CreateByteField (TCGP, One, PPL1)
                    CreateByteField (TCGP, 0x02, PPRP)
                    CreateByteField (TCGP, 0x03, TPRS)
                    CreateByteField (TCGP, 0x04, PPOR)
                    CreateByteField (TCGP, 0x05, TPMV)
                    CreateByteField (TCGP, 0x06, MOR)
                    CreateByteField (TCGP, 0x07, TVEN)
                    OperationRegion (TCGC, SystemIO, 0x72, 0x02)
                    Field (TCGC, ByteAcc, Lock, Preserve)
                    {
                        TIDX,   8, 
                        TPDA,   8
                    }
                    IndexField (TIDX, TPDA, ByteAcc, Lock, Preserve)
                    {
                                Offset (0x40), 
                        TPP1,   8, 
                        PPLO,   8, 
                        TPP3,   8
                    }
                    OperationRegion (SMIP, SystemIO, 0xB2, 0x02)
                    Field (SMIP, WordAcc, NoLock, Preserve)
                    {
                        SMIT,   8, 
                        SMID,   8
                    }
                    OperationRegion (PCI0.LPCB.LPC1, PCI_Config, 0x40, 0xC0)
                    Field (PCI0.LPCB.LPC1, AnyAcc, NoLock, Preserve)
                    {
                                Offset (0x20), 
                        PARC,   8, 
                        PBRC,   8, 
                        PCRC,   8, 
                        PDRC,   8, 
                                Offset (0x28), 
                        PERC,   8, 
                        PFRC,   8, 
                        PGRC,   8, 
                        PHRC,   8
                    }
                    Device (LNKA)
                    {
                        Name (_HID, EisaId ("PNP0C0F"))
                        Name (_UID, One)
                        Method (_DIS, 0, Serialized)
                        {
                            Or (PARC, 0x80, PARC)
                        }
                        Method (_PRS, 0, Serialized)
                        {
                            Return (PRSA)
                        }
                        Method (_CRS, 0, Serialized)
                        {
                            Name (RTLA, ResourceTemplate ()
                            {
                                IRQ (Level, ActiveLow, Shared, )
                                    {}
                            })
                            CreateWordField (RTLA, One, IRQ0)
                            Store (Zero, IRQ0)
                            ShiftLeft (One, And (PARC, 0x0F), IRQ0)
                            Return (RTLA)
                        }
                        Method (_SRS, 1, Serialized)
                        {
                            CreateWordField (Arg0, One, IRQ0)
                            FindSetRightBit (IRQ0, Local0)
                            Decrement (Local0)
                            Store (Local0, PARC)
                        }
                        Method (_STA, 0, Serialized)
                        {
                            If (And (PARC, 0x80))
                            {
                                Return (0x09)
                            }
                            Else
                            {
                                Return (0x0B)
                            }
                        }
                    }
                    Device (LNKB)
                    {
                        Name (_HID, EisaId ("PNP0C0F"))
                        Name (_UID, 0x02)
                        Method (_DIS, 0, Serialized)
                        {
                            Or (PBRC, 0x80, PBRC)
                        }
                        Method (_PRS, 0, Serialized)
                        {
                            Return (PRSB)
                        }
                        Method (_CRS, 0, Serialized)
                        {
                            Name (RTLB, ResourceTemplate ()
                            {
                                IRQ (Level, ActiveLow, Shared, )
                                    {}
                            })
                            CreateWordField (RTLB, One, IRQ0)
                            Store (Zero, IRQ0)
                            ShiftLeft (One, And (PBRC, 0x0F), IRQ0)
                            Return (RTLB)
                        }
                        Method (_SRS, 1, Serialized)
                        {
                            CreateWordField (Arg0, One, IRQ0)
                            FindSetRightBit (IRQ0, Local0)
                            Decrement (Local0)
                            Store (Local0, PBRC)
                        }
                        Method (_STA, 0, Serialized)
                        {
                            If (And (PBRC, 0x80))
                            {
                                Return (0x09)
                            }
                            Else
                            {
                                Return (0x0B)
                            }
                        }
                    }
                    Device (LNKC)
                    {
                        Name (_HID, EisaId ("PNP0C0F"))
                        Name (_UID, 0x03)
                        Method (_DIS, 0, Serialized)
                        {
                            Or (PCRC, 0x80, PCRC)
                        }
                        Method (_PRS, 0, Serialized)
                        {
                            Return (PRSC)
                        }
                        Method (_CRS, 0, Serialized)
                        {
                            Name (RTLC, ResourceTemplate ()
                            {
                                IRQ (Level, ActiveLow, Shared, )
                                    {}
                            })
                            CreateWordField (RTLC, One, IRQ0)
                            Store (Zero, IRQ0)
                            ShiftLeft (One, And (PCRC, 0x0F), IRQ0)
                            Return (RTLC)
                        }
                        Method (_SRS, 1, Serialized)
                        {
                            CreateWordField (Arg0, One, IRQ0)
                            FindSetRightBit (IRQ0, Local0)
                            Decrement (Local0)
                            Store (Local0, PCRC)
                        }
                        Method (_STA, 0, Serialized)
                        {
                            If (And (PCRC, 0x80))
                            {
                                Return (0x09)
                            }
                            Else
                            {
                                Return (0x0B)
                            }
                        }
                    }
                    Device (LNKD)
                    {
                        Name (_HID, EisaId ("PNP0C0F"))
                        Name (_UID, 0x04)
                        Method (_DIS, 0, Serialized)
                        {
                            Or (PDRC, 0x80, PDRC)
                        }
                        Method (_PRS, 0, Serialized)
                        {
                            Return (PRSD)
                        }
                        Method (_CRS, 0, Serialized)
                        {
                            Name (RTLD, ResourceTemplate ()
                            {
                                IRQ (Level, ActiveLow, Shared, )
                                    {}
                            })
                            CreateWordField (RTLD, One, IRQ0)
                            Store (Zero, IRQ0)
                            ShiftLeft (One, And (PDRC, 0x0F), IRQ0)
                            Return (RTLD)
                        }
                        Method (_SRS, 1, Serialized)
                        {
                            CreateWordField (Arg0, One, IRQ0)
                            FindSetRightBit (IRQ0, Local0)
                            Decrement (Local0)
                            Store (Local0, PDRC)
                        }
                        Method (_STA, 0, Serialized)
                        {
                            If (And (PDRC, 0x80))
                            {
                                Return (0x09)
                            }
                            Else
                            {
                                Return (0x0B)
                            }
                        }
                    }
                    Device (LNKE)
                    {
                        Name (_HID, EisaId ("PNP0C0F"))
                        Name (_UID, 0x05)
                        Method (_DIS, 0, Serialized)
                        {
                            Or (PERC, 0x80, PERC)
                        }
                        Method (_PRS, 0, Serialized)
                        {
                            Return (PRSE)
                        }
                        Method (_CRS, 0, Serialized)
                        {
                            Name (RTLE, ResourceTemplate ()
                            {
                                IRQ (Level, ActiveLow, Shared, )
                                    {}
                            })
                            CreateWordField (RTLE, One, IRQ0)
                            Store (Zero, IRQ0)
                            ShiftLeft (One, And (PERC, 0x0F), IRQ0)
                            Return (RTLE)
                        }
                        Method (_SRS, 1, Serialized)
                        {
                            CreateWordField (Arg0, One, IRQ0)
                            FindSetRightBit (IRQ0, Local0)
                            Decrement (Local0)
                            Store (Local0, PERC)
                        }
                        Method (_STA, 0, Serialized)
                        {
                            If (And (PERC, 0x80))
                            {
                                Return (0x09)
                            }
                            Else
                            {
                                Return (0x0B)
                            }
                        }
                    }
                    Device (LNKF)
                    {
                        Name (_HID, EisaId ("PNP0C0F"))
                        Name (_UID, 0x06)
                        Method (_DIS, 0, Serialized)
                        {
                            Or (PFRC, 0x80, PFRC)
                        }
                        Method (_PRS, 0, Serialized)
                        {
                            Return (PRSF)
                        }
                        Method (_CRS, 0, Serialized)
                        {
                            Name (RTLF, ResourceTemplate ()
                            {
                                IRQ (Level, ActiveLow, Shared, )
                                    {}
                            })
                            CreateWordField (RTLF, One, IRQ0)
                            Store (Zero, IRQ0)
                            ShiftLeft (One, And (PFRC, 0x0F), IRQ0)
                            Return (RTLF)
                        }
                        Method (_SRS, 1, Serialized)
                        {
                            CreateWordField (Arg0, One, IRQ0)
                            FindSetRightBit (IRQ0, Local0)
                            Decrement (Local0)
                            Store (Local0, PFRC)
                        }
                        Method (_STA, 0, Serialized)
                        {
                            If (And (PFRC, 0x80))
                            {
                                Return (0x09)
                            }
                            Else
                            {
                                Return (0x0B)
                            }
                        }
                    }
                    Device (LNKG)
                    {
                        Name (_HID, EisaId ("PNP0C0F"))
                        Name (_UID, 0x07)
                        Method (_DIS, 0, Serialized)
                        {
                            Or (PGRC, 0x80, PGRC)
                        }
                        Method (_PRS, 0, Serialized)
                        {
                            Return (PRSG)
                        }
                        Method (_CRS, 0, Serialized)
                        {
                            Name (RTLG, ResourceTemplate ()
                            {
                                IRQ (Level, ActiveLow, Shared, )
                                    {}
                            })
                            CreateWordField (RTLG, One, IRQ0)
                            Store (Zero, IRQ0)
                            ShiftLeft (One, And (PGRC, 0x0F), IRQ0)
                            Return (RTLG)
                        }
                        Method (_SRS, 1, Serialized)
                        {
                            CreateWordField (Arg0, One, IRQ0)
                            FindSetRightBit (IRQ0, Local0)
                            Decrement (Local0)
                            Store (Local0, PGRC)
                        }
                        Method (_STA, 0, Serialized)
                        {
                            If (And (PGRC, 0x80))
                            {
                                Return (0x09)
                            }
                            Else
                            {
                                Return (0x0B)
                            }
                        }
                    }
                    Device (LNKH)
                    {
                        Name (_HID, EisaId ("PNP0C0F"))
                        Name (_UID, 0x08)
                        Method (_DIS, 0, Serialized)
                        {
                            Or (PHRC, 0x80, PHRC)
                        }
                        Method (_PRS, 0, Serialized)
                        {
                            Return (PRSH)
                        }
                        Method (_CRS, 0, Serialized)
                        {
                            Name (RTLH, ResourceTemplate ()
                            {
                                IRQ (Level, ActiveLow, Shared, )
                                    {}
                            })
                            CreateWordField (RTLH, One, IRQ0)
                            Store (Zero, IRQ0)
                            ShiftLeft (One, And (PHRC, 0x0F), IRQ0)
                            Return (RTLH)
                        }
                        Method (_SRS, 1, Serialized)
                        {
                            CreateWordField (Arg0, One, IRQ0)
                            FindSetRightBit (IRQ0, Local0)
                            Decrement (Local0)
                            Store (Local0, PHRC)
                        }
                        Method (_STA, 0, Serialized)
                        {
                            If (And (PHRC, 0x80))
                            {
                                Return (0x09)
                            }
                            Else
                            {
                                Return (0x0B)
                            }
                        }
                    }
                }
                OperationRegion (LPC0, PCI_Config, 0x40, 0xC0)
                Field (LPC0, AnyAcc, NoLock, Preserve)
                {
                            Offset (0x40), 
                    IOD0,   8, 
                    IOD1,   8, 
                            Offset (0xB0), 
                    RAEN,   1, 
                        ,   13, 
                    RCBA,   18
                }
                Device (DMAC)
                {
                    Name (_HID, EisaId ("PNP0200"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x20,               // Length
                            )
                        IO (Decode16,
                            0x0081,             // Range Minimum
                            0x0081,             // Range Maximum
                            0x01,               // Alignment
                            0x11,               // Length
                            )
                        IO (Decode16,
                            0x0093,             // Range Minimum
                            0x0093,             // Range Maximum
                            0x01,               // Alignment
                            0x0D,               // Length
                            )
                        IO (Decode16,
                            0x00C0,             // Range Minimum
                            0x00C0,             // Range Maximum
                            0x01,               // Alignment
                            0x20,               // Length
                            )
                        DMA (Compatibility, NotBusMaster, Transfer8_16, )
                            {4}
                    })
                }
                Device (FWHD)
                {
                    Name (_HID, EisaId ("INT0800"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0xFF000000,         // Address Base
                            0x01000000,         // Address Length
                            )
                    })
                }
                Device (HPET)
                {
                    Name (_HID, EisaId ("PNP0103"))
                    Name (_UID, Zero)
                    Name (BUF0, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadWrite,
                            0xFED00000,         // Address Base
                            0x00000400,         // Address Length
                            )
                    })
                    Method (_STA, 0, NotSerialized)
                    {
                        If (LGreaterEqual (OSYS, 0x07D1))
                        {
                            If (HPAE)
                            {
                                Return (0x0F)
                            }
                        }
                        Else
                        {
                            If (HPAE)
                            {
                                Return (0x0B)
                            }
                        }
                        Return (Zero)
                    }
                    Method (_CRS, 0, Serialized)
                    {
                        If (HPAE)
                        {
                            CreateDWordField (BUF0, 0x04, HPT0)
                            If (LEqual (HPAS, One))
                            {
                                Store (0xFED01000, HPT0)
                            }
                            If (LEqual (HPAS, 0x02))
                            {
                                Store (0xFED02000, HPT0)
                            }
                            If (LEqual (HPAS, 0x03))
                            {
                                Store (0xFED03000, HPT0)
                            }
                        }
                        Return (BUF0)
                    }
                }
                Device (IPIC)
                {
                    Name (_HID, EisaId ("PNP0000"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0020,             // Range Minimum
                            0x0020,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0024,             // Range Minimum
                            0x0024,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0028,             // Range Minimum
                            0x0028,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x002C,             // Range Minimum
                            0x002C,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0030,             // Range Minimum
                            0x0030,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0034,             // Range Minimum
                            0x0034,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0038,             // Range Minimum
                            0x0038,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x003C,             // Range Minimum
                            0x003C,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00A0,             // Range Minimum
                            0x00A0,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00A4,             // Range Minimum
                            0x00A4,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00A8,             // Range Minimum
                            0x00A8,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00AC,             // Range Minimum
                            0x00AC,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00B0,             // Range Minimum
                            0x00B0,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00B4,             // Range Minimum
                            0x00B4,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00B8,             // Range Minimum
                            0x00B8,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00BC,             // Range Minimum
                            0x00BC,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x04D0,             // Range Minimum
                            0x04D0,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IRQNoFlags ()
                            {2}
                    })
                }
                Device (MATH)
                {
                    Name (_HID, EisaId ("PNP0C04"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x00F0,             // Range Minimum
                            0x00F0,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {13}
                    })
                }
                Device (LDRC)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x02)
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x002E,             // Range Minimum
                            0x002E,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x004E,             // Range Minimum
                            0x004E,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0061,             // Range Minimum
                            0x0061,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0063,             // Range Minimum
                            0x0063,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0065,             // Range Minimum
                            0x0065,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0067,             // Range Minimum
                            0x0067,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0070,             // Range Minimum
                            0x0070,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0080,             // Range Minimum
                            0x0080,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0092,             // Range Minimum
                            0x0092,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x00B2,             // Range Minimum
                            0x00B2,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0680,             // Range Minimum
                            0x0680,             // Range Maximum
                            0x01,               // Alignment
                            0x20,               // Length
                            )
                        IO (Decode16,
                            0x1000,             // Range Minimum
                            0x1000,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IO (Decode16,
                            0x1004,             // Range Minimum
                            0x1004,             // Range Maximum
                            0x01,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0xFFFF,             // Range Minimum
                            0xFFFF,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0400,             // Range Minimum
                            0x0400,             // Range Maximum
                            0x01,               // Alignment
                            0x54,               // Length
                            )
                        IO (Decode16,
                            0x0458,             // Range Minimum
                            0x0458,             // Range Maximum
                            0x01,               // Alignment
                            0x28,               // Length
                            )
                        IO (Decode16,
                            0x0500,             // Range Minimum
                            0x0500,             // Range Maximum
                            0x01,               // Alignment
                            0x80,               // Length
                            )
                        IO (Decode16,
                            0x1600,             // Range Minimum
                            0x1600,             // Range Maximum
                            0x01,               // Alignment
                            0xFF,               // Length
                            )
                        IO (Decode16,
                            0xFE00,             // Range Minimum
                            0xFE00,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0068,             // Range Minimum
                            0x0068,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x006C,             // Range Minimum
                            0x006C,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0700,             // Range Minimum
                            0x0700,             // Range Maximum
                            0x01,               // Alignment
                            0x10,               // Length
                            )
                    })
                }
                Device (RTC)
                {
                    Name (_HID, EisaId ("PNP0B00"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0070,             // Range Minimum
                            0x0070,             // Range Maximum
                            0x01,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {8}
                    })
                }
                Device (TIMR)
                {
                    Name (_HID, EisaId ("PNP0100"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0040,             // Range Minimum
                            0x0040,             // Range Maximum
                            0x01,               // Alignment
                            0x04,               // Length
                            )
                        IO (Decode16,
                            0x0050,             // Range Minimum
                            0x0050,             // Range Maximum
                            0x10,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {0}
                    })
                }
                Device (CWDT)
                {
                    Name (_HID, EisaId ("INT3F0D"))
                    Name (_CID, EisaId ("PNP0C02"))
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0454,             // Range Minimum
                            0x0454,             // Range Maximum
                            0x04,               // Alignment
                            0x04,               // Length
                            )
                    })
                    Method (_STA, 0, Serialized)
                    {
                        If (LEqual (WDTE, One))
                        {
                            Return (0x0F)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }
                    Method (_CRS, 0, Serialized)
                    {
                        Return (BUF0)
                    }
                }
                OperationRegion (PKBS, SystemIO, 0x60, 0x05)
                Field (PKBS, ByteAcc, Lock, Preserve)
                {
                    PKBD,   8, 
                            Offset (0x02), 
                            Offset (0x03), 
                            Offset (0x04), 
                    PKBC,   8
                }
                Device (PS2K)
                {
                    Name (_HID, EisaId ("PNP0303"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {1}
                    })
                    Name (_PRS, ResourceTemplate ()
                    {
                        StartDependentFn (0x00, 0x00)
                        {
                            FixedIO (
                                0x0060,             // Address
                                0x01,               // Length
                                )
                            FixedIO (
                                0x0064,             // Address
                                0x01,               // Length
                                )
                            IRQNoFlags ()
                                {1}
                        }
                        EndDependentFn ()
                    })
                }
                Device (PS2M)
                {
                    Name (_HID, EisaId ("LEN0026"))
                    Name (_CID, EisaId ("PNP0F13"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {12}
                    })
                    Name (_PRS, ResourceTemplate ()
                    {
                        StartDependentFn (0x00, 0x00)
                        {
                            IRQNoFlags ()
                                {12}
                        }
                        EndDependentFn ()
                    })
                    Method (MHID, 0, NotSerialized)
                    {
                        Store (0x1700AE30, _HID)
                    }
                }
            }
        }
    }
    Scope (_PR)
    {
        Processor (CPU0, 0x01, 0x00000410, 0x06)
        {
        }
        Processor (CPU1, 0x02, 0x00000410, 0x06)
        {
        }
        Processor (CPU2, 0x03, 0x00000410, 0x06)
        {
        }
        Processor (CPU3, 0x04, 0x00000410, 0x06)
        {
        }
        Processor (CPU4, 0x05, 0x00000410, 0x06)
        {
        }
        Processor (CPU5, 0x06, 0x00000410, 0x06)
        {
        }
        Processor (CPU6, 0x07, 0x00000410, 0x06)
        {
        }
        Processor (CPU7, 0x08, 0x00000410, 0x06)
        {
        }
    }
    Scope (\)
    {
        Method (PNTF, 1, NotSerialized)
        {
            If (And (PPMF, 0x01000000))
            {
                If (LOr (LAnd (And (PDC0, 0x08), LOr (LEqual (Arg0, 
                    0x80), LEqual (Arg0, 0x82))), LAnd (And (PDC0, 0x10), LEqual (Arg0, 
                    0x81))))
                {
                    Notify (\_PR.CPU0, Arg0)
                }
                If (LOr (LAnd (And (PDC1, 0x08), LOr (LEqual (Arg0, 
                    0x80), LEqual (Arg0, 0x82))), LAnd (And (PDC1, 0x10), LEqual (Arg0, 
                    0x81))))
                {
                    Notify (\_PR.CPU1, Arg0)
                }
                If (LOr (LAnd (And (PDC2, 0x08), LOr (LEqual (Arg0, 
                    0x80), LEqual (Arg0, 0x82))), LAnd (And (PDC2, 0x10), LEqual (Arg0, 
                    0x81))))
                {
                    Notify (\_PR.CPU2, Arg0)
                }
                If (LOr (LAnd (And (PDC3, 0x08), LOr (LEqual (Arg0, 
                    0x80), LEqual (Arg0, 0x82))), LAnd (And (PDC3, 0x10), LEqual (Arg0, 
                    0x81))))
                {
                    Notify (\_PR.CPU3, Arg0)
                }
                If (LOr (LAnd (And (PDC4, 0x08), LOr (LEqual (Arg0, 
                    0x80), LEqual (Arg0, 0x82))), LAnd (And (PDC4, 0x10), LEqual (Arg0, 
                    0x81))))
                {
                    Notify (\_PR.CPU4, Arg0)
                }
                If (LOr (LAnd (And (PDC5, 0x08), LOr (LEqual (Arg0, 
                    0x80), LEqual (Arg0, 0x82))), LAnd (And (PDC5, 0x10), LEqual (Arg0, 
                    0x81))))
                {
                    Notify (\_PR.CPU5, Arg0)
                }
                If (LOr (LAnd (And (PDC6, 0x08), LOr (LEqual (Arg0, 
                    0x80), LEqual (Arg0, 0x82))), LAnd (And (PDC6, 0x10), LEqual (Arg0, 
                    0x81))))
                {
                    Notify (\_PR.CPU6, Arg0)
                }
                If (LOr (LAnd (And (PDC7, 0x08), LOr (LEqual (Arg0, 
                    0x80), LEqual (Arg0, 0x82))), LAnd (And (PDC7, 0x10), LEqual (Arg0, 
                    0x81))))
                {
                    Notify (\_PR.CPU7, Arg0)
                }
            }
            Else
            {
                If (LOr (LEqual (Arg0, 0x80), LOr (LEqual (Arg0, 0x81), LEqual (
                    Arg0, 0x82))))
                {
                    Notify (\_PR.CPU0, Arg0)
                    Notify (\_PR.CPU1, Arg0)
                    Notify (\_PR.CPU2, Arg0)
                    Notify (\_PR.CPU3, Arg0)
                    Notify (\_PR.CPU4, Arg0)
                    Notify (\_PR.CPU5, Arg0)
                    Notify (\_PR.CPU6, Arg0)
                    Notify (\_PR.CPU7, Arg0)
                }
            }
        }
    }
    Mutex (MUTX, 0x00)
    OperationRegion (PRT0, SystemIO, 0x80, 0x04)
    Field (PRT0, DWordAcc, Lock, Preserve)
    {
        P80H,   32
    }
    Method (P8XH, 2, Serialized)
    {
        If (LEqual (Arg0, Zero))
        {
            Store (Or (And (P80D, 0xFFFFFF00), Arg1), P80D)
        }
        If (LEqual (Arg0, One))
        {
            Store (Or (And (P80D, 0xFFFF00FF), ShiftLeft (Arg1, 0x08)
                ), P80D)
        }
        If (LEqual (Arg0, 0x02))
        {
            Store (Or (And (P80D, 0xFF00FFFF), ShiftLeft (Arg1, 0x10)
                ), P80D)
        }
        If (LEqual (Arg0, 0x03))
        {
            Store (Or (And (P80D, 0x00FFFFFF), ShiftLeft (Arg1, 0x18)
                ), P80D)
        }
        Store (P80D, P80H)
    }
    OperationRegion (SPRT, SystemIO, 0xB2, 0x02)
    Field (SPRT, ByteAcc, Lock, Preserve)
    {
        SSMP,   8
    }
    Method (_PIC, 1, NotSerialized)
    {
        Store (Arg0, GPIC)
        Store (Arg0, PICM)
    }
    Method (_PTS, 1, NotSerialized)
    {
        Store (Zero, P80D)
        P8XH (Zero, Arg0)
        If (LEqual (Arg0, 0x03))
        {
            If (LAnd (DTSE, LGreater (TCNT, One)))
            {
                TRAP (TRTD, 0x1E)
            }
        }
        If (LOr (LEqual (Arg0, 0x03), LEqual (Arg0, 0x04)))
        {
            \_SB.PCI0.LPCB.EC.BEEP (0x03)
            Store (One, \_SB.PCI0.LPCB.EC.S3FG)
            Store (DerefOf (Index (\_SB.PCI0.PNLS, BRNS)), \_SB.PCI0.GFX0.BCLP)
            Or (\_SB.PCI0.GFX0.BCLP, 0x80000000, \_SB.PCI0.GFX0.BCLP)
        }
    }
    Method (_WAK, 1, Serialized)
    {
        P8XH (Zero, 0xAB)
        If (LEqual (Arg0, 0x03))
        {
            \_SB.PCI0.LPCB.EC.HKEY.HKS3 ()
        }
        If (NEXP)
        {
            If (And (OSCC, 0x02))
            {
                \_SB.PCI0.NHPG ()
            }
            If (And (OSCC, 0x04))
            {
                \_SB.PCI0.NPME ()
            }
        }
        Store (Zero, LIDX)
        If (IGDS)
        {
            If (LEqual (\_SB.PCI0.LPCB.EC.HPLD, One))
            {
                Store (One, LIDS)
                Store (One, \_SB.PCI0.GFX0.CLID)
            }
            Else
            {
                Store (Zero, LIDS)
                Store (Zero, \_SB.PCI0.GFX0.CLID)
            }
        }
        If (LOr (LEqual (Arg0, 0x03), LEqual (Arg0, 0x04)))
        {
            If (LAnd (DTSE, LGreater (TCNT, One)))
            {
                TRAP (TRTD, 0x14)
                Sleep (0x64)
            }
            Store (One, \_SB.PCI0.LPCB.EC.DELY)
            \_SB.PCI0.LPCB.EC.BEEP (0x03)
            If (LEqual (OSYS, 0x07D2))
            {
                If (And (CFGD, One))
                {
                    If (LGreater (\_PR.CPU0._PPC, Zero))
                    {
                        Subtract (\_PR.CPU0._PPC, One, \_PR.CPU0._PPC)
                        PNOT ()
                        Add (\_PR.CPU0._PPC, One, \_PR.CPU0._PPC)
                        PNOT ()
                    }
                    Else
                    {
                        Add (\_PR.CPU0._PPC, One, \_PR.CPU0._PPC)
                        PNOT ()
                        Subtract (\_PR.CPU0._PPC, One, \_PR.CPU0._PPC)
                        PNOT ()
                    }
                }
            }
            If (LEqual (RP1D, Zero))
            {
                Notify (\_SB.PCI0.RP01, Zero)
            }
            If (LEqual (RP2D, Zero))
            {
                Notify (\_SB.PCI0.RP02, Zero)
            }
            If (LEqual (RP3D, Zero))
            {
                Notify (\_SB.PCI0.RP03, Zero)
            }
            If (LEqual (RP4D, Zero))
            {
                Notify (\_SB.PCI0.RP04, Zero)
            }
            If (LEqual (RP5D, Zero))
            {
                Notify (\_SB.PCI0.RP05, Zero)
            }
            If (LEqual (RP6D, Zero))
            {
                Notify (\_SB.PCI0.RP06, Zero)
            }
            If (LEqual (RP7D, Zero))
            {
                Notify (\_SB.PCI0.RP07, Zero)
            }
            If (LEqual (RP8D, Zero))
            {
                Notify (\_SB.PCI0.RP08, Zero)
            }
            WGSV (Zero)
        }
        Store (One, \_SB.BASC)
        If (LLess (Arg0, 0x04))
        {
            If (LAnd (LEqual (And (\_SB.PCI0.LPCB.EC.HB0S, 0x0F, Local1), Zero), LNot (\_SB.PCI0.LPCB.EC.ACPW)))
            {
                Store (0x0A, \_SB.PCI0.LPCB.EC.ETHB)
            }
        }
        If (LEqual (Arg0, 0x04))
        {
            Store (0x0A, \_SB.PCI0.LPCB.EC.ETHB)
        }
        Return (Package (0x02)
        {
            Zero, 
            Zero
        })
    }
    Method (GETB, 3, Serialized)
    {
        Multiply (Arg0, 0x08, Local0)
        Multiply (Arg1, 0x08, Local1)
        CreateField (Arg2, Local0, Local1, TBF3)
        Return (TBF3)
    }
    Method (PNOT, 0, NotSerialized)
    {
        If (LGreater (TCNT, One))
        {
            If (And (PDC0, 0x08))
            {
                Notify (\_PR.CPU0, 0x80)
                If (And (PDC0, 0x10))
                {
                    Sleep (0x64)
                    Notify (\_PR.CPU0, 0x81)
                }
            }
            If (And (PDC1, 0x08))
            {
                Notify (\_PR.CPU1, 0x80)
                If (And (PDC1, 0x10))
                {
                    Sleep (0x64)
                    Notify (\_PR.CPU1, 0x81)
                }
            }
            If (And (PDC2, 0x08))
            {
                Notify (\_PR.CPU2, 0x80)
                If (And (PDC2, 0x10))
                {
                    Sleep (0x64)
                    Notify (\_PR.CPU2, 0x81)
                }
            }
            If (And (PDC3, 0x08))
            {
                Notify (\_PR.CPU3, 0x80)
                If (And (PDC3, 0x10))
                {
                    Sleep (0x64)
                    Notify (\_PR.CPU3, 0x81)
                }
            }
            If (And (PDC4, 0x08))
            {
                Notify (\_PR.CPU4, 0x80)
                If (And (PDC4, 0x10))
                {
                    Sleep (0x64)
                    Notify (\_PR.CPU4, 0x81)
                }
            }
            If (And (PDC5, 0x08))
            {
                Notify (\_PR.CPU5, 0x80)
                If (And (PDC5, 0x10))
                {
                    Sleep (0x64)
                    Notify (\_PR.CPU5, 0x81)
                }
            }
            If (And (PDC6, 0x08))
            {
                Notify (\_PR.CPU6, 0x80)
                If (And (PDC6, 0x10))
                {
                    Sleep (0x64)
                    Notify (\_PR.CPU6, 0x81)
                }
            }
            If (And (PDC7, 0x08))
            {
                Notify (\_PR.CPU7, 0x80)
                If (And (PDC7, 0x10))
                {
                    Sleep (0x64)
                    Notify (\_PR.CPU7, 0x81)
                }
            }
        }
        Else
        {
            Notify (\_PR.CPU0, 0x80)
            Sleep (0x64)
            Notify (\_PR.CPU0, 0x81)
        }
    }
    Method (TRAP, 2, Serialized)
    {
        Store (Arg1, SMIF)
        If (LEqual (Arg0, TRTP))
        {
            Store (Zero, TRP0)
        }
        If (LEqual (Arg0, TRTD))
        {
            Store (Arg1, DTSF)
            Store (Zero, TRPD)
            Return (DTSF)
        }
        If (LEqual (Arg0, TRTI))
        {
            Store (Zero, TRPH)
        }
        Return (SMIF)
    }
    Scope (_SB.PCI0)
    {
        Name (EBRL, 0x64)
        Name (EBRV, Zero)
        Name (IBCL, Package (0x12)
        {
            0x64, 
            0x23, 
            0x14, 
            0x19, 
            0x1E, 
            0x23, 
            0x28, 
            0x2D, 
            0x32, 
            0x37, 
            0x3C, 
            0x41, 
            0x46, 
            0x4B, 
            0x50, 
            0x55, 
            0x5A, 
            0x64
        })
        Method (IBCM, 1, NotSerialized)
        {
            Store (Arg0, EBRL)
            If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x02)), One
                )))
            {
                Store (Zero, BRNS)
            }
            Else
            {
                If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x03)), One
                    )))
                {
                    Store (One, BRNS)
                }
                Else
                {
                    If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x04)), One
                        )))
                    {
                        Store (0x02, BRNS)
                    }
                    Else
                    {
                        If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x05)), One
                            )))
                        {
                            Store (0x03, BRNS)
                        }
                        Else
                        {
                            If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x06)), One
                                )))
                            {
                                Store (0x04, BRNS)
                            }
                            Else
                            {
                                If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x07)), One
                                    )))
                                {
                                    Store (0x05, BRNS)
                                }
                                Else
                                {
                                    If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x08)), One
                                        )))
                                    {
                                        Store (0x06, BRNS)
                                    }
                                    Else
                                    {
                                        If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x09)), One
                                            )))
                                        {
                                            Store (0x07, BRNS)
                                        }
                                        Else
                                        {
                                            If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x0A)), One
                                                )))
                                            {
                                                Store (0x08, BRNS)
                                            }
                                            Else
                                            {
                                                If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x0B)), One
                                                    )))
                                                {
                                                    Store (0x09, BRNS)
                                                }
                                                Else
                                                {
                                                    If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x0C)), One
                                                        )))
                                                    {
                                                        Store (0x0A, BRNS)
                                                    }
                                                    Else
                                                    {
                                                        If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x0D)), One
                                                            )))
                                                        {
                                                            Store (0x0B, BRNS)
                                                        }
                                                        Else
                                                        {
                                                            If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x0E)), One
                                                                )))
                                                            {
                                                                Store (0x0C, BRNS)
                                                            }
                                                            Else
                                                            {
                                                                If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x0F)), One
                                                                    )))
                                                                {
                                                                    Store (0x0D, BRNS)
                                                                }
                                                                Else
                                                                {
                                                                    If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x10)), One
                                                                        )))
                                                                    {
                                                                        Store (0x0E, BRNS)
                                                                    }
                                                                    Else
                                                                    {
                                                                        If (LLess (EBRL, Add (DerefOf (Index (IBCL, 0x11)), One
                                                                            )))
                                                                        {
                                                                            Store (0x0F, BRNS)
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            If (LGreaterEqual (OSYS, 0x07D6))
            {
                UCMS (0x14)
            }
            If (IGDS)
            {
                UCMS (0x06)
                Store (DerefOf (Index (PNLS, BRNS)), BRTL)
                ISBC (DerefOf (Index (PNLS, BRNS)))
                Store (One, ^GFX0.ASLE)
            }
            Else
            {
                If (LNotEqual (EBRV, BRNS))
                {
                    UCMS (0x06)
                }
            }
            Store (BRNS, EBRV)
        }
        Name (ISCT, Zero)
        Method (ISBC, 1, NotSerialized)
        {
            ^GFX0.PARD ()
            Store (Arg0, ^GFX0.BCLP)
            Or (^GFX0.BCLP, 0x80000000, ^GFX0.BCLP)
            Store (0x02, ^GFX0.ASLC)
            Store (0x05, ISCT)
            While (LAnd (^GFX0.ASLC, ISCT))
            {
                Store (Zero, ^GFX0.LBPC)
                Decrement (ISCT)
            }
        }
        Name (PNLS, Buffer (0x10)
        {
            /* 0000 */    0x04, 0x08, 0x0D, 0x12, 0x16, 0x1D, 0x24, 0x2C, 
            /* 0008 */    0x35, 0x3F, 0x4E, 0x62, 0x7E, 0x9E, 0xC8, 0xFF
        })
        Name (BRTB, Package (0x03)
        {
            Package (0x10)
            {
                0x04, 
                0x08, 
                0x0D, 
                0x12, 
                0x16, 
                0x1D, 
                0x24, 
                0x2C, 
                0x35, 
                0x3F, 
                0x4E, 
                0x62, 
                0x7E, 
                0x9E, 
                0xC8, 
                0xFF
            }, 
            Package (0x10)
            {
                0x04, 
                0x08, 
                0x0D, 
                0x12, 
                0x16, 
                0x1D, 
                0x24, 
                0x2C, 
                0x35, 
                0x3F, 
                0x4E, 
                0x62, 
                0x7E, 
                0x9E, 
                0xC8, 
                0xFF
            }, 
            Package (0x05)
            {
                0x01F4, 
                0x01F4, 
                Zero, 
                Zero, 
                Zero
            }
        })
        Method (_INI, 0, NotSerialized)
        {
            Store (One, IGDS)
            Store (0x07D0, OSYS)
            If (CondRefOf (_OSI, Local0))
            {
                If (_OSI ("Linux"))
                {
                    Store (0x03E8, OSYS)
                }
                If (_OSI ("Windows 2001"))
                {
                    Store (0x07D1, OSYS)
                }
                If (_OSI ("Windows 2001 SP1"))
                {
                    Store (0x07D1, OSYS)
                }
                If (_OSI ("Windows 2001 SP2"))
                {
                    Store (0x07D2, OSYS)
                }
                If (_OSI ("Windows 2001.1"))
                {
                    Store (0x07D3, OSYS)
                }
                If (_OSI ("Windows 2006"))
                {
                    Store (0x07D6, OSYS)
                }
                If (_OSI ("Windows 2009"))
                {
                    Store (0x07D9, OSYS)
                }
                If (LEqual (OSYS, 0x07D9))
                {
                    If (SWDT)
                    {
                        If (LNotEqual (SGMD, 0x02))
                        {
                            VHYB (0x02)
                        }
                    }
                }
                Else
                {
                    If (SWDT)
                    {
                        If (LNotEqual (SGMD, Zero))
                        {
                            VHYB (Zero)
                        }
                    }
                }
            }
        }
        Method (NHPG, 0, Serialized)
        {
            Store (Zero, ^RP01.HPEX)
            Store (Zero, ^RP02.HPEX)
            Store (Zero, ^RP03.HPEX)
            Store (Zero, ^RP04.HPEX)
            Store (One, ^RP01.HPSX)
            Store (One, ^RP02.HPSX)
            Store (One, ^RP03.HPSX)
            Store (One, ^RP04.HPSX)
        }
        Method (NPME, 0, Serialized)
        {
            Store (Zero, ^RP01.PMEX)
            Store (Zero, ^RP02.PMEX)
            Store (Zero, ^RP03.PMEX)
            Store (Zero, ^RP04.PMEX)
            Store (Zero, ^RP05.PMEX)
            Store (Zero, ^RP06.PMEX)
            Store (Zero, ^RP07.PMEX)
            Store (Zero, ^RP08.PMEX)
            Store (One, ^RP01.PMSX)
            Store (One, ^RP02.PMSX)
            Store (One, ^RP03.PMSX)
            Store (One, ^RP04.PMSX)
            Store (One, ^RP05.PMSX)
            Store (One, ^RP06.PMSX)
            Store (One, ^RP07.PMSX)
            Store (One, ^RP08.PMSX)
        }
    }
    Scope (\)
    {
        Name (PICM, Zero)
        Name (PRWP, Package (0x02)
        {
            Zero, 
            Zero
        })
        Method (GPRW, 2, NotSerialized)
        {
            Store (Arg0, Index (PRWP, Zero))
            Store (ShiftLeft (SS1, One), Local0)
            Or (Local0, ShiftLeft (SS2, 0x02), Local0)
            Or (Local0, ShiftLeft (SS3, 0x03), Local0)
            Or (Local0, ShiftLeft (SS4, 0x04), Local0)
            If (And (ShiftLeft (One, Arg1), Local0))
            {
                Store (Arg1, Index (PRWP, One))
            }
            Else
            {
                ShiftRight (Local0, One, Local0)
                FindSetLeftBit (Local0, Index (PRWP, One))
            }
            Return (PRWP)
        }
    }
    OperationRegion (SMI2, SystemIO, 0xB2, One)
    Field (SMI2, ByteAcc, NoLock, Preserve)
    {
        APMC,   8
    }
    Mutex (MSMI, 0x07)
    Method (SMI, 5, NotSerialized)
    {
        Acquire (MSMI, 0xFFFF)
        Store (Arg0, CMD)
        Store (Arg1, PAR0)
        Store (Arg2, PAR1)
        Store (Arg3, PAR2)
        Store (Arg4, PAR3)
        Store (0xF5, APMC)
        While (LEqual (ERR, One))
        {
            Sleep (0x64)
            Store (0xF5, APMC)
        }
        Store (PAR0, Local0)
        Release (MSMI)
        Return (Local0)
    }
    Method (RBEC, 1, NotSerialized)
    {
        Return (SMI (Zero, 0x03, Arg0, Zero, Zero))
    }
    Method (WBEC, 2, NotSerialized)
    {
        SMI (Zero, 0x04, Arg0, Arg1, Zero)
    }
    Method (MBEC, 3, NotSerialized)
    {
        SMI (Zero, 0x05, Arg0, Arg1, Arg2)
    }
    Method (WISA, 2, NotSerialized)
    {
        SMI (Zero, 0x07, Arg0, Arg1, Zero)
    }
    Method (MISA, 3, NotSerialized)
    {
        SMI (Zero, 0x08, Arg0, Arg1, Arg2)
    }
    Method (VUPS, 1, NotSerialized)
    {
        SMI (One, One, Arg0, Zero, Zero)
    }
    Method (VEVT, 1, NotSerialized)
    {
        Return (SMI (One, 0x08, Arg0, Zero, Zero))
    }
    Method (VBRC, 1, NotSerialized)
    {
        SMI (One, 0x0A, Arg0, Zero, Zero)
    }
    Method (VBRD, 0, NotSerialized)
    {
        SMI (One, 0x0B, Zero, Zero, Zero)
    }
    Method (VBRU, 0, NotSerialized)
    {
        SMI (One, 0x0C, Zero, Zero, Zero)
    }
    Method (VBRS, 1, NotSerialized)
    {
        SMI (One, 0x0D, Arg0, Zero, Zero)
    }
    Method (VBRG, 0, NotSerialized)
    {
        Return (SMI (One, 0x0E, Zero, Zero, Zero))
    }
    Method (VHYB, 1, NotSerialized)
    {
        Return (SMI (One, 0x10, Arg0, Zero, Zero))
    }
    Method (VDYN, 2, NotSerialized)
    {
        Return (SMI (One, 0x11, Arg0, Arg1, Zero))
    }
    Method (UCMS, 1, NotSerialized)
    {
        Return (SMI (0x02, Arg0, Zero, Zero, Zero))
    }
    Method (BCHK, 0, NotSerialized)
    {
        Return (SMI (0x05, 0x04, Zero, Zero, Zero))
    }
    Method (BLTH, 1, NotSerialized)
    {
        Return (SMI (0x06, Arg0, Zero, Zero, Zero))
    }
    Method (PRSM, 2, NotSerialized)
    {
        Return (SMI (0x07, Zero, Arg0, Arg1, Zero))
    }
    Method (WGSV, 1, NotSerialized)
    {
        Return (SMI (0x09, Arg0, Zero, Zero, Zero))
    }
    Method (TPHY, 1, NotSerialized)
    {
        SMI (0x0C, Arg0, Zero, Zero, Zero)
    }
    Method (TMOR, 1, NotSerialized)
    {
        SMI (0x0D, Arg0, Zero, Zero, Zero)
    }
    Method (THRO, 1, NotSerialized)
    {
        Return (SMI (0x0E, Arg0, Zero, Zero, Zero))
    }
    Method (WMIS, 2, NotSerialized)
    {
        Return (SMI (0x10, Arg0, Arg1, Zero, Zero))
    }
    Method (OSSV, 1, NotSerialized)
    {
        Return (SMI (0x12, Arg0, Zero, Zero, Zero))
    }
    Method (UAWS, 1, NotSerialized)
    {
        Return (SMI (0x13, Arg0, Zero, Zero, Zero))
    }
    Method (BFWC, 1, NotSerialized)
    {
        Return (SMI (0x14, Zero, Arg0, Zero, Zero))
    }
    Method (BFWP, 0, NotSerialized)
    {
        Return (SMI (0x14, One, Zero, Zero, Zero))
    }
    Method (BFWG, 1, NotSerialized)
    {
        SMI (0x14, 0x03, Arg0, Zero, Zero)
    }
    Method (BDMC, 1, NotSerialized)
    {
        SMI (0x14, 0x04, Arg0, Zero, Zero)
    }
    Method (PSIF, 2, NotSerialized)
    {
        Return (SMI (0x14, 0x05, Arg0, Arg1, Zero))
    }
    Method (FNSC, 2, NotSerialized)
    {
        Return (SMI (0x14, 0x06, Arg0, Arg1, Zero))
    }
    Method (AUDC, 2, NotSerialized)
    {
        Return (SMI (0x14, 0x07, Arg0, Arg1, Zero))
    }
    Method (SYBC, 2, NotSerialized)
    {
        Return (SMI (0x14, 0x08, Arg0, Arg1, Zero))
    }
    Method (CBIF, 2, NotSerialized)
    {
        Return (SMI (0x14, 0x0F, Arg0, Arg1, Zero))
    }
    Method (BFUD, 0, NotSerialized)
    {
        Return (SMI (0x14, 0x10, Zero, Zero, Zero))
    }
    Scope (_TZ)
    {
        Name (TPAS, 0x5F)
        Name (TPC, 0x64)
        Name (T90S, 0x53)
        Name (T90C, 0x55)
        ThermalZone (TZ00)
        {
            Method (_CRT, 0, Serialized)
            {
                If (LEqual (TJ90, 0x55))
                {
                    Return (Add (0x0AAC, Multiply (T90C, 0x0A)))
                }
                Else
                {
                    Return (Add (0x0AAC, Multiply (TPC, 0x0A)))
                }
            }
            Method (_SCP, 1, Serialized)
            {
                Store (Arg0, CTYP)
            }
            Method (_TMP, 0, Serialized)
            {
                If (ECON)
                {
                    If (DTSE)
                    {
                        If (LGreaterEqual (DTS1, DTS2))
                        {
                            Store (DTS1, Local1)
                        }
                        Else
                        {
                            Store (DTS2, Local1)
                        }
                        If (LNotEqual (\_SB.PCI0.LPCB.EC.TMP2, Zero))
                        {
                            If (LGreaterEqual (Local1, \_SB.PCI0.LPCB.EC.TMP2))
                            {
                                Subtract (Local1, \_SB.PCI0.LPCB.EC.TMP2, Local7)
                            }
                            Else
                            {
                                Store (Zero, Local7)
                                Store (\_SB.PCI0.LPCB.EC.TMP2, Local1)
                            }
                            Store (Local7, \_SB.PCI0.LPCB.EC.TMP3)
                        }
                        If (LGreater (Local1, \_SB.PCI0.LPCB.EC.TMP1))
                        {
                            Store (Local1, Local0)
                        }
                        Else
                        {
                            Store (\_SB.PCI0.LPCB.EC.TMP1, Local0)
                        }
                        If (Or (LLess (Local0, 0x23), LGreater (Local0, 0x73)))
                        {
                            Store (0x23, Local0)
                        }
                    }
                    Else
                    {
                        If (LGreater (\_SB.PCI0.LPCB.EC.TMP2, \_SB.PCI0.LPCB.EC.TMP1))
                        {
                            Store (\_SB.PCI0.LPCB.EC.TMP2, Local0)
                        }
                        Else
                        {
                            Store (\_SB.PCI0.LPCB.EC.TMP1, Local0)
                        }
                        If (Or (LLess (Local0, 0x23), LGreater (Local0, 0x73)))
                        {
                            Store (0x23, Local0)
                        }
                    }
                    Return (Add (0x0AAC, Multiply (Local0, 0x0A)))
                }
                Else
                {
                    Return (0x0BB8)
                }
            }
            Method (_PSL, 0, Serialized)
            {
                If (LEqual (TCNT, 0x08))
                {
                    Return (Package (0x08)
                    {
                        \_PR.CPU0, 
                        \_PR.CPU1, 
                        \_PR.CPU2, 
                        \_PR.CPU3, 
                        \_PR.CPU4, 
                        \_PR.CPU5, 
                        \_PR.CPU6, 
                        \_PR.CPU7
                    })
                }
                If (LEqual (TCNT, 0x04))
                {
                    Return (Package (0x04)
                    {
                        \_PR.CPU0, 
                        \_PR.CPU1, 
                        \_PR.CPU2, 
                        \_PR.CPU3
                    })
                }
                If (LEqual (TCNT, 0x02))
                {
                    Return (Package (0x02)
                    {
                        \_PR.CPU0, 
                        \_PR.CPU1
                    })
                }
                Return (Package (0x01)
                {
                    \_PR.CPU0
                })
            }
            Method (_PSV, 0, Serialized)
            {
                If (LEqual (TJ90, 0x55))
                {
                    Return (Add (0x0AAC, Multiply (T90S, 0x0A)))
                }
                Else
                {
                    Return (Add (0x0AAC, Multiply (TPAS, 0x0A)))
                }
            }
            Method (_TC1, 0, Serialized)
            {
                Return (0x02)
            }
            Method (_TC2, 0, Serialized)
            {
                Return (0x03)
            }
            Method (_TSP, 0, Serialized)
            {
                Return (0x64)
            }
        }
    }
    Scope (_SB.PCI0)
    {
        Device (PDRC)
        {
            Name (_HID, EisaId ("PNP0C02"))
            Name (_UID, One)
            Name (BUF0, ResourceTemplate ()
            {
                Memory32Fixed (ReadWrite,
                    0x00000000,         // Address Base
                    0x00004000,         // Address Length
                    )
                Memory32Fixed (ReadWrite,
                    0x00000000,         // Address Base
                    0x00008000,         // Address Length
                    )
                Memory32Fixed (ReadWrite,
                    0x00000000,         // Address Base
                    0x00001000,         // Address Length
                    )
                Memory32Fixed (ReadWrite,
                    0x00000000,         // Address Base
                    0x00001000,         // Address Length
                    )
                Memory32Fixed (ReadWrite,
                    0x00000000,         // Address Base
                    0x00000000,         // Address Length
                    )
                Memory32Fixed (ReadWrite,
                    0xFED20000,         // Address Base
                    0x00020000,         // Address Length
                    )
                Memory32Fixed (ReadOnly,
                    0xFED90000,         // Address Base
                    0x00004000,         // Address Length
                    )
                Memory32Fixed (ReadWrite,
                    0xFED45000,         // Address Base
                    0x0004B000,         // Address Length
                    )
                Memory32Fixed (ReadOnly,
                    0xFF000000,         // Address Base
                    0x01000000,         // Address Length
                    )
                Memory32Fixed (ReadOnly,
                    0xFEE00000,         // Address Base
                    0x00100000,         // Address Length
                    )
                Memory32Fixed (ReadWrite,
                    0x00000000,         // Address Base
                    0x00001000,         // Address Length
                    )
            })
            Method (_CRS, 0, Serialized)
            {
                CreateDWordField (BUF0, 0x04, RBR0)
                ShiftLeft (^^LPCB.RCBA, 0x0E, RBR0)
                CreateDWordField (BUF0, 0x7C, TBR0)
                Store (TBAB, TBR0)
                CreateDWordField (BUF0, 0x80, TBLN)
                If (LEqual (TBAB, Zero))
                {
                    Store (Zero, TBLN)
                }
                CreateDWordField (BUF0, 0x10, MBR0)
                ShiftLeft (MHBR, 0x0F, MBR0)
                CreateDWordField (BUF0, 0x1C, DBR0)
                ShiftLeft (DIBR, 0x0C, DBR0)
                CreateDWordField (BUF0, 0x28, EBR0)
                ShiftLeft (EPBR, 0x0C, EBR0)
                CreateDWordField (BUF0, 0x34, XBR0)
                ShiftLeft (PXBR, 0x1A, XBR0)
                CreateDWordField (BUF0, 0x38, XSZ0)
                ShiftRight (0x10000000, PXSZ, XSZ0)
                Return (BUF0)
            }
        }
    }
    Scope (_GPE)
    {
        Method (_L0B, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.P0P1, 0x02)
        }
        Method (_L09, 0, NotSerialized)
        {
            If (LEqual (RP1D, Zero))
            {
                \_SB.PCI0.RP01.HPME ()
                Notify (\_SB.PCI0.RP01, 0x02)
            }
            If (LEqual (RP2D, Zero))
            {
                \_SB.PCI0.RP02.HPME ()
                Notify (\_SB.PCI0.RP02, 0x02)
            }
            If (LEqual (RP3D, Zero))
            {
                \_SB.PCI0.RP03.HPME ()
                Notify (\_SB.PCI0.RP03, 0x02)
            }
            If (LEqual (RP4D, Zero))
            {
                \_SB.PCI0.RP04.HPME ()
                Notify (\_SB.PCI0.RP04, 0x02)
            }
            If (LEqual (RP5D, Zero))
            {
                \_SB.PCI0.RP05.HPME ()
                Notify (\_SB.PCI0.RP05, 0x02)
            }
            If (LEqual (RP6D, Zero))
            {
                \_SB.PCI0.RP06.HPME ()
                Notify (\_SB.PCI0.RP06, 0x02)
            }
            If (LEqual (RP7D, Zero))
            {
                \_SB.PCI0.RP07.HPME ()
                Notify (\_SB.PCI0.RP07, 0x02)
            }
            If (LEqual (RP8D, Zero))
            {
                \_SB.PCI0.RP08.HPME ()
                Notify (\_SB.PCI0.RP08, 0x02)
            }
            Notify (\_SB.PCI0.PEG0, 0x02)
            Notify (\_SB.PCI0.PEG0.PEGP, 0x02)
            Notify (\_SB.PCI0.PEG1, 0x02)
            Notify (\_SB.PCI0.PEG2, 0x02)
            Notify (\_SB.PCI0.PEG3, 0x02)
        }
        Method (_L0D, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.EHC1, 0x02)
            Notify (\_SB.PCI0.EHC2, 0x02)
            Notify (\_SB.PCI0.HDEF, 0x02)
            Notify (\_SB.PWRB, 0x02)
        }
        Method (_L01, 0, NotSerialized)
        {
            Add (L01C, One, L01C)
            P8XH (Zero, One)
            If (LAnd (LEqual (RP1D, Zero), \_SB.PCI0.RP01.HPSX))
            {
                Sleep (0x64)
                If (\_SB.PCI0.RP01.PDCX)
                {
                    Store (One, \_SB.PCI0.RP01.PDCX)
                    Store (One, \_SB.PCI0.RP01.HPSX)
                    If (LNot (\_SB.PCI0.RP01.PDSX))
                    {
                        Store (Zero, \_SB.PCI0.RP01.L0SE)
                    }
                    Notify (\_SB.PCI0.RP01, Zero)
                }
                Else
                {
                    Store (One, \_SB.PCI0.RP01.HPSX)
                }
            }
            If (LAnd (LEqual (RP2D, Zero), \_SB.PCI0.RP02.HPSX))
            {
                Sleep (0x64)
                If (\_SB.PCI0.RP02.PDCX)
                {
                    Store (One, \_SB.PCI0.RP02.PDCX)
                    Store (One, \_SB.PCI0.RP02.HPSX)
                    If (LNot (\_SB.PCI0.RP02.PDSX))
                    {
                        Store (Zero, \_SB.PCI0.RP02.L0SE)
                    }
                    Notify (\_SB.PCI0.RP02, Zero)
                }
                Else
                {
                    Store (One, \_SB.PCI0.RP02.HPSX)
                }
            }
            If (LAnd (LEqual (RP3D, Zero), \_SB.PCI0.RP03.HPSX))
            {
                Sleep (0x64)
                If (\_SB.PCI0.RP03.PDCX)
                {
                    Store (One, \_SB.PCI0.RP03.PDCX)
                    Store (One, \_SB.PCI0.RP03.HPSX)
                    If (LNot (\_SB.PCI0.RP03.PDSX))
                    {
                        Store (Zero, \_SB.PCI0.RP03.L0SE)
                    }
                    Notify (\_SB.PCI0.RP03, Zero)
                }
                Else
                {
                    Store (One, \_SB.PCI0.RP03.HPSX)
                }
            }
            If (LAnd (LEqual (RP4D, Zero), \_SB.PCI0.RP04.HPSX))
            {
                Sleep (0x64)
                If (\_SB.PCI0.RP04.PDCX)
                {
                    Store (One, \_SB.PCI0.RP04.PDCX)
                    Store (One, \_SB.PCI0.RP04.HPSX)
                    If (LNot (\_SB.PCI0.RP04.PDSX))
                    {
                        Store (Zero, \_SB.PCI0.RP04.L0SE)
                    }
                    Notify (\_SB.PCI0.RP04, Zero)
                }
                Else
                {
                    Store (One, \_SB.PCI0.RP04.HPSX)
                }
            }
            If (LAnd (LEqual (RP5D, Zero), \_SB.PCI0.RP05.HPSX))
            {
                Sleep (0x64)
                If (\_SB.PCI0.RP05.PDCX)
                {
                    Store (One, \_SB.PCI0.RP05.PDCX)
                    Store (One, \_SB.PCI0.RP05.HPSX)
                    If (LNot (\_SB.PCI0.RP05.PDSX))
                    {
                        Store (Zero, \_SB.PCI0.RP05.L0SE)
                    }
                    Notify (\_SB.PCI0.RP05, Zero)
                }
                Else
                {
                    Store (One, \_SB.PCI0.RP05.HPSX)
                }
            }
            If (LAnd (LEqual (RP6D, Zero), \_SB.PCI0.RP06.HPSX))
            {
                Sleep (0x64)
                If (\_SB.PCI0.RP06.PDCX)
                {
                    Store (One, \_SB.PCI0.RP06.PDCX)
                    Store (One, \_SB.PCI0.RP06.HPSX)
                    If (LNot (\_SB.PCI0.RP06.PDSX))
                    {
                        Store (Zero, \_SB.PCI0.RP06.L0SE)
                    }
                    Notify (\_SB.PCI0.RP06, Zero)
                }
                Else
                {
                    Store (One, \_SB.PCI0.RP06.HPSX)
                }
            }
        }
        Method (_L02, 0, NotSerialized)
        {
            Store (Zero, GPEC)
            Notify (\_TZ.TZ00, 0x80)
            If (CondRefOf (TNOT))
            {
                TNOT ()
            }
        }
        Method (_L06, 0, NotSerialized)
        {
            If (LAnd (\_SB.PCI0.GFX0.GSSE, LNot (GSMI)))
            {
                \_SB.PCI0.GFX0.GSCI ()
            }
        }
        Method (_L07, 0, NotSerialized)
        {
            Store (0x20, \_SB.PCI0.SBUS.HSTS)
        }
    }
    Scope (\)
    {
        OperationRegion (IO_T, SystemIO, 0x1004, 0x10)
        Field (IO_T, ByteAcc, NoLock, Preserve)
        {
            TRPI,   16, 
                    Offset (0x04), 
                    Offset (0x06), 
                    Offset (0x08), 
            TRP0,   8, 
                    Offset (0x0A), 
                    Offset (0x0B), 
                    Offset (0x0C), 
                    Offset (0x0D), 
                    Offset (0x0E), 
                    Offset (0x0F), 
                    Offset (0x10)
        }
        OperationRegion (IO_D, SystemIO, 0x1000, 0x04)
        Field (IO_D, ByteAcc, NoLock, Preserve)
        {
            TRPD,   8
        }
        OperationRegion (IO_H, SystemIO, 0x1000, 0x04)
        Field (IO_H, ByteAcc, NoLock, Preserve)
        {
            TRPH,   8
        }
        OperationRegion (PMIO, SystemIO, PMBS, 0x80)
        Field (PMIO, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x20), 
                    Offset (0x22), 
                ,   3, 
            GPS3,   1, 
                    Offset (0x28), 
                    Offset (0x2A), 
                ,   3, 
            GPE3,   1, 
                    Offset (0x3C), 
                ,   1, 
            UPRW,   1, 
                    Offset (0x42), 
                ,   1, 
            GPEC,   1, 
                    Offset (0x64), 
                ,   9, 
            SCIS,   1, 
                    Offset (0x66)
        }
        OperationRegion (GPIO, SystemIO, GPBS, 0x64)
        Field (GPIO, ByteAcc, NoLock, Preserve)
        {
            GU00,   8, 
            GU01,   8, 
            GU02,   8, 
            GU03,   8, 
            GIO0,   8, 
            GIO1,   8, 
            GIO2,   8, 
            GIO3,   8, 
                    Offset (0x0C), 
                ,   1, 
                ,   1, 
            GI02,   1, 
            GI03,   1, 
            GI04,   1, 
                ,   1, 
                ,   1, 
                    Offset (0x0D), 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                    Offset (0x0E), 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
            MDID,   1, 
            BKLT,   1, 
                ,   3, 
            GP27,   1, 
            GP28,   1, 
                    Offset (0x10), 
                    Offset (0x18), 
                    Offset (0x2C), 
            GIV0,   8, 
            GIV1,   8, 
            GIV2,   8, 
            GIV3,   8, 
            GU04,   8, 
            GU05,   8, 
            GU06,   8, 
                ,   1, 
                ,   1, 
            GU07,   1, 
                    Offset (0x34), 
            GIO4,   8, 
            GIO5,   8, 
            GIO6,   8, 
            GIO7,   8, 
                ,   1, 
                ,   1, 
            GO34,   1, 
            GO35,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                    Offset (0x39), 
                    Offset (0x3A), 
            GO48,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
            GO54,   1, 
                    Offset (0x3B), 
                    Offset (0x40), 
            GU08,   8, 
            GU09,   8, 
            GU0A,   8, 
            GU0B,   8, 
            GIO8,   8, 
            GIO9,   8, 
            GIOA,   8, 
            GIOB,   8, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
            GO70,   1, 
            GO71,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
                    Offset (0x4A), 
            GL0A,   8, 
            GL0B,   8
        }
        OperationRegion (RCRB, SystemMemory, SRCB, 0x4000)
        Field (RCRB, DWordAcc, Lock, Preserve)
        {
                    Offset (0x1000), 
                    Offset (0x3000), 
                    Offset (0x3404), 
            HPAS,   2, 
                ,   5, 
            HPAE,   1, 
                    Offset (0x3418), 
                ,   1, 
                ,   1, 
            SATD,   1, 
            SMBD,   1, 
            HDAD,   1, 
                    Offset (0x341A), 
            RP1D,   1, 
            RP2D,   1, 
            RP3D,   1, 
            RP4D,   1, 
            RP5D,   1, 
            RP6D,   1, 
            RP7D,   1, 
            RP8D,   1, 
                    Offset (0x359C), 
            UP0D,   1, 
            UP1D,   1, 
            UP2D,   1, 
            UP3D,   1, 
            UP4D,   1, 
            UP5D,   1, 
            UP6D,   1, 
            UP7D,   1, 
            UP8D,   1, 
            UP9D,   1, 
            UPAD,   1, 
            UPBD,   1, 
            UPCD,   1, 
            UPDD,   1, 
                ,   1, 
                    Offset (0x359E)
        }
        Method (GETP, 1, Serialized)
        {
            If (LEqual (And (Arg0, 0x09), Zero))
            {
                Return (0xFFFFFFFF)
            }
            If (LEqual (And (Arg0, 0x09), 0x08))
            {
                Return (0x0384)
            }
            ShiftRight (And (Arg0, 0x0300), 0x08, Local0)
            ShiftRight (And (Arg0, 0x3000), 0x0C, Local1)
            Return (Multiply (0x1E, Subtract (0x09, Add (Local0, Local1))
                ))
        }
        Method (GDMA, 5, Serialized)
        {
            If (Arg0)
            {
                If (LAnd (Arg1, Arg4))
                {
                    Return (0x14)
                }
                If (LAnd (Arg2, Arg4))
                {
                    Return (Multiply (Subtract (0x04, Arg3), 0x0F))
                }
                Return (Multiply (Subtract (0x04, Arg3), 0x1E))
            }
            Return (0xFFFFFFFF)
        }
        Method (GETT, 1, Serialized)
        {
            Return (Multiply (0x1E, Subtract (0x09, Add (And (ShiftRight (Arg0, 0x02
                ), 0x03), And (Arg0, 0x03)))))
        }
        Method (GETF, 3, Serialized)
        {
            Name (TMPF, Zero)
            If (Arg0)
            {
                Or (TMPF, One, TMPF)
            }
            If (And (Arg2, 0x02))
            {
                Or (TMPF, 0x02, TMPF)
            }
            If (Arg1)
            {
                Or (TMPF, 0x04, TMPF)
            }
            If (And (Arg2, 0x20))
            {
                Or (TMPF, 0x08, TMPF)
            }
            If (And (Arg2, 0x4000))
            {
                Or (TMPF, 0x10, TMPF)
            }
            Return (TMPF)
        }
        Method (SETP, 3, Serialized)
        {
            If (LGreater (Arg0, 0xF0))
            {
                Return (0x08)
            }
            Else
            {
                If (And (Arg1, 0x02))
                {
                    If (LAnd (LLessEqual (Arg0, 0x78), And (Arg2, 0x02)))
                    {
                        Return (0x2301)
                    }
                    If (LAnd (LLessEqual (Arg0, 0xB4), And (Arg2, One)))
                    {
                        Return (0x2101)
                    }
                }
                Return (0x1001)
            }
        }
        Method (SDMA, 1, Serialized)
        {
            If (LLessEqual (Arg0, 0x14))
            {
                Return (One)
            }
            If (LLessEqual (Arg0, 0x1E))
            {
                Return (0x02)
            }
            If (LLessEqual (Arg0, 0x2D))
            {
                Return (One)
            }
            If (LLessEqual (Arg0, 0x3C))
            {
                Return (0x02)
            }
            If (LLessEqual (Arg0, 0x5A))
            {
                Return (One)
            }
            Return (Zero)
        }
        Method (SETT, 3, Serialized)
        {
            If (And (Arg1, 0x02))
            {
                If (LAnd (LLessEqual (Arg0, 0x78), And (Arg2, 0x02)))
                {
                    Return (0x0B)
                }
                If (LAnd (LLessEqual (Arg0, 0xB4), And (Arg2, One)))
                {
                    Return (0x09)
                }
            }
            Return (0x04)
        }
    }
    Scope (_SB.PCI0)
    {
        Device (EHC1)
        {
            Name (_ADR, 0x001D0000)
            OperationRegion (U1CS, PCI_Config, 0x62, 0x04)
            Field (U1CS, DWordAcc, NoLock, Preserve)
            {
                    ,   1, 
                E1EN,   8
            }
            Method (_PSW, 1, NotSerialized)
            {
                If (Arg0)
                {
                    Store (Ones, E1EN)
                }
                Else
                {
                    Store (Zero, E1EN)
                }
                Store (Arg0, ESG0)
            }
            Method (_S3D, 0, NotSerialized)
            {
                Return (0x02)
            }
            Method (_S4D, 0, NotSerialized)
            {
                Return (0x02)
            }
            Method (_PRW, 0, NotSerialized)
            {
                Return (GPRW (0x0D, 0x03))
            }
            Device (HUB0)
            {
                Name (_ADR, Zero)
                Device (PRT1)
                {
                    Name (_ADR, One)
                    Name (_UPC, Package (0x04)
                    {
                        Zero, 
                        0xFF, 
                        Zero, 
                        Zero
                    })
                    Device (PRO4)
                    {
                        Name (_ADR, 0x04)
                        Name (_UPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                    }
                    Device (PRO5)
                    {
                        Name (_ADR, 0x05)
                        Name (_UPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                    }
                    Device (PRO6)
                    {
                        Name (_ADR, 0x06)
                        Name (_UPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                    }
                }
            }
        }
        Device (EHC2)
        {
            Name (_ADR, 0x001A0000)
            OperationRegion (U1CS, PCI_Config, 0x62, 0x04)
            Field (U1CS, DWordAcc, NoLock, Preserve)
            {
                    ,   1, 
                E2EN,   6
            }
            Method (_PSW, 1, NotSerialized)
            {
                If (Arg0)
                {
                    Store (Ones, E2EN)
                }
                Else
                {
                    Store (Zero, E2EN)
                }
                Store (Arg0, ESG1)
            }
            Method (_S3D, 0, NotSerialized)
            {
                Return (0x02)
            }
            Method (_S4D, 0, NotSerialized)
            {
                Return (0x02)
            }
            Method (_PRW, 0, NotSerialized)
            {
                Return (GPRW (0x0D, 0x03))
            }
            Device (HUB0)
            {
                Name (_ADR, Zero)
                Device (PRT1)
                {
                    Name (_ADR, One)
                    Name (_UPC, Package (0x04)
                    {
                        Zero, 
                        0xFF, 
                        Zero, 
                        Zero
                    })
                    Device (POR6)
                    {
                        Name (_ADR, 0x06)
                        Name (_UPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                    }
                }
            }
        }
//        Device (HDEF)
//        {
//            Name (_ADR, 0x001B0000)
//            OperationRegion (HDAR, PCI_Config, 0x4C, 0x10)
//            Field (HDAR, WordAcc, NoLock, Preserve)
//            {
//                DCKA,   1, 
//                        Offset (0x01), 
//                DCKM,   1, 
//                    ,   6, 
//                DCKS,   1, 
//                        Offset (0x08), 
//                    ,   15, 
//                PMES,   1
//            }
//
//            Method (_PRW, 0, NotSerialized)
//            {
//                Return (GPRW (0x0D, 0x04))
//            }
//        }
          /**  This is the Conexant HD Smrt Audio Dev.   **/
          Device (HDEF)
          {
          	Name (_ADR, 0x001B0000)
              Name (_S3D, 0x03)
              Name (RID, Zero)
              Name (_PRW, Package (0x02)
              	{
              		0x0D,
                  	0x04
              	}
              )
              Method (_DSM, 4, NotSerialized)
              {
              	Store (Package (0x0E)
                  {
                  	"AAPL,slot-name",
                      Buffer (0x09)
                      {
                      	"Built in"
                      },
                      "device-id",  /**** This is the Oriinal Conexant HD CX20671 ID  ****/
                      Buffer (0x04)
                      {
                      	0x6E, 0x50, 0xF1, 0x14
                      },
                      "layout-id",
                      Buffer (0x04)
                      {
                      	0x0C, 0x00, 0x00, 0x00
                      },
                      "model",
                      Buffer (0x1A)
                      {
                      	"HD Audio Conexant Cx20671"
                      },
                      "name",
                      Buffer (0x11)
                      {
                      	"Conexant Cx20671"
                      },
                      "device_type",
                      Buffer (0x11)
                      {
                      	"Audio Controller"
                      },
                      "PinConfigurations",
                      Buffer (One)
                      {
                      	0x00
                      }
                  }, Local0)
                  DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                  Return (Local0)
              }
          }
        Device (RP01)
        {
            Name (_ADR, 0x001C0000)
            OperationRegion (PXCS, PCI_Config, 0x40, 0xC0)
            Field (PXCS, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                L0SE,   1, 
                        Offset (0x11), 
                        Offset (0x12), 
                    ,   13, 
                LASX,   1, 
                        Offset (0x1A), 
                ABPX,   1, 
                    ,   2, 
                PDCX,   1, 
                    ,   2, 
                PDSX,   1, 
                        Offset (0x1B), 
                LSCX,   1, 
                        Offset (0x20), 
                        Offset (0x22), 
                PSPX,   1, 
                        Offset (0x98), 
                    ,   30, 
                HPEX,   1, 
                PMEX,   1, 
                    ,   30, 
                HPSX,   1, 
                PMSX,   1
            }
            Device (PXSX)
            {
                Name (_ADR, Zero)
            }
            Method (HPME, 0, Serialized)
            {
                If (PMSX)
                {
                    Store (0xC8, Local0)
                    While (Local0)
                    {
                        Store (One, PMSX)
                        If (PMSX)
                        {
                            Decrement (Local0)
                        }
                        Else
                        {
                            Store (Zero, Local0)
                        }
                    }
                    Notify (PXSX, 0x02)
                }
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR04 ())
                }
                Return (PR04 ())
            }
        }
        Device (RP02)
        {
            Name (_ADR, 0x001C0001)
            OperationRegion (PXCS, PCI_Config, 0x40, 0xC0)
            Field (PXCS, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                L0SE,   1, 
                        Offset (0x11), 
                        Offset (0x12), 
                    ,   13, 
                LASX,   1, 
                        Offset (0x1A), 
                ABPX,   1, 
                    ,   2, 
                PDCX,   1, 
                    ,   2, 
                PDSX,   1, 
                        Offset (0x1B), 
                LSCX,   1, 
                        Offset (0x20), 
                        Offset (0x22), 
                PSPX,   1, 
                        Offset (0x98), 
                    ,   30, 
                HPEX,   1, 
                PMEX,   1, 
                    ,   30, 
                HPSX,   1, 
                PMSX,   1
            }
            Device (PXSX)
            {
                Name (_ADR, Zero)
            }
            Method (HPME, 0, Serialized)
            {
                If (PMSX)
                {
                    Store (0xC8, Local0)
                    While (Local0)
                    {
                        Store (One, PMSX)
                        If (PMSX)
                        {
                            Decrement (Local0)
                        }
                        Else
                        {
                            Store (Zero, Local0)
                        }
                    }
                    Notify (PXSX, 0x02)
                }
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR05 ())
                }
                Return (PR05 ())
            }
        }
        Device (RP03)
        {
            Name (_ADR, 0x001C0002)
            OperationRegion (PXCS, PCI_Config, 0x40, 0xC0)
            Field (PXCS, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                L0SE,   1, 
                        Offset (0x11), 
                        Offset (0x12), 
                    ,   13, 
                LASX,   1, 
                        Offset (0x1A), 
                ABPX,   1, 
                    ,   2, 
                PDCX,   1, 
                    ,   2, 
                PDSX,   1, 
                        Offset (0x1B), 
                LSCX,   1, 
                        Offset (0x20), 
                        Offset (0x22), 
                PSPX,   1, 
                        Offset (0x98), 
                    ,   30, 
                HPEX,   1, 
                PMEX,   1, 
                    ,   30, 
                HPSX,   1, 
                PMSX,   1
            }
            Device (PXSX)
            {
                Name (_ADR, Zero)
            }
            Method (HPME, 0, Serialized)
            {
                If (PMSX)
                {
                    Store (0xC8, Local0)
                    While (Local0)
                    {
                        Store (One, PMSX)
                        If (PMSX)
                        {
                            Decrement (Local0)
                        }
                        Else
                        {
                            Store (Zero, Local0)
                        }
                    }
                    Notify (PXSX, 0x02)
                }
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR06 ())
                }
                Return (PR06 ())
            }
        }
        Device (RP04)
        {
            Name (_ADR, 0x001C0003)
            OperationRegion (PXCS, PCI_Config, 0x40, 0xC0)
            Field (PXCS, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                L0SE,   1, 
                        Offset (0x11), 
                        Offset (0x12), 
                    ,   13, 
                LASX,   1, 
                        Offset (0x1A), 
                ABPX,   1, 
                    ,   2, 
                PDCX,   1, 
                    ,   2, 
                PDSX,   1, 
                        Offset (0x1B), 
                LSCX,   1, 
                        Offset (0x20), 
                        Offset (0x22), 
                PSPX,   1, 
                        Offset (0x98), 
                    ,   30, 
                HPEX,   1, 
                PMEX,   1, 
                    ,   30, 
                HPSX,   1, 
                PMSX,   1
            }
            Device (PXSX)
            {
                Name (_ADR, Zero)
            }
            Method (HPME, 0, Serialized)
            {
                If (PMSX)
                {
                    Store (0xC8, Local0)
                    While (Local0)
                    {
                        Store (One, PMSX)
                        If (PMSX)
                        {
                            Decrement (Local0)
                        }
                        Else
                        {
                            Store (Zero, Local0)
                        }
                    }
                    Notify (PXSX, 0x02)
                }
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR07 ())
                }
                Return (PR07 ())
            }
        }
        Device (RP05)
        {
            Name (_ADR, 0x001C0004)
            OperationRegion (PXCS, PCI_Config, 0x40, 0xC0)
            Field (PXCS, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                L0SE,   1, 
                        Offset (0x11), 
                        Offset (0x12), 
                    ,   13, 
                LASX,   1, 
                        Offset (0x1A), 
                ABPX,   1, 
                    ,   2, 
                PDCX,   1, 
                    ,   2, 
                PDSX,   1, 
                        Offset (0x1B), 
                LSCX,   1, 
                        Offset (0x20), 
                        Offset (0x22), 
                PSPX,   1, 
                        Offset (0x98), 
                    ,   30, 
                HPEX,   1, 
                PMEX,   1, 
                    ,   30, 
                HPSX,   1, 
                PMSX,   1
            }
            Device (PXSX)
            {
                Name (_ADR, Zero)
            }
            Method (HPME, 0, Serialized)
            {
                If (PMSX)
                {
                    Store (0xC8, Local0)
                    While (Local0)
                    {
                        Store (One, PMSX)
                        If (PMSX)
                        {
                            Decrement (Local0)
                        }
                        Else
                        {
                            Store (Zero, Local0)
                        }
                    }
                    Notify (PXSX, 0x02)
                }
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR08 ())
                }
                Return (PR08 ())
            }
        }
        Device (RP06)
        {
            Name (_ADR, 0x001C0005)
            OperationRegion (PXCS, PCI_Config, 0x40, 0xC0)
            Field (PXCS, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                L0SE,   1, 
                        Offset (0x11), 
                        Offset (0x12), 
                    ,   13, 
                LASX,   1, 
                        Offset (0x1A), 
                ABPX,   1, 
                    ,   2, 
                PDCX,   1, 
                    ,   2, 
                PDSX,   1, 
                        Offset (0x1B), 
                LSCX,   1, 
                        Offset (0x20), 
                        Offset (0x22), 
                PSPX,   1, 
                        Offset (0x98), 
                    ,   30, 
                HPEX,   1, 
                PMEX,   1, 
                    ,   30, 
                HPSX,   1, 
                PMSX,   1
            }
            Device (PXSX)
            {
                Name (_ADR, Zero)
                Name (_PRW, Package (0x02)
                {
                    0x09, 
                    0x04
                })
            }
            Method (HPME, 0, Serialized)
            {
                If (PMSX)
                {
                    Store (0xC8, Local0)
                    While (Local0)
                    {
                        Store (One, PMSX)
                        If (PMSX)
                        {
                            Decrement (Local0)
                        }
                        Else
                        {
                            Store (Zero, Local0)
                        }
                    }
                    Notify (PXSX, 0x02)
                }
            }
            Method (_PRW, 0, NotSerialized)
            {
                Return (GPRW (0x09, 0x04))
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR09 ())
                }
                Return (PR09 ())
            }
        }
        Device (RP07)
        {
            Name (_ADR, 0x001C0006)
            OperationRegion (PXCS, PCI_Config, 0x40, 0xC0)
            Field (PXCS, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                L0SE,   1, 
                        Offset (0x11), 
                        Offset (0x12), 
                    ,   13, 
                LASX,   1, 
                        Offset (0x1A), 
                ABPX,   1, 
                    ,   2, 
                PDCX,   1, 
                    ,   2, 
                PDSX,   1, 
                        Offset (0x1B), 
                LSCX,   1, 
                        Offset (0x20), 
                        Offset (0x22), 
                PSPX,   1, 
                        Offset (0x98), 
                    ,   30, 
                HPEX,   1, 
                PMEX,   1, 
                    ,   30, 
                HPSX,   1, 
                PMSX,   1
            }
            Device (PXSX)
            {
                Name (_ADR, Zero)
            }
            Method (HPME, 0, Serialized)
            {
                If (PMSX)
                {
                    Store (0xC8, Local0)
                    While (Local0)
                    {
                        Store (One, PMSX)
                        If (PMSX)
                        {
                            Decrement (Local0)
                        }
                        Else
                        {
                            Store (Zero, Local0)
                        }
                    }
                    Notify (PXSX, 0x02)
                }
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR0E)
                }
                Return (PR0E)
            }
        }
        Device (RP08)
        {
            Name (_ADR, 0x001C0007)
            OperationRegion (PXCS, PCI_Config, 0x40, 0xC0)
            Field (PXCS, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                L0SE,   1, 
                        Offset (0x11), 
                        Offset (0x12), 
                    ,   13, 
                LASX,   1, 
                        Offset (0x1A), 
                ABPX,   1, 
                    ,   2, 
                PDCX,   1, 
                    ,   2, 
                PDSX,   1, 
                        Offset (0x1B), 
                LSCX,   1, 
                        Offset (0x20), 
                        Offset (0x22), 
                PSPX,   1, 
                        Offset (0x98), 
                    ,   30, 
                HPEX,   1, 
                PMEX,   1, 
                    ,   30, 
                HPSX,   1, 
                PMSX,   1
            }
            Device (PXSX)
            {
                Name (_ADR, Zero)
            }
            Method (HPME, 0, Serialized)
            {
                If (PMSX)
                {
                    Store (0xC8, Local0)
                    While (Local0)
                    {
                        Store (One, PMSX)
                        If (PMSX)
                        {
                            Decrement (Local0)
                        }
                        Else
                        {
                            Store (Zero, Local0)
                        }
                    }
                    Notify (PXSX, 0x02)
                }
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR0F)
                }
                Return (PR0F)
            }
        }
        Device (SAT0)
        {
            Name (_ADR, 0x001F0002)
            OperationRegion (SACS, PCI_Config, 0x40, 0xC0)
            Field (SACS, DWordAcc, NoLock, Preserve)
            {
                PRIT,   16, 
                SECT,   16, 
                PSIT,   4, 
                SSIT,   4, 
                        Offset (0x08), 
                SYNC,   4, 
                        Offset (0x0A), 
                SDT0,   2, 
                    ,   2, 
                SDT1,   2, 
                        Offset (0x0B), 
                SDT2,   2, 
                    ,   2, 
                SDT3,   2, 
                        Offset (0x14), 
                ICR0,   4, 
                ICR1,   4, 
                ICR2,   4, 
                ICR3,   4, 
                ICR4,   4, 
                ICR5,   4, 
                        Offset (0x34), 
                HDPS,   2, 
                        Offset (0x50), 
                MAPV,   2
            }
            Name (_PSC, Zero)
            Method (_PS0, 0, NotSerialized)
            {
                Store (Zero, _PSC)
            }
            Method (_PS3, 0, NotSerialized)
            {
                Store (Zero, HDPS)
                Store (Zero, _PSC)
            }
            Device (PRT0)
            {
                Name (_ADR, 0xFFFF)
                Name (DIP0, Zero)
                Name (HDTF, Buffer (0x0E)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                })
                Name (HPTF, Buffer (0x15)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xEF
                })
                Method (_SDD, 1, NotSerialized)
                {
                    If (LEqual (SizeOf (Arg0), 0x0200))
                    {
                        CreateWordField (Arg0, 0x9C, W780)
                        If (And (W780, 0x08))
                        {
                            Store (One, DIP0)
                            Store (One, DPP0)
                        }
                    }
                }
                Method (_GTF, 0, NotSerialized)
                {
                    If (DIP0)
                    {
                        Return (HPTF)
                    }
                    Return (HDTF)
                }
            }
            Device (PRT1)
            {
                Name (_ADR, 0x0001FFFF)
                Name (DIP1, Zero)
                Name (HDTF, Buffer (0x0E)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                })
                Name (HPTF, Buffer (0x15)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xEF
                })
                Method (_SDD, 1, NotSerialized)
                {
                    If (LEqual (SizeOf (Arg0), 0x0200))
                    {
                        CreateWordField (Arg0, 0x9C, W780)
                        If (And (W780, 0x08))
                        {
                            Store (One, DIP1)
                            Store (One, DPP1)
                        }
                    }
                }
                Method (_GTF, 0, NotSerialized)
                {
                    If (DIP1)
                    {
                        Return (HPTF)
                    }
                    Return (HDTF)
                }
            }
            Device (PRT2)
            {
                Name (_ADR, 0x0002FFFF)
                Method (_RMV, 0, NotSerialized)
                {
                    Return (One)
                }
                Name (DIP2, Zero)
                Name (HDTF, Buffer (0x0E)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
                })
                Name (HPTF, Buffer (0x15)
                {
                    /* 0000 */    0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 
                    /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03, 
                    /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xEF
                })
                Method (_SDD, 1, NotSerialized)
                {
                    If (LEqual (SizeOf (Arg0), 0x0200))
                    {
                        CreateWordField (Arg0, 0x9C, W780)
                        If (And (W780, 0x08))
                        {
                            Store (One, DIP2)
                            Store (One, DPP2)
                        }
                    }
                }
                Method (_GTF, 0, NotSerialized)
                {
                    If (DIP2)
                    {
                        Return (HPTF)
                    }
                    Return (HDTF)
                }
            }
            Device (PRID)
            {
                Name (_ADR, Zero)
                Method (_GTM, 0, NotSerialized)
                {
                    Name (PBUF, Buffer (0x14)
                    {
                        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                        /* 0010 */    0x00, 0x00, 0x00, 0x00
                    })
                    CreateDWordField (PBUF, Zero, PIO0)
                    CreateDWordField (PBUF, 0x04, DMA0)
                    CreateDWordField (PBUF, 0x08, PIO1)
                    CreateDWordField (PBUF, 0x0C, DMA1)
                    CreateDWordField (PBUF, 0x10, FLAG)
                    Store (GETP (PRIT), PIO0)
                    Store (GDMA (And (SYNC, One), And (ICR3, One), 
                        And (ICR0, One), SDT0, And (ICR1, One)), DMA0)
                    If (LEqual (DMA0, 0xFFFFFFFF))
                    {
                        Store (PIO0, DMA0)
                    }
                    If (And (PRIT, 0x4000))
                    {
                        If (LEqual (And (PRIT, 0x90), 0x80))
                        {
                            Store (0x0384, PIO1)
                        }
                        Else
                        {
                            Store (GETT (PSIT), PIO1)
                        }
                    }
                    Else
                    {
                        Store (0xFFFFFFFF, PIO1)
                    }
                    Store (GDMA (And (SYNC, 0x02), And (ICR3, 0x02), 
                        And (ICR0, 0x02), SDT1, And (ICR1, 0x02)), DMA1)
                    If (LEqual (DMA1, 0xFFFFFFFF))
                    {
                        Store (PIO1, DMA1)
                    }
                    Store (GETF (And (SYNC, One), And (SYNC, 0x02), 
                        PRIT), FLAG)
                    Return (PBUF)
                }
                Method (_STM, 3, NotSerialized)
                {
                    CreateDWordField (Arg0, Zero, PIO0)
                    CreateDWordField (Arg0, 0x04, DMA0)
                    CreateDWordField (Arg0, 0x08, PIO1)
                    CreateDWordField (Arg0, 0x0C, DMA1)
                    CreateDWordField (Arg0, 0x10, FLAG)
                    If (LEqual (SizeOf (Arg1), 0x0200))
                    {
                        And (PRIT, 0xC0F0, PRIT)
                        And (SYNC, 0x0E, SYNC)
                        Store (Zero, SDT0)
                        And (ICR0, 0x0E, ICR0)
                        And (ICR1, 0x0E, ICR1)
                        And (ICR3, 0x0E, ICR3)
                        And (ICR5, 0x0E, ICR5)
                        CreateWordField (Arg1, 0x62, W490)
                        CreateWordField (Arg1, 0x6A, W530)
                        CreateWordField (Arg1, 0x7E, W630)
                        CreateWordField (Arg1, 0x80, W640)
                        CreateWordField (Arg1, 0xB0, W880)
                        CreateWordField (Arg1, 0xBA, W930)
                        Or (PRIT, 0x8004, PRIT)
                        If (LAnd (And (FLAG, 0x02), And (W490, 0x0800)))
                        {
                            Or (PRIT, 0x02, PRIT)
                        }
                        Or (PRIT, SETP (PIO0, W530, W640), PRIT)
                        If (And (FLAG, One))
                        {
                            Or (SYNC, One, SYNC)
                            Store (SDMA (DMA0), SDT0)
                            If (LLess (DMA0, 0x1E))
                            {
                                Or (ICR3, One, ICR3)
                            }
                            If (LLess (DMA0, 0x3C))
                            {
                                Or (ICR0, One, ICR0)
                            }
                            Or (ICR1, One, ICR1)
                        }
                    }
                    If (LEqual (SizeOf (Arg2), 0x0200))
                    {
                        And (PRIT, 0xBF0F, PRIT)
                        Store (Zero, PSIT)
                        And (SYNC, 0x0D, SYNC)
                        Store (Zero, SDT1)
                        And (ICR0, 0x0D, ICR0)
                        And (ICR1, 0x0D, ICR1)
                        And (ICR3, 0x0D, ICR3)
                        And (ICR5, 0x0D, ICR5)
                        CreateWordField (Arg2, 0x62, W491)
                        CreateWordField (Arg2, 0x6A, W531)
                        CreateWordField (Arg2, 0x7E, W631)
                        CreateWordField (Arg2, 0x80, W641)
                        CreateWordField (Arg2, 0xB0, W881)
                        CreateWordField (Arg2, 0xBA, W931)
                        Or (PRIT, 0x8040, PRIT)
                        If (LAnd (And (FLAG, 0x08), And (W491, 0x0800)))
                        {
                            Or (PRIT, 0x20, PRIT)
                        }
                        If (And (FLAG, 0x10))
                        {
                            Or (PRIT, 0x4000, PRIT)
                            If (LGreater (PIO1, 0xF0))
                            {
                                Or (PRIT, 0x80, PRIT)
                            }
                            Else
                            {
                                Or (PRIT, 0x10, PRIT)
                                Store (SETT (PIO1, W531, W641), PSIT)
                            }
                        }
                        If (And (FLAG, 0x04))
                        {
                            Or (SYNC, 0x02, SYNC)
                            Store (SDMA (DMA1), SDT1)
                            If (LLess (DMA1, 0x1E))
                            {
                                Or (ICR3, 0x02, ICR3)
                            }
                            If (LLess (DMA1, 0x3C))
                            {
                                Or (ICR0, 0x02, ICR0)
                            }
                            Or (ICR1, 0x02, ICR1)
                        }
                    }
                }
                Device (P_D0)
                {
                    Name (_ADR, Zero)
                    Method (_GTF, 0, NotSerialized)
                    {
                        Name (PIB0, Buffer (0x1C)
                        {
                            /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                            /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 
                            /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 0x00, 0x00, 
                            /* 0018 */    0x00, 0x00, 0xA0, 0xF5
                        })
                        CreateByteField (PIB0, One, PMD0)
                        CreateByteField (PIB0, 0x08, DMD0)
                        If (And (PRIT, 0x02))
                        {
                            If (LEqual (And (PRIT, 0x09), 0x08))
                            {
                                Store (0x08, PMD0)
                            }
                            Else
                            {
                                Store (0x0A, PMD0)
                                ShiftRight (And (PRIT, 0x0300), 0x08, Local0)
                                ShiftRight (And (PRIT, 0x3000), 0x0C, Local1)
                                Add (Local0, Local1, Local2)
                                If (LEqual (0x03, Local2))
                                {
                                    Store (0x0B, PMD0)
                                }
                                If (LEqual (0x05, Local2))
                                {
                                    Store (0x0C, PMD0)
                                }
                            }
                        }
                        Else
                        {
                            Store (One, PMD0)
                        }
                        If (And (SYNC, One))
                        {
                            Store (Or (SDT0, 0x40), DMD0)
                            If (And (ICR1, One))
                            {
                                If (And (ICR0, One))
                                {
                                    Add (DMD0, 0x02, DMD0)
                                }
                                If (And (ICR3, One))
                                {
                                    Store (0x45, DMD0)
                                }
                            }
                        }
                        Else
                        {
                            Or (Subtract (And (PMD0, 0x07), 0x02), 0x20, DMD0)
                        }
                        Return (PIB0)
                    }
                }
                Device (P_D1)
                {
                    Name (_ADR, One)
                    Method (_GTF, 0, NotSerialized)
                    {
                        Name (PIB1, Buffer (0x1C)
                        {
                            /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03, 
                            /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x10, 0x03, 
                            /* 0010 */    0x00, 0x00, 0x00, 0xB0, 0xEF, 0x00, 0x00, 0x00, 
                            /* 0018 */    0x00, 0x00, 0xB0, 0xF5
                        })
                        CreateByteField (PIB1, One, PMD1)
                        CreateByteField (PIB1, 0x08, DMD1)
                        If (And (PRIT, 0x20))
                        {
                            If (LEqual (And (PRIT, 0x90), 0x80))
                            {
                                Store (0x08, PMD1)
                            }
                            Else
                            {
                                Add (And (PSIT, 0x03), ShiftRight (And (PSIT, 0x0C), 
                                    0x02), Local0)
                                If (LEqual (0x05, Local0))
                                {
                                    Store (0x0C, PMD1)
                                }
                                Else
                                {
                                    If (LEqual (0x03, Local0))
                                    {
                                        Store (0x0B, PMD1)
                                    }
                                    Else
                                    {
                                        Store (0x0A, PMD1)
                                    }
                                }
                            }
                        }
                        Else
                        {
                            Store (One, PMD1)
                        }
                        If (And (SYNC, 0x02))
                        {
                            Store (Or (SDT1, 0x40), DMD1)
                            If (And (ICR1, 0x02))
                            {
                                If (And (ICR0, 0x02))
                                {
                                    Add (DMD1, 0x02, DMD1)
                                }
                                If (And (ICR3, 0x02))
                                {
                                    Store (0x45, DMD1)
                                }
                            }
                        }
                        Else
                        {
                            Or (Subtract (And (PMD1, 0x07), 0x02), 0x20, DMD1)
                        }
                        Return (PIB1)
                    }
                }
            }
            Device (SECD)
            {
                Name (_ADR, One)
                Method (_GTM, 0, NotSerialized)
                {
                    Name (SBUF, Buffer (0x14)
                    {
                        /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                        /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                        /* 0010 */    0x00, 0x00, 0x00, 0x00
                    })
                    CreateDWordField (SBUF, Zero, PIO0)
                    CreateDWordField (SBUF, 0x04, DMA0)
                    CreateDWordField (SBUF, 0x08, PIO1)
                    CreateDWordField (SBUF, 0x0C, DMA1)
                    CreateDWordField (SBUF, 0x10, FLAG)
                    Store (GETP (SECT), PIO0)
                    Store (GDMA (And (SYNC, 0x04), And (ICR3, 0x04), 
                        And (ICR0, 0x04), SDT2, And (ICR1, 0x04)), DMA0)
                    If (LEqual (DMA0, 0xFFFFFFFF))
                    {
                        Store (PIO0, DMA0)
                    }
                    If (And (SECT, 0x4000))
                    {
                        If (LEqual (And (SECT, 0x90), 0x80))
                        {
                            Store (0x0384, PIO1)
                        }
                        Else
                        {
                            Store (GETT (SSIT), PIO1)
                        }
                    }
                    Else
                    {
                        Store (0xFFFFFFFF, PIO1)
                    }
                    Store (GDMA (And (SYNC, 0x08), And (ICR3, 0x08), 
                        And (ICR0, 0x08), SDT3, And (ICR1, 0x08)), DMA1)
                    If (LEqual (DMA1, 0xFFFFFFFF))
                    {
                        Store (PIO1, DMA1)
                    }
                    Store (GETF (And (SYNC, 0x04), And (SYNC, 0x08), 
                        SECT), FLAG)
                    If (And (LEqual (PIO0, 0xFFFFFFFF), LEqual (DMA0, 0xFFFFFFFF)))
                    {
                        Store (0x78, PIO0)
                        Store (0x14, DMA0)
                        Store (0x03, FLAG)
                    }
                    Return (SBUF)
                }
                Method (_STM, 3, NotSerialized)
                {
                    CreateDWordField (Arg0, Zero, PIO0)
                    CreateDWordField (Arg0, 0x04, DMA0)
                    CreateDWordField (Arg0, 0x08, PIO1)
                    CreateDWordField (Arg0, 0x0C, DMA1)
                    CreateDWordField (Arg0, 0x10, FLAG)
                    If (LEqual (SizeOf (Arg1), 0x0200))
                    {
                        And (SECT, 0xC0F0, SECT)
                        And (SYNC, 0x0B, SYNC)
                        Store (Zero, SDT2)
                        And (ICR0, 0x0B, ICR0)
                        And (ICR1, 0x0B, ICR1)
                        And (ICR3, 0x0B, ICR3)
                        And (ICR5, 0x0B, ICR5)
                        CreateWordField (Arg1, 0x62, W490)
                        CreateWordField (Arg1, 0x6A, W530)
                        CreateWordField (Arg1, 0x7E, W630)
                        CreateWordField (Arg1, 0x80, W640)
                        CreateWordField (Arg1, 0xB0, W880)
                        CreateWordField (Arg1, 0xBA, W930)
                        Or (SECT, 0x8004, SECT)
                        If (LAnd (And (FLAG, 0x02), And (W490, 0x0800)))
                        {
                            Or (SECT, 0x02, SECT)
                        }
                        Or (SECT, SETP (PIO0, W530, W640), SECT)
                        If (And (FLAG, One))
                        {
                            Or (SYNC, 0x04, SYNC)
                            Store (SDMA (DMA0), SDT2)
                            If (LLess (DMA0, 0x1E))
                            {
                                Or (ICR3, 0x04, ICR3)
                            }
                            If (LLess (DMA0, 0x3C))
                            {
                                Or (ICR0, 0x04, ICR0)
                            }
                            If (And (W930, 0x2000))
                            {
                                Or (ICR1, 0x04, ICR1)
                            }
                        }
                    }
                    If (LEqual (SizeOf (Arg2), 0x0200))
                    {
                        And (SECT, 0xBF0F, SECT)
                        Store (Zero, SSIT)
                        And (SYNC, 0x07, SYNC)
                        Store (Zero, SDT3)
                        And (ICR0, 0x07, ICR0)
                        And (ICR1, 0x07, ICR1)
                        And (ICR3, 0x07, ICR3)
                        And (ICR5, 0x07, ICR5)
                        CreateWordField (Arg2, 0x62, W491)
                        CreateWordField (Arg2, 0x6A, W531)
                        CreateWordField (Arg2, 0x7E, W631)
                        CreateWordField (Arg2, 0x80, W641)
                        CreateWordField (Arg2, 0xB0, W881)
                        CreateWordField (Arg2, 0xBA, W931)
                        Or (SECT, 0x8040, SECT)
                        If (LAnd (And (FLAG, 0x08), And (W491, 0x0800)))
                        {
                            Or (SECT, 0x20, SECT)
                        }
                        If (And (FLAG, 0x10))
                        {
                            Or (SECT, 0x4000, SECT)
                            If (LGreater (PIO1, 0xF0))
                            {
                                Or (SECT, 0x80, SECT)
                            }
                            Else
                            {
                                Or (SECT, 0x10, SECT)
                                Store (SETT (PIO1, W531, W641), SSIT)
                            }
                        }
                        If (And (FLAG, 0x04))
                        {
                            Or (SYNC, 0x08, SYNC)
                            Store (SDMA (DMA1), SDT3)
                            If (LLess (DMA1, 0x1E))
                            {
                                Or (ICR3, 0x08, ICR3)
                            }
                            If (LLess (DMA1, 0x3C))
                            {
                                Or (ICR0, 0x08, ICR0)
                            }
                            If (And (W931, 0x2000))
                            {
                                Or (ICR1, 0x08, ICR1)
                            }
                        }
                    }
                }
                Device (S_D0)
                {
                    Name (_ADR, Zero)
                    Method (_GTF, 0, NotSerialized)
                    {
                        Name (SIB0, Buffer (0x1C)
                        {
                            /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03, 
                            /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 
                            /* 0010 */    0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00, 0x00, 0x00, 
                            /* 0018 */    0x00, 0x00, 0xA0, 0xF5
                        })
                        CreateByteField (SIB0, One, PMD0)
                        CreateByteField (SIB0, 0x08, DMD0)
                        If (And (SECT, 0x02))
                        {
                            If (LEqual (And (SECT, 0x09), 0x08))
                            {
                                Store (0x08, PMD0)
                            }
                            Else
                            {
                                Store (0x0A, PMD0)
                                ShiftRight (And (SECT, 0x0300), 0x08, Local0)
                                ShiftRight (And (SECT, 0x3000), 0x0C, Local1)
                                Add (Local0, Local1, Local2)
                                If (LEqual (0x03, Local2))
                                {
                                    Store (0x0B, PMD0)
                                }
                                If (LEqual (0x05, Local2))
                                {
                                    Store (0x0C, PMD0)
                                }
                            }
                        }
                        Else
                        {
                            Store (One, PMD0)
                        }
                        If (And (SYNC, 0x04))
                        {
                            Store (Or (SDT2, 0x40), DMD0)
                            If (And (ICR1, 0x04))
                            {
                                If (And (ICR0, 0x04))
                                {
                                    Add (DMD0, 0x02, DMD0)
                                }
                                If (And (ICR3, 0x04))
                                {
                                    Store (0x45, DMD0)
                                }
                            }
                        }
                        Else
                        {
                            Or (Subtract (And (PMD0, 0x07), 0x02), 0x20, DMD0)
                        }
                        Return (SIB0)
                    }
                }
                Device (S_D1)
                {
                    Name (_ADR, One)
                    Method (_GTF, 0, NotSerialized)
                    {
                        Name (SIB1, Buffer (0x1C)
                        {
                            /* 0000 */    0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03, 
                            /* 0008 */    0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x10, 0x03, 
                            /* 0010 */    0x00, 0x00, 0x00, 0xB0, 0xEF, 0x00, 0x00, 0x00, 
                            /* 0018 */    0x00, 0x00, 0xB0, 0xF5
                        })
                        CreateByteField (SIB1, One, PMD1)
                        CreateByteField (SIB1, 0x08, DMD1)
                        If (And (SECT, 0x20))
                        {
                            If (LEqual (And (SECT, 0x90), 0x80))
                            {
                                Store (0x08, PMD1)
                            }
                            Else
                            {
                                Add (And (SSIT, 0x03), ShiftRight (And (SSIT, 0x0C), 
                                    0x02), Local0)
                                If (LEqual (0x05, Local0))
                                {
                                    Store (0x0C, PMD1)
                                }
                                Else
                                {
                                    If (LEqual (0x03, Local0))
                                    {
                                        Store (0x0B, PMD1)
                                    }
                                    Else
                                    {
                                        Store (0x0A, PMD1)
                                    }
                                }
                            }
                        }
                        Else
                        {
                            Store (One, PMD1)
                        }
                        If (And (SYNC, 0x08))
                        {
                            Store (Or (SDT3, 0x40), DMD1)
                            If (And (ICR1, 0x08))
                            {
                                If (And (ICR0, 0x08))
                                {
                                    Add (DMD1, 0x02, DMD1)
                                }
                                If (And (ICR3, 0x08))
                                {
                                    Store (0x45, DMD1)
                                }
                            }
                        }
                        Else
                        {
                            Or (Subtract (And (PMD1, 0x07), 0x02), 0x20, DMD1)
                        }
                        Return (SIB1)
                    }
                }
            }
        }
        Device (SAT1)
        {
            Name (_ADR, 0x001F0005)
            OperationRegion (SACS, PCI_Config, 0x40, 0xC0)
            Field (SACS, DWordAcc, NoLock, Preserve)
            {
                PRIT,   16, 
                SECT,   16, 
                PSIT,   4, 
                SSIT,   4, 
                        Offset (0x08), 
                SYNC,   4, 
                        Offset (0x0A), 
                SDT0,   2, 
                    ,   2, 
                SDT1,   2, 
                        Offset (0x0B), 
                SDT2,   2, 
                    ,   2, 
                SDT3,   2, 
                        Offset (0x14), 
                ICR0,   4, 
                ICR1,   4, 
                ICR2,   4, 
                ICR3,   4, 
                ICR4,   4, 
                ICR5,   4, 
                        Offset (0x34), 
                HDPS,   2, 
                        Offset (0x50), 
                MAPV,   2
            }
            Name (_PSC, Zero)
            Method (_PS0, 0, NotSerialized)
            {
                Store (Zero, _PSC)
            }
            Method (_PS3, 0, NotSerialized)
            {
                Store (Zero, HDPS)
                Store (Zero, _PSC)
            }
        }
        Device (SBUS)
        {
            Name (_ADR, 0x001F0003)
            OperationRegion (SMBP, PCI_Config, 0x40, 0xC0)
            Field (SMBP, DWordAcc, NoLock, Preserve)
            {
                    ,   2, 
                I2CE,   1
            }
            OperationRegion (SMPB, PCI_Config, 0x20, 0x04)
            Field (SMPB, DWordAcc, NoLock, Preserve)
            {
                    ,   5, 
                SBAR,   11
            }
            OperationRegion (SMBI, SystemIO, ShiftLeft (SBAR, 0x05), 0x10)
            Field (SMBI, ByteAcc, NoLock, Preserve)
            {
                HSTS,   8, 
                        Offset (0x02), 
                HCON,   8, 
                HCOM,   8, 
                TXSA,   8, 
                DAT0,   8, 
                DAT1,   8, 
                HBDR,   8, 
                PECR,   8, 
                RXSA,   8, 
                SDAT,   16
            }
            Method (SSXB, 2, Serialized)
            {
                If (STRT ())
                {
                    Return (Zero)
                }
                Store (Zero, I2CE)
                Store (0xBF, HSTS)
                Store (Arg0, TXSA)
                Store (Arg1, HCOM)
                Store (0x48, HCON)
                If (COMP ())
                {
                    Or (HSTS, 0xFF, HSTS)
                    Return (One)
                }
                Return (Zero)
            }
            Method (SRXB, 1, Serialized)
            {
                If (STRT ())
                {
                    Return (0xFFFF)
                }
                Store (Zero, I2CE)
                Store (0xBF, HSTS)
                Store (Or (Arg0, One), TXSA)
                Store (0x44, HCON)
                If (COMP ())
                {
                    Or (HSTS, 0xFF, HSTS)
                    Return (DAT0)
                }
                Return (0xFFFF)
            }
            Method (SWRB, 3, Serialized)
            {
                If (STRT ())
                {
                    Return (Zero)
                }
                Store (Zero, I2CE)
                Store (0xBF, HSTS)
                Store (Arg0, TXSA)
                Store (Arg1, HCOM)
                Store (Arg2, DAT0)
                Store (0x48, HCON)
                If (COMP ())
                {
                    Or (HSTS, 0xFF, HSTS)
                    Return (One)
                }
                Return (Zero)
            }
            Method (SRDB, 2, Serialized)
            {
                If (STRT ())
                {
                    Return (0xFFFF)
                }
                Store (Zero, I2CE)
                Store (0xBF, HSTS)
                Store (Or (Arg0, One), TXSA)
                Store (Arg1, HCOM)
                Store (0x48, HCON)
                If (COMP ())
                {
                    Or (HSTS, 0xFF, HSTS)
                    Return (DAT0)
                }
                Return (0xFFFF)
            }
            Method (SWRW, 3, Serialized)
            {
                If (STRT ())
                {
                    Return (Zero)
                }
                Store (Zero, I2CE)
                Store (0xBF, HSTS)
                Store (Arg0, TXSA)
                Store (Arg1, HCOM)
                And (Arg2, 0xFF, DAT1)
                And (ShiftRight (Arg2, 0x08), 0xFF, DAT0)
                Store (0x4C, HCON)
                If (COMP ())
                {
                    Or (HSTS, 0xFF, HSTS)
                    Return (One)
                }
                Return (Zero)
            }
            Method (SRDW, 2, Serialized)
            {
                If (STRT ())
                {
                    Return (0xFFFF)
                }
                Store (Zero, I2CE)
                Store (0xBF, HSTS)
                Store (Or (Arg0, One), TXSA)
                Store (Arg1, HCOM)
                Store (0x4C, HCON)
                If (COMP ())
                {
                    Or (HSTS, 0xFF, HSTS)
                    Return (Or (ShiftLeft (DAT0, 0x08), DAT1))
                }
                Return (0xFFFFFFFF)
            }
            Method (SBLW, 4, Serialized)
            {
                If (STRT ())
                {
                    Return (Zero)
                }
                Store (Arg3, I2CE)
                Store (0xBF, HSTS)
                Store (Arg0, TXSA)
                Store (Arg1, HCOM)
                Store (SizeOf (Arg2), DAT0)
                Store (Zero, Local1)
                Store (DerefOf (Index (Arg2, Zero)), HBDR)
                Store (0x54, HCON)
                While (LGreater (SizeOf (Arg2), Local1))
                {
                    Store (0x0FA0, Local0)
                    While (LAnd (LNot (And (HSTS, 0x80)), Local0))
                    {
                        Decrement (Local0)
                        Stall (0x32)
                    }
                    If (LNot (Local0))
                    {
                        KILL ()
                        Return (Zero)
                    }
                    Store (0x80, HSTS)
                    Increment (Local1)
                    If (LGreater (SizeOf (Arg2), Local1))
                    {
                        Store (DerefOf (Index (Arg2, Local1)), HBDR)
                    }
                }
                If (COMP ())
                {
                    Or (HSTS, 0xFF, HSTS)
                    Return (One)
                }
                Return (Zero)
            }
            Method (SBLR, 3, Serialized)
            {
                Name (TBUF, Buffer (0x0100) {})
                If (STRT ())
                {
                    Return (Zero)
                }
                Store (Arg2, I2CE)
                Store (0xBF, HSTS)
                Store (Or (Arg0, One), TXSA)
                Store (Arg1, HCOM)
                Store (0x54, HCON)
                Store (0x0FA0, Local0)
                While (LAnd (LNot (And (HSTS, 0x80)), Local0))
                {
                    Decrement (Local0)
                    Stall (0x32)
                }
                If (LNot (Local0))
                {
                    KILL ()
                    Return (Zero)
                }
                Store (DAT0, Index (TBUF, Zero))
                Store (0x80, HSTS)
                Store (One, Local1)
                While (LLess (Local1, DerefOf (Index (TBUF, Zero))))
                {
                    Store (0x0FA0, Local0)
                    While (LAnd (LNot (And (HSTS, 0x80)), Local0))
                    {
                        Decrement (Local0)
                        Stall (0x32)
                    }
                    If (LNot (Local0))
                    {
                        KILL ()
                        Return (Zero)
                    }
                    Store (HBDR, Index (TBUF, Local1))
                    Store (0x80, HSTS)
                    Increment (Local1)
                }
                If (COMP ())
                {
                    Or (HSTS, 0xFF, HSTS)
                    Return (TBUF)
                }
                Return (Zero)
            }
            Method (STRT, 0, Serialized)
            {
                Store (0xC8, Local0)
                While (Local0)
                {
                    If (And (HSTS, 0x40))
                    {
                        Decrement (Local0)
                        Sleep (One)
                        If (LEqual (Local0, Zero))
                        {
                            Return (One)
                        }
                    }
                    Else
                    {
                        Store (Zero, Local0)
                    }
                }
                Store (0x0FA0, Local0)
                While (Local0)
                {
                    If (And (HSTS, One))
                    {
                        Decrement (Local0)
                        Stall (0x32)
                        If (LEqual (Local0, Zero))
                        {
                            KILL ()
                        }
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
                Return (One)
            }
            Method (COMP, 0, Serialized)
            {
                Store (0x0FA0, Local0)
                While (Local0)
                {
                    If (And (HSTS, 0x02))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Decrement (Local0)
                        Stall (0x32)
                        If (LEqual (Local0, Zero))
                        {
                            KILL ()
                        }
                    }
                }
                Return (Zero)
            }
            Method (KILL, 0, Serialized)
            {
                Or (HCON, 0x02, HCON)
                Or (HSTS, 0xFF, HSTS)
            }
        }
    }
    Scope (_SB.PCI0)
    {
        Device (PEG0)
        {
            Name (_ADR, 0x00010000)
            Method (_PRW, 0, NotSerialized)
            {
                Return (GPRW (0x09, 0x04))
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR02 ())
                }
                Return (PR02 ())
            }
            Device (PEGP)
            {
                Name (_ADR, Zero)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
            }
        }
        Device (PEG1)
        {
            Name (_ADR, 0x00010001)
            Method (_PRW, 0, NotSerialized)
            {
                Return (GPRW (0x09, 0x04))
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR0A ())
                }
                Return (PR0A ())
            }
        }
        Device (PEG2)
        {
            Name (_ADR, 0x00010002)
            Method (_PRW, 0, NotSerialized)
            {
                Return (GPRW (0x09, 0x04))
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR0B ())
                }
                Return (PR0B ())
            }
        }
        Device (PEG3)
        {
            Name (_ADR, 0x00060000)
            Method (_PRW, 0, NotSerialized)
            {
                Return (GPRW (0x09, 0x04))
            }
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR0C)
                }
                Return (PR0C)
            }
        }
        Device (B0D4)
        {
            Name (_ADR, 0x00040000)
        }
        Device (GFX0)
        {
            Name (_ADR, 0x00020000)
            Method (_DOS, 1, NotSerialized)
            {
                Store (And (Arg0, 0x07), DSEN)
                If (LEqual (And (Arg0, 0x03), Zero))
                {
                    If (CondRefOf (HDOS))
                    {
                        HDOS ()
                    }
                }
            }
            Method (_DOD, 0, NotSerialized)
            {
                If (CondRefOf (IDAB))
                {
                    IDAB ()
                }
                Else
                {
                    Store (Zero, NDID)
                    If (LNotEqual (DIDL, Zero))
                    {
                        Store (SDDL (DIDL), DID1)
                    }
                    If (LNotEqual (DDL2, Zero))
                    {
                        Store (SDDL (DDL2), DID2)
                    }
                    If (LNotEqual (DDL3, Zero))
                    {
                        Store (SDDL (DDL3), DID3)
                    }
                    If (LNotEqual (DDL4, Zero))
                    {
                        Store (SDDL (DDL4), DID4)
                    }
                    If (LNotEqual (DDL5, Zero))
                    {
                        Store (SDDL (DDL5), DID5)
                    }
                    If (LNotEqual (DDL6, Zero))
                    {
                        Store (SDDL (DDL6), DID6)
                    }
                    If (LNotEqual (DDL7, Zero))
                    {
                        Store (SDDL (DDL7), DID7)
                    }
                    If (LNotEqual (DDL8, Zero))
                    {
                        Store (SDDL (DDL8), DID8)
                    }
                }
                If (LEqual (NDID, One))
                {
                    Name (TMP1, Package (0x01)
                    {
                        0xFFFFFFFF
                    })
                    Store (Or (0x00010000, DID1), Index (TMP1, Zero))
                    Return (TMP1)
                }
                If (LEqual (NDID, 0x02))
                {
                    Name (TMP2, Package (0x02)
                    {
                        0xFFFFFFFF, 
                        0xFFFFFFFF
                    })
                    Store (Or (0x00010000, DID1), Index (TMP2, Zero))
                    Store (Or (0x00010000, DID2), Index (TMP2, One))
                    Return (TMP2)
                }
                If (LEqual (NDID, 0x03))
                {
                    Name (TMP3, Package (0x03)
                    {
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF
                    })
                    Store (Or (0x00010000, DID1), Index (TMP3, Zero))
                    Store (Or (0x00010000, DID2), Index (TMP3, One))
                    Store (Or (0x00010000, DID3), Index (TMP3, 0x02))
                    Return (TMP3)
                }
                If (LEqual (NDID, 0x04))
                {
                    Name (TMP4, Package (0x04)
                    {
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF
                    })
                    Store (Or (0x00010000, DID1), Index (TMP4, Zero))
                    Store (Or (0x00010000, DID2), Index (TMP4, One))
                    Store (Or (0x00010000, DID3), Index (TMP4, 0x02))
                    Store (Or (0x00010000, DID4), Index (TMP4, 0x03))
                    Return (TMP4)
                }
                If (LEqual (NDID, 0x05))
                {
                    Name (TMP5, Package (0x05)
                    {
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF
                    })
                    Store (Or (0x00010000, DID1), Index (TMP5, Zero))
                    Store (Or (0x00010000, DID2), Index (TMP5, One))
                    Store (Or (0x00010000, DID3), Index (TMP5, 0x02))
                    Store (Or (0x00010000, DID4), Index (TMP5, 0x03))
                    Store (Or (0x00010000, DID5), Index (TMP5, 0x04))
                    Return (TMP5)
                }
                If (LEqual (NDID, 0x06))
                {
                    Name (TMP6, Package (0x06)
                    {
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF
                    })
                    Store (Or (0x00010000, DID1), Index (TMP6, Zero))
                    Store (Or (0x00010000, DID2), Index (TMP6, One))
                    Store (Or (0x00010000, DID3), Index (TMP6, 0x02))
                    Store (Or (0x00010000, DID4), Index (TMP6, 0x03))
                    Store (Or (0x00010000, DID5), Index (TMP6, 0x04))
                    Store (Or (0x00010000, DID6), Index (TMP6, 0x05))
                    Return (TMP6)
                }
                If (LEqual (NDID, 0x07))
                {
                    Name (TMP7, Package (0x07)
                    {
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF
                    })
                    Store (Or (0x00010000, DID1), Index (TMP7, Zero))
                    Store (Or (0x00010000, DID2), Index (TMP7, One))
                    Store (Or (0x00010000, DID3), Index (TMP7, 0x02))
                    Store (Or (0x00010000, DID4), Index (TMP7, 0x03))
                    Store (Or (0x00010000, DID5), Index (TMP7, 0x04))
                    Store (Or (0x00010000, DID6), Index (TMP7, 0x05))
                    Store (Or (0x00010000, DID7), Index (TMP7, 0x06))
                    Return (TMP7)
                }
                If (LEqual (NDID, 0x08))
                {
                    Name (TMP8, Package (0x08)
                    {
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF, 
                        0xFFFFFFFF
                    })
                    Store (Or (0x00010000, DID1), Index (TMP8, Zero))
                    Store (Or (0x00010000, DID2), Index (TMP8, One))
                    Store (Or (0x00010000, DID3), Index (TMP8, 0x02))
                    Store (Or (0x00010000, DID4), Index (TMP8, 0x03))
                    Store (Or (0x00010000, DID5), Index (TMP8, 0x04))
                    Store (Or (0x00010000, DID6), Index (TMP8, 0x05))
                    Store (Or (0x00010000, DID7), Index (TMP8, 0x06))
                    Store (Or (0x00010000, DID8), Index (TMP8, 0x07))
                    Return (TMP8)
                }
                If (LEqual (NDID, 0x09))
                {
                    If (CondRefOf (HWID))
                    {
                        Return (HWID)
                    }
                }
                Return (Package (0x01)
                {
                    0x0400
                })
            }
            Device (DD01)
            {
                Method (_ADR, 0, Serialized)
                {
                    If (LEqual (DID1, Zero))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (And (0xFFFF, DID1))
                    }
                }
                Method (_DCS, 0, NotSerialized)
                {
                    Return (CDDS (DID1))
                }
                Method (_DGS, 0, NotSerialized)
                {
                    If (LAnd (LEqual (And (SGMD, One), One), CondRefOf (SNXD
                        )))
                    {
                        Return (NXD1)
                    }
                    Return (NDDS (DID1))
                }
                Method (_DSS, 1, NotSerialized)
                {
                    If (LEqual (And (Arg0, 0xC0000000), 0xC0000000))
                    {
                        Store (NSTE, CSTE)
                    }
                }
            }
            Device (DD02)
            {
                Method (_ADR, 0, Serialized)
                {
                    If (LEqual (DID2, Zero))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (And (0xFFFF, DID2))
                    }
                }
                Method (_DCS, 0, NotSerialized)
                {
                    If (LEqual (LIDS, Zero))
                    {
                        Return (Zero)
                    }
                    Return (CDDS (DID2))
                }
                Method (_DGS, 0, NotSerialized)
                {
                    If (LAnd (LEqual (And (SGMD, One), One), CondRefOf (SNXD
                        )))
                    {
                        Return (NXD2)
                    }
                    Return (NDDS (DID2))
                }
                Method (_DSS, 1, NotSerialized)
                {
                    If (LEqual (And (Arg0, 0xC0000000), 0xC0000000))
                    {
                        Store (NSTE, CSTE)
                    }
                }
                Method (_BCL, 0, NotSerialized)
                {
                    Return (Package (0x12)
                    {
                        0x64, 
                        0x23, 
                        0x14, 
                        0x19, 
                        0x1E, 
                        0x23, 
                        0x28, 
                        0x2D, 
                        0x32, 
                        0x37, 
                        0x3C, 
                        0x41, 
                        0x46, 
                        0x4B, 
                        0x50, 
                        0x55, 
                        0x5A, 
                        0x64
                    })
                }
                Method (_BCM, 1, NotSerialized)
                {
                    If (LAnd (LGreaterEqual (Arg0, Zero), LLessEqual (Arg0, 0x64)))
                    {
                        IBCM (Arg0)
                        UCMS (0x14)
                        ^^^LPCB.EC.BLCL ()
                        Store (Arg0, BRTL)
                    }
                }
                Method (_BQC, 0, NotSerialized)
                {
                    Return (BRTL)
                }
                Method (_DDC, 1, NotSerialized)
                {
                    If (LEqual (Arg0, One))
                    {
                        Return (VEDI)
                    }
                    Else
                    {
                        If (LEqual (Arg0, 0x02))
                        {
                            Return (VEDI)
                        }
                    }
                    Return (Zero)
                }
            }
            Device (DD03)
            {
                Method (_ADR, 0, Serialized)
                {
                    If (LEqual (DID3, Zero))
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (And (0xFFFF, DID3))
                    }
                }
                Method (_DCS, 0, NotSerialized)
                {
                    If (LEqual (DID3, Zero))
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (CDDS (DID3))
                    }
                }
                Method (_DGS, 0, NotSerialized)
                {
                    If (LAnd (LEqual (And (SGMD, One), One), CondRefOf (SNXD
                        )))
                    {
                        Return (NXD3)
                    }
                    Return (NDDS (DID3))
                }
                Method (_DSS, 1, NotSerialized)
                {
                    If (LEqual (And (Arg0, 0xC0000000), 0xC0000000))
                    {
                        Store (NSTE, CSTE)
                    }
                }
            }
            Device (DD04)
            {
                Method (_ADR, 0, Serialized)
                {
                    If (LEqual (DID4, Zero))
                    {
                        Return (0x04)
                    }
                    Else
                    {
                        Return (And (0xFFFF, DID4))
                    }
                }
                Method (_DCS, 0, NotSerialized)
                {
                    If (LEqual (DID4, Zero))
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (CDDS (DID4))
                    }
                }
                Method (_DGS, 0, NotSerialized)
                {
                    If (LAnd (LEqual (And (SGMD, One), One), CondRefOf (SNXD
                        )))
                    {
                        Return (NXD4)
                    }
                    Return (NDDS (DID4))
                }
                Method (_DSS, 1, NotSerialized)
                {
                    If (LEqual (And (Arg0, 0xC0000000), 0xC0000000))
                    {
                        Store (NSTE, CSTE)
                    }
                }
            }
            Device (DD05)
            {
                Method (_ADR, 0, Serialized)
                {
                    If (LEqual (DID5, Zero))
                    {
                        Return (0x05)
                    }
                    Else
                    {
                        Return (And (0xFFFF, DID5))
                    }
                }
                Method (_DCS, 0, NotSerialized)
                {
                    If (LEqual (DID5, Zero))
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (CDDS (DID5))
                    }
                }
                Method (_DGS, 0, NotSerialized)
                {
                    If (LAnd (LEqual (And (SGMD, One), One), CondRefOf (SNXD
                        )))
                    {
                        Return (NXD5)
                    }
                    Return (NDDS (DID5))
                }
                Method (_DSS, 1, NotSerialized)
                {
                    If (LEqual (And (Arg0, 0xC0000000), 0xC0000000))
                    {
                        Store (NSTE, CSTE)
                    }
                }
            }
            Device (DD06)
            {
                Method (_ADR, 0, Serialized)
                {
                    If (LEqual (DID6, Zero))
                    {
                        Return (0x06)
                    }
                    Else
                    {
                        Return (And (0xFFFF, DID6))
                    }
                }
                Method (_DCS, 0, NotSerialized)
                {
                    If (LEqual (DID6, Zero))
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (CDDS (DID6))
                    }
                }
                Method (_DGS, 0, NotSerialized)
                {
                    If (LAnd (LEqual (And (SGMD, One), One), CondRefOf (SNXD
                        )))
                    {
                        Return (NXD6)
                    }
                    Return (NDDS (DID6))
                }
                Method (_DSS, 1, NotSerialized)
                {
                    If (LEqual (And (Arg0, 0xC0000000), 0xC0000000))
                    {
                        Store (NSTE, CSTE)
                    }
                }
            }
            Device (DD07)
            {
                Method (_ADR, 0, Serialized)
                {
                    If (LEqual (DID7, Zero))
                    {
                        Return (0x07)
                    }
                    Else
                    {
                        Return (And (0xFFFF, DID7))
                    }
                }
                Method (_DCS, 0, NotSerialized)
                {
                    If (LEqual (DID7, Zero))
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (CDDS (DID7))
                    }
                }
                Method (_DGS, 0, NotSerialized)
                {
                    If (LAnd (LEqual (And (SGMD, One), One), CondRefOf (SNXD
                        )))
                    {
                        Return (NXD7)
                    }
                    Return (NDDS (DID7))
                }
                Method (_DSS, 1, NotSerialized)
                {
                    If (LEqual (And (Arg0, 0xC0000000), 0xC0000000))
                    {
                        Store (NSTE, CSTE)
                    }
                }
            }
            Device (DD08)
            {
                Method (_ADR, 0, Serialized)
                {
                    If (LEqual (DID8, Zero))
                    {
                        Return (0x08)
                    }
                    Else
                    {
                        Return (And (0xFFFF, DID8))
                    }
                }
                Method (_DCS, 0, NotSerialized)
                {
                    If (LEqual (DID8, Zero))
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (CDDS (DID8))
                    }
                }
                Method (_DGS, 0, NotSerialized)
                {
                    If (LAnd (LEqual (And (SGMD, One), One), CondRefOf (SNXD
                        )))
                    {
                        Return (NXD8)
                    }
                    Return (NDDS (DID8))
                }
                Method (_DSS, 1, NotSerialized)
                {
                    If (LEqual (And (Arg0, 0xC0000000), 0xC0000000))
                    {
                        Store (NSTE, CSTE)
                    }
                }
            }
            Method (SDDL, 1, NotSerialized)
            {
                Increment (NDID)
                Store (And (Arg0, 0x0F0F), Local0)
                Or (0x80000000, Local0, Local1)
                If (LEqual (DIDL, Local0))
                {
                    Return (Local1)
                }
                If (LEqual (DDL2, Local0))
                {
                    Return (Local1)
                }
                If (LEqual (DDL3, Local0))
                {
                    Return (Local1)
                }
                If (LEqual (DDL4, Local0))
                {
                    Return (Local1)
                }
                If (LEqual (DDL5, Local0))
                {
                    Return (Local1)
                }
                If (LEqual (DDL6, Local0))
                {
                    Return (Local1)
                }
                If (LEqual (DDL7, Local0))
                {
                    Return (Local1)
                }
                If (LEqual (DDL8, Local0))
                {
                    Return (Local1)
                }
                Return (Zero)
            }
            Method (CDDS, 1, NotSerialized)
            {
                Store (And (Arg0, 0x0F0F), Local0)
                If (LEqual (Zero, Local0))
                {
                    Return (0x1D)
                }
                If (LEqual (CADL, Local0))
                {
                    Return (0x1F)
                }
                If (LEqual (CAL2, Local0))
                {
                    Return (0x1F)
                }
                If (LEqual (CAL3, Local0))
                {
                    Return (0x1F)
                }
                If (LEqual (CAL4, Local0))
                {
                    Return (0x1F)
                }
                If (LEqual (CAL5, Local0))
                {
                    Return (0x1F)
                }
                If (LEqual (CAL6, Local0))
                {
                    Return (0x1F)
                }
                If (LEqual (CAL7, Local0))
                {
                    Return (0x1F)
                }
                If (LEqual (CAL8, Local0))
                {
                    Return (0x1F)
                }
                Return (0x1D)
            }
            Method (NDDS, 1, NotSerialized)
            {
                Store (And (Arg0, 0x0F0F), Local0)
                If (LEqual (Zero, Local0))
                {
                    Return (Zero)
                }
                If (LEqual (NADL, Local0))
                {
                    Return (One)
                }
                If (LEqual (NDL2, Local0))
                {
                    Return (One)
                }
                If (LEqual (NDL3, Local0))
                {
                    Return (One)
                }
                If (LEqual (NDL4, Local0))
                {
                    Return (One)
                }
                If (LEqual (NDL5, Local0))
                {
                    Return (One)
                }
                If (LEqual (NDL6, Local0))
                {
                    Return (One)
                }
                If (LEqual (NDL7, Local0))
                {
                    Return (One)
                }
                If (LEqual (NDL8, Local0))
                {
                    Return (One)
                }
                Return (Zero)
            }
            Scope (^^PCI0)
            {
                OperationRegion (MCHP, PCI_Config, 0x40, 0xC0)
                Field (MCHP, AnyAcc, NoLock, Preserve)
                {
                            Offset (0x60), 
                    TASM,   10, 
                            Offset (0x62)
                }
            }
            OperationRegion (IGDP, PCI_Config, 0x40, 0xC0)
            Field (IGDP, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x12), 
                    ,   1, 
                GIVD,   1, 
                    ,   2, 
                GUMA,   3, 
                        Offset (0x14), 
                    ,   4, 
                GMFN,   1, 
                        Offset (0x18), 
                        Offset (0xA4), 
                ASLE,   8, 
                        Offset (0xA8), 
                GSSE,   1, 
                GSSB,   14, 
                GSES,   1, 
                        Offset (0xB0), 
                    ,   12, 
                CDVL,   1, 
                        Offset (0xB2), 
                        Offset (0xB5), 
                LBPC,   8, 
                        Offset (0xBC), 
                ASLS,   32
            }
            OperationRegion (IGDM, SystemMemory, ASLB, 0x2000)
            Field (IGDM, AnyAcc, NoLock, Preserve)
            {
                SIGN,   128, 
                SIZE,   32, 
                OVER,   32, 
                SVER,   256, 
                VVER,   128, 
                GVER,   128, 
                MBOX,   32, 
                DMOD,   32, 
                        Offset (0x100), 
                DRDY,   32, 
                CSTS,   32, 
                CEVT,   32, 
                        Offset (0x120), 
                DIDL,   32, 
                DDL2,   32, 
                DDL3,   32, 
                DDL4,   32, 
                DDL5,   32, 
                DDL6,   32, 
                DDL7,   32, 
                DDL8,   32, 
                CPDL,   32, 
                CPL2,   32, 
                CPL3,   32, 
                CPL4,   32, 
                CPL5,   32, 
                CPL6,   32, 
                CPL7,   32, 
                CPL8,   32, 
                CADL,   32, 
                CAL2,   32, 
                CAL3,   32, 
                CAL4,   32, 
                CAL5,   32, 
                CAL6,   32, 
                CAL7,   32, 
                CAL8,   32, 
                NADL,   32, 
                NDL2,   32, 
                NDL3,   32, 
                NDL4,   32, 
                NDL5,   32, 
                NDL6,   32, 
                NDL7,   32, 
                NDL8,   32, 
                ASLP,   32, 
                TIDX,   32, 
                CHPD,   32, 
                CLID,   32, 
                CDCK,   32, 
                SXSW,   32, 
                EVTS,   32, 
                CNOT,   32, 
                NRDY,   32, 
                        Offset (0x200), 
                SCIE,   1, 
                GEFC,   4, 
                GXFC,   3, 
                GESF,   8, 
                        Offset (0x204), 
                PARM,   32, 
                DSLP,   32, 
                        Offset (0x300), 
                ARDY,   32, 
                ASLC,   32, 
                TCHE,   32, 
                ALSI,   32, 
                BCLP,   32, 
                PFIT,   32, 
                CBLV,   32, 
                BCLM,   320, 
                CPFM,   32, 
                EPFM,   32, 
                PLUT,   592, 
                PFMB,   32, 
                CCDV,   32, 
                PCFT,   32, 
                        Offset (0x400), 
                GVD1,   49152, 
                PHED,   32, 
                BDDC,   2048
            }
            Name (DBTB, Package (0x15)
            {
                Zero, 
                0x07, 
                0x38, 
                0x01C0, 
                0x0E00, 
                0x3F, 
                0x01C7, 
                0x0E07, 
                0x01F8, 
                0x0E38, 
                0x0FC0, 
                Zero, 
                Zero, 
                Zero, 
                Zero, 
                Zero, 
                0x7000, 
                0x7007, 
                0x7038, 
                0x71C0, 
                0x7E00
            })
            Name (CDCT, Package (0x05)
            {
                Package (0x02)
                {
                    0xE4, 
                    0x0140
                }, 
                Package (0x02)
                {
                    0xDE, 
                    0x014D
                }, 
                Package (0x02)
                {
                    0xDE, 
                    0x014D
                }, 
                Package (0x02)
                {
                    Zero, 
                    Zero
                }, 
                Package (0x02)
                {
                    0xDE, 
                    0x014D
                }
            })
            Name (SUCC, One)
            Name (NVLD, 0x02)
            Name (CRIT, 0x04)
            Name (NCRT, 0x06)
            Method (GSCI, 0, Serialized)
            {
                Method (GBDA, 0, Serialized)
                {
                    If (LEqual (GESF, Zero))
                    {
                        Store (0x0679, PARM)
                        Store (Zero, GESF)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, One))
                    {
                        Store (0x0240, PARM)
                        Store (Zero, GESF)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x04))
                    {
                        And (PARM, 0xEFFF0000, PARM)
                        And (PARM, ShiftLeft (DerefOf (Index (DBTB, IBTT)), 0x10), 
                            PARM)
                        Or (IBTT, PARM, PARM)
                        Store (Zero, GESF)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x05))
                    {
                        Store (IPSC, PARM)
                        Or (PARM, ShiftLeft (IPAT, 0x08), PARM)
                        Add (PARM, 0x0100, PARM)
                        Or (PARM, ShiftLeft (LIDS, 0x10), PARM)
                        Add (PARM, 0x00010000, PARM)
                        Or (PARM, ShiftLeft (IBIA, 0x14), PARM)
                        Store (Zero, GESF)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x06))
                    {
                        Store (ITVF, PARM)
                        Or (PARM, ShiftLeft (ITVM, 0x04), PARM)
                        Store (Zero, GESF)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x07))
                    {
                        Store (GIVD, PARM)
                        XOr (PARM, One, PARM)
                        Or (PARM, ShiftLeft (GMFN, One), PARM)
                        Or (PARM, 0x1800, PARM)
                        Or (PARM, ShiftLeft (IDMS, 0x11), PARM)
                        Or (ShiftLeft (DerefOf (Index (DerefOf (Index (CDCT, HVCO)), CDVL
                            )), 0x15), PARM, PARM)
                        Store (One, GESF)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x0A))
                    {
                        Store (Zero, PARM)
                        If (ISSC)
                        {
                            Or (PARM, 0x03, PARM)
                        }
                        Store (Zero, GESF)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x0B))
                    {
                        Store (KSV0, PARM)
                        Store (KSV1, GESF)
                        Return (SUCC)
                    }
                    Store (Zero, GESF)
                    Return (CRIT)
                }
                Method (SBCB, 0, Serialized)
                {
                    If (LEqual (GESF, Zero))
                    {
                        Store (Zero, PARM)
                        Store (0x000F87FD, PARM)
                        Store (Zero, GESF)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, One))
                    {
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x03))
                    {
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x04))
                    {
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x05))
                    {
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x06))
                    {
                        Store (And (PARM, 0x0F), ITVF)
                        Store (ShiftRight (And (PARM, 0xF0), 0x04), ITVM)
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x07))
                    {
                        If (LEqual (PARM, Zero))
                        {
                            Store (CLID, Local0)
                            If (And (0x80000000, Local0))
                            {
                                And (CLID, 0x0F, CLID)
                                GLID (CLID)
                            }
                        }
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x08))
                    {
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x09))
                    {
                        And (PARM, 0xFF, IBTT)
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x0A))
                    {
                        And (PARM, 0xFF, IPSC)
                        If (And (ShiftRight (PARM, 0x08), 0xFF))
                        {
                            And (ShiftRight (PARM, 0x08), 0xFF, IPAT)
                            Decrement (IPAT)
                        }
                        And (ShiftRight (PARM, 0x14), 0x07, IBIA)
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x0B))
                    {
                        And (ShiftRight (PARM, One), One, IF1E)
                        If (And (PARM, 0x0001E000))
                        {
                            And (ShiftRight (PARM, 0x0D), 0x0F, IDMS)
                        }
                        Else
                        {
                            And (ShiftRight (PARM, 0x11), 0x0F, IDMS)
                        }
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x10))
                    {
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x11))
                    {
                        Store (ShiftLeft (LIDS, 0x08), PARM)
                        Add (PARM, 0x0100, PARM)
                        Store (Zero, GESF)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x12))
                    {
                        If (And (PARM, One))
                        {
                            If (LEqual (ShiftRight (PARM, One), One))
                            {
                                Store (One, ISSC)
                            }
                            Else
                            {
                                Store (Zero, GESF)
                                Return (CRIT)
                            }
                        }
                        Else
                        {
                            Store (Zero, ISSC)
                        }
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x13))
                    {
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    If (LEqual (GESF, 0x14))
                    {
                        And (PARM, 0x0F, PAVP)
                        Store (Zero, GESF)
                        Store (Zero, PARM)
                        Return (SUCC)
                    }
                    Store (Zero, GESF)
                    Return (SUCC)
                }
                If (LEqual (GEFC, 0x04))
                {
                    Store (GBDA (), GXFC)
                }
                If (LEqual (GEFC, 0x06))
                {
                    Store (SBCB (), GXFC)
                }
                Store (Zero, GEFC)
                Store (One, SCIS)
                Store (Zero, GSSE)
                Store (Zero, SCIE)
                Return (Zero)
            }
            Method (PDRD, 0, NotSerialized)
            {
                If (LNot (DRDY))
                {
                    Sleep (ASLP)
                }
                Return (LNot (DRDY))
            }
            Method (PSTS, 0, NotSerialized)
            {
                If (LGreater (CSTS, 0x02))
                {
                    Sleep (ASLP)
                }
                Return (LEqual (CSTS, 0x03))
            }
            Method (GNOT, 2, NotSerialized)
            {
                If (PDRD ())
                {
                    Return (One)
                }
                Store (Arg0, CEVT)
                Store (0x03, CSTS)
                If (LAnd (LEqual (CHPD, Zero), LEqual (Arg1, Zero)))
                {
                    If (LAnd (LGreater (OSYS, 0x07D0), LLess (OSYS, 0x07D6)))
                    {
                        Notify (PCI0, Arg1)
                    }
                    Else
                    {
                        Notify (GFX0, Arg1)
                    }
                }
                If (CondRefOf (HNOT))
                {
                    HNOT (Arg0)
                }
                Else
                {
                    Notify (GFX0, 0x80)
                }
                Return (Zero)
            }
            Method (GHDS, 1, NotSerialized)
            {
                Store (Arg0, TIDX)
                Return (GNOT (One, Zero))
            }
            Method (GLID, 1, NotSerialized)
            {
                If (LEqual (Arg0, One))
                {
                    Store (0x03, CLID)
                }
                Else
                {
                    Store (Arg0, CLID)
                }
                Return (GNOT (0x02, Zero))
            }
            Method (GDCK, 1, NotSerialized)
            {
                Store (Arg0, CDCK)
                Return (GNOT (0x04, Zero))
            }
            Method (PARD, 0, NotSerialized)
            {
                If (LNot (ARDY))
                {
                    Sleep (ASLP)
                }
                Return (LNot (ARDY))
            }
            Method (AINT, 2, NotSerialized)
            {
                If (LNot (And (TCHE, ShiftLeft (One, Arg0))))
                {
                    Return (One)
                }
                If (PARD ())
                {
                    Return (One)
                }
                If (LEqual (Arg0, 0x02))
                {
                    XOr (PFIT, 0x07, PFIT)
                    Or (PFIT, 0x80000000, PFIT)
                    Store (0x04, ASLC)
                }
                Else
                {
                    If (LEqual (Arg0, One))
                    {
                        Store (Arg1, BCLP)
                        Or (BCLP, 0x80000000, BCLP)
                        Store (0x0A, ASLC)
                    }
                    Else
                    {
                        If (LEqual (Arg0, 0x03))
                        {
                            Store (Arg1, PFMB)
                            Or (PFMB, 0x80000100, PFMB)
                        }
                        Else
                        {
                            If (LEqual (Arg0, Zero))
                            {
                                Store (Arg1, ALSI)
                                Store (One, ASLC)
                            }
                            Else
                            {
                                Return (One)
                            }
                        }
                    }
                }
                Store (One, ASLE)
                Return (Zero)
            }
            Method (SCIP, 0, NotSerialized)
            {
                If (LNotEqual (OVER, Zero))
                {
                    Return (LNot (GSMI))
                }
                Return (Zero)
            }
            Device (^^MEM2)
            {
                Name (_HID, EisaId ("PNP0C01"))
                Name (_UID, 0x02)
                Name (CRS, ResourceTemplate ()
                {
                    Memory32Fixed (ReadWrite,
                        0x20000000,         // Address Base
                        0x00200000,         // Address Length
                        )
                    Memory32Fixed (ReadWrite,
                        0x40000000,         // Address Base
                        0x00200000,         // Address Length
                        )
                })
                Method (_CRS, 0, NotSerialized)
                {
                    If (IGDS)
                    {
                        Return (CRS)
                    }
                }
            }
        }
    }
    Name (_S0, Package (0x04)
    {
        Zero, 
        Zero, 
        Zero, 
        Zero
    })
    Name (_S3, Package (0x04)
    {
        0x05, 
        Zero, 
        Zero, 
        Zero
    })
    Name (_S4, Package (0x04)
    {
        0x06, 
        Zero, 
        Zero, 
        Zero
    })
    Name (_S5, Package (0x04)
    {
        0x07, 
        Zero, 
        Zero, 
        Zero
    })
    Scope (_SB.PCI0.LPCB)
    {
        Device (EC)
        {
            Name (_HID, EisaId ("PNP0C09"))
            Name (_UID, One)
            Name (_GPE, 0x16)
            Method (_CRS, 0, NotSerialized)
            {
                Name (BFFR, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0062,             // Range Minimum
                        0x0062,             // Range Maximum
                        0x00,               // Alignment
                        0x01,               // Length
                        )
                    IO (Decode16,
                        0x0066,             // Range Minimum
                        0x0066,             // Range Maximum
                        0x00,               // Alignment
                        0x01,               // Length
                        )
                })
                Return (BFFR)
            }
            OperationRegion (ERAM, EmbeddedControl, Zero, 0xFF)
            Field (ERAM, ByteAcc, NoLock, Preserve)
            {
                DSBY,   1, 
                ENGA,   1, 
                ENHY,   1, 
                HFNE,   1, 
                DSEM,   1, 
                EN3R,   1, 
                REBY,   1, 
                ENTM,   1, 
                ENBK,   1, 
                ENFP,   1, 
                    ,   1, 
                IDMI,   1, 
                WPSW,   1, 
                BYON,   1, 
                ENBT,   1, 
                NTKY,   1, 
                DKON,   1, 
                DSSK,   1, 
                MTES,   1, 
                USBO,   1, 
                DSMC,   1, 
                SNLC,   1, 
                NLSF,   1, 
                TNKB,   1, 
                DSHP,   1, 
                IGPK,   1, 
                CHGR,   1, 
                    ,   1, 
                CBAT,   1, 
                ADO0,   1, 
                ADO1,   1, 
                        Offset (0x04), 
                    ,   1, 
                CLBA,   1, 
                LWBA,   1, 
                SUBE,   1, 
                PUBE,   1, 
                RSBE,   1, 
                DCBE,   1, 
                PFBE,   1, 
                HSPA,   1, 
                NHDD,   1, 
                DEAD,   1, 
                B440,   1, 
                B315,   1, 
                T315,   1, 
                R315,   1, 
                BYAM,   1, 
                HSUN,   8, 
                HSRP,   8, 
                    ,   1, 
                DELY,   1, 
                        Offset (0x09), 
                        Offset (0x0A), 
                        Offset (0x0B), 
                TPSE,   2, 
                        Offset (0x0C), 
                HLCL,   4, 
                    ,   2, 
                BLIK,   1, 
                TONF,   1, 
                UONE,   1, 
                    ,   1, 
                UONM,   2, 
                ECBK,   4, 
                HFNS,   2, 
                GSER,   1, 
                PSCS,   1, 
                PSDS,   1, 
                GSUD,   1, 
                GSID,   2, 
                MBCG,   1, 
                SBCG,   1, 
                MBRF,   1, 
                SBRF,   1, 
                HDSU,   1, 
                BYSU,   1, 
                    ,   1, 
                TMOD,   1, 
                HAM0,   8, 
                HAM1,   8, 
                HAM2,   8, 
                HAM3,   8, 
                HAM4,   8, 
                HAM5,   8, 
                HAM6,   8, 
                HAM7,   8, 
                HAM8,   8, 
                HAM9,   8, 
                HAMA,   8, 
                HAMB,   8, 
                HAMC,   8, 
                HAMD,   8, 
                HAME,   8, 
                HAMF,   8, 
                HT00,   1, 
                HT01,   1, 
                HT02,   1, 
                HT03,   1, 
                HT10,   1, 
                HT11,   1, 
                HT12,   1, 
                HT13,   1, 
                        Offset (0x23), 
                EXCM,   8, 
                        Offset (0x25), 
                        Offset (0x26), 
                USP0,   1, 
                USP3,   1, 
                USP4,   1, 
                EHP0,   1, 
                EHP1,   1, 
                        Offset (0x27), 
                        Offset (0x28), 
                ID00,   1, 
                ID01,   1, 
                ID02,   1, 
                ID03,   1, 
                    ,   2, 
                SEBT,   1, 
                CMDS,   1, 
                        Offset (0x2A), 
                HATR,   8, 
                HT0H,   8, 
                HT0L,   8, 
                HT1H,   8, 
                HT1L,   8, 
                HFSP,   8, 
                    ,   5, 
                SMUT,   1, 
                        Offset (0x31), 
                FANS,   2, 
                HUWB,   1, 
                ENS4,   1, 
                DSEX,   1, 
                AYID,   1, 
                MMUT,   1, 
                ODDP,   1, 
                HWPM,   1, 
                HWLB,   1, 
                HWLO,   1, 
                HWDK,   1, 
                HWFN,   1, 
                HWBT,   1, 
                HWRI,   1, 
                HWBU,   1, 
                        Offset (0x34), 
                    ,   7, 
                HPLO,   1, 
                        Offset (0x36), 
                        Offset (0x37), 
                        Offset (0x38), 
                HB0S,   7, 
                MBTS,   1, 
                        Offset (0x3A), 
                MUTE,   1, 
                I2CS,   1, 
                PWRF,   1, 
                WANO,   1, 
                DCBD,   1, 
                DCWL,   1, 
                DCWW,   1, 
                        Offset (0x3B), 
                SPKM,   1, 
                KBLH,   1, 
                    ,   1, 
                BTDH,   1, 
                USBN,   1, 
                    ,   2, 
                S3FG,   1, 
                        Offset (0x3D), 
                        Offset (0x3E), 
                        Offset (0x41), 
                    ,   7, 
                PFLG,   1, 
                        Offset (0x46), 
                FNKY,   1, 
                    ,   1, 
                HPLD,   1, 
                PROF,   1, 
                ACPW,   1, 
                    ,   2, 
                CALR,   1, 
                HPBU,   1, 
                DKEV,   1, 
                BYNO,   1, 
                HDIB,   1, 
                        Offset (0x48), 
                HPHI,   1, 
                GSTS,   1, 
                    ,   2, 
                EXGC,   1, 
                DOKI,   1, 
                HDDT,   1, 
                        Offset (0x49), 
                    ,   1, 
                NUMK,   1, 
                        Offset (0x4A), 
                        Offset (0x4B), 
                        Offset (0x4C), 
                ETHB,   8, 
                ETLB,   8, 
                    ,   1, 
                ACOV,   1, 
                RMCS,   1, 
                    ,   1, 
                T4E4,   1, 
                T4E5,   1, 
                        Offset (0x4F), 
                        Offset (0x50), 
                SMPR,   8, 
                SMST,   8, 
                SMAD,   8, 
                SMCM,   8, 
                SMD0,   100, 
                        Offset (0x74), 
                BCNT,   8, 
                SMAA,   8, 
                BATD,   16, 
                TMP0,   8, 
                TMP1,   8, 
                TMP2,   8, 
                TMP3,   8, 
                TMP4,   8, 
                TMP5,   8, 
                TMP6,   8, 
                TMP7,   8, 
                        Offset (0x81), 
                HIID,   8, 
                        Offset (0x83), 
                HFNI,   8, 
                        Offset (0x86), 
                        Offset (0x87), 
                        Offset (0x88), 
                HDEC,   8, 
                HDEO,   8, 
                        Offset (0x8B), 
                LOMD,   1, 
                CBDE,   1, 
                        Offset (0x8C), 
                        Offset (0x8D), 
                HDAA,   3, 
                HDAB,   3, 
                HDAC,   2, 
                        Offset (0x8F), 
                        Offset (0x90), 
                ERMC,   8, 
                        Offset (0x92), 
                AMSB,   8, 
                ALSB,   8, 
                DMSB,   8, 
                DLSB,   8, 
                        Offset (0xA0), 
                        Offset (0xB0), 
                HDEN,   32, 
                DBTS,   8, 
                        Offset (0xB8), 
                HDEM,   8, 
                HDES,   8, 
                        Offset (0xC0), 
                        Offset (0xC1), 
                MCUR,   16, 
                MBRM,   16, 
                MBVG,   16, 
                        Offset (0xC8), 
                ATMX,   8, 
                AC65,   8, 
                        Offset (0xCB), 
                BFUD,   1, 
                        Offset (0xCC), 
                PWMH,   8, 
                PWML,   8, 
                SHSC,   8, 
                HSID,   8, 
                        Offset (0xE0), 
                CRC0, 8, CRC1, 8, 
                CAC0, 8, CAC1, 8, 
                CVO0, 8, CVO1, 8, 
                        Offset (0xE8), 
                        Offset (0xE9), 
                        Offset (0xEA), 
                        Offset (0xEB), 
                        Offset (0xEC), 
                        Offset (0xED), 
                    ,   1, 
                    ,   1, 
                    ,   1, 
                    ,   1, 
                    ,   1, 
                    ,   1, 
                    ,   1, 
                        Offset (0xEE), 
                MBTH,   4, 
                SBTH,   4, 
                        Offset (0xF0), 
                        Offset (0xF8), 
                    ,   4, 
                        Offset (0xF9), 
                        Offset (0xFA), 
                        Offset (0xFC)
            }
            Field (ERAM, ByteAcc, NoLock, Preserve)
            {
                        Offset (0xA0), 
                SBRC,   16, 
                BFC0, 8, BFC1, 8, 
                SBAE,   16, 
                SBRS,   16, 
                SBAC,   16, 
                SBVO,   16, 
                SBAF,   16, 
                SBBS,   16
            }
            Field (ERAM, ByteAcc, NoLock, Preserve)
            {
                        Offset (0xA0), 
                    ,   15, 
                SBCM,   1, 
                SBMD,   16, 
                SBCC,   16
            }
            Field (ERAM, ByteAcc, NoLock, Preserve)
            {
                        Offset (0xA0), 
                BDC0, 8, BDC1, 8, 
                BDV0, 8, BDV1, 8, 
                SBOM,   16, 
                SBSI,   16, 
                SBDT,   16, 
                BSN0, 8, BSN1, 8
            }
            Field (ERAM, ByteAcc, NoLock, Preserve)
            {
                        Offset (0xA0), 
                 BCH0, 8, BCH1, 8, BCH2, 8, BCH3, 8
            }
            Field (ERAM, ByteAcc, NoLock, Preserve)
            {
                        Offset (0xA0), 
                BMN0, 8, BMN1, 8, BMN2, 8, BMN3, 8,
 BMN4, 8, BMN5, 8, BMN6, 8, BMN7, 8,
 BMN8, 8, BMN9, 8, BMNA, 8, BMNB, 8,
 BMNC, 8, BMND, 8, BMNE, 8, BMNF, 8,
            }
            Field (ERAM, ByteAcc, NoLock, Preserve)
            {
                        Offset (0xA0), 
                BDN0, 8, BDN1, 8, BDN2, 8, BDN3, 8,
 BDN4, 8, BDN5, 8, BDN6, 8, BDN7, 8,
 BDN8, 8, BDN9, 8, BDNA, 8, BDNB, 8,
 BDNC, 8, BDND, 8, BDNE, 8, BDNF, 8,
            }
            Name (BATO, Zero)
            Name (BATN, Zero)
            Name (BATF, 0xC0)
            Method (_REG, 2, NotSerialized)
            {
                VBRG ()
                VBRS (BRNS)
                If (LAnd (LEqual (Arg0, 0x03), LEqual (Arg1, One)))
                {
                    Store (One, ECON)
                    Store (0xFF, SXFG)
                    Store (Zero, LIDX)
                    Store (ACPW, ACST)
                    Store (ACST, PWRS)
                    If (IGDS)
                    {
                        Store (One, ^^^GFX0.CLID)
                    }
                    If (Not (^^^GFX0.CLID))
                    {
                        Notify (LID, 0x80)
                    }
                    WGSV (Zero)
                }
                If (LEqual (AC65, 0x41))
                {
                    If (LNot (MBTS))
                    {
                        Store (0x0D, \_PR.CPU0._PPC)
                        PNOT ()
                    }
                }
                THRO (0x95)
                Sleep (0x03E8)
                Notify (BAT1, Zero)
                PNOT ()
            }
            Method (LED, 2, NotSerialized)
            {
                Or (Arg0, Arg1, Local0)
                If (ECON)
                {
                    Store (Local0, HLCL)
                }
                Else
                {
                    WBEC (0x0C, Local0)
                }
            }
            Name (BAON, Zero)
            Name (WBON, Zero)
            Method (BEEP, 1, NotSerialized)
            {
                If (LEqual (Arg0, 0x0F))
                {
                    Store (Zero, WBON)
                }
                Store (WBON, Local2)
                Store (Arg0, Local0)
                Store (0xFF, Local1)
                If (LEqual (Arg0, 0x11))
                {
                    Store (Zero, Local0)
                    Store (Zero, Local1)
                    Store (Zero, WBON)
                }
                If (LEqual (Arg0, 0x10))
                {
                    Store (0x03, Local0)
                    Store (0x08, Local1)
                    Store (One, WBON)
                }
                If (LEqual (Arg0, 0x03))
                {
                    Store (Zero, WBON)
                    If (Local2)
                    {
                        Store (0x07, Local0)
                        If (LOr (LEqual (SPS, 0x03), LEqual (SPS, 0x04)))
                        {
                            Store (Zero, Local2)
                            Store (0xFF, Local0)
                            Store (0xFF, Local1)
                        }
                    }
                }
                If (LEqual (Arg0, 0x07))
                {
                    If (Local2)
                    {
                        Store (Zero, Local2)
                        Store (0xFF, Local0)
                        Store (0xFF, Local1)
                    }
                }
                If (ECON)
                {
                    If (LAnd (Local2, LNot (WBON)))
                    {
                        Store (Zero, HSRP)
                        Store (Zero, HSUN)
                        Sleep (0x64)
                    }
                    If (LNotEqual (Local1, 0xFF))
                    {
                        Store (Local1, HSRP)
                    }
                    If (LNotEqual (Local0, 0xFF))
                    {
                        Store (Local0, HSUN)
                    }
                }
                If (LEqual (Arg0, 0x03)) {}
                If (LEqual (Arg0, 0x07))
                {
                    Sleep (0x01F4)
                }
            }
            Method (FNST, 0, NotSerialized)
            {
                If (ECON)
                {
                    Store (HFNS, Local0)
                    Store (HFNE, Local1)
                }
                Else
                {
                    And (RBEC (0x0E), 0x03, Local0)
                    And (RBEC (Zero), 0x08, Local1)
                }
                If (Local1)
                {
                    If (LEqual (Local0, Zero))
                    {
                        UCMS (0x11)
                    }
                    If (LEqual (Local0, One))
                    {
                        UCMS (0x0F)
                    }
                    If (LEqual (Local0, 0x02))
                    {
                        UCMS (0x10)
                    }
                    ^HKEY.MHKQ (0x6005)
                }
            }
            Method (CHKS, 0, NotSerialized)
            {
                Store (0x03E8, Local0)
                While (SMPR)
                {
                    Sleep (One)
                    Decrement (Local0)
                    If (LNot (Local0))
                    {
                        Return (0x8080)
                    }
                }
                And (SMST, 0x80, Local1)
                If (LEqual (Local1, 0x80))
                {
                    Return (Zero)
                }
                Return (0x8081)
            }
            Method (BFWL, 0, NotSerialized)
            {
                Store (SMD0, FW00)
                SMI (0x14, 0x02, Zero, Zero, Zero)
            }
            Method (BLCL, 0, NotSerialized)
            {
                Store (BRNS, Local0)
                If (^^^GFX0.DRDY)
                {
                    If (LEqual (Zero, Local0))
                    {
                        Store (DerefOf (Index (DerefOf (Index (BRTB, 0x02)), 0x03)), 
                            Local1)
                        Store (DerefOf (Index (DerefOf (Index (BRTB, 0x02)), Zero)), 
                            Local2)
                    }
                    Else
                    {
                        Store (DerefOf (Index (DerefOf (Index (BRTB, 0x02)), 0x04)), 
                            Local1)
                        Store (DerefOf (Index (DerefOf (Index (BRTB, 0x02)), One)), 
                            Local2)
                    }
                    Or (Local1, ShiftLeft (Local2, 0x09), Local2)
                    ^^^GFX0.AINT (0x03, Local2)
                    Store (Zero, Local1)
                    Store (DerefOf (Index (DerefOf (Index (BRTB, Local1)), Local0)), 
                        Local2)
                    ^^^GFX0.AINT (One, Local2)
                }
            }
            Method (_Q01, 0, NotSerialized)
            {
                Store (One, P80H)
            }
            Method (_Q02, 0, NotSerialized)
            {
                Store (0x02, P80H)
            }
            Method (_Q03, 0, NotSerialized)
            {
                Store (0x03, P80H)
            }
            Method (_Q04, 0, NotSerialized)
            {
                Store (0x04, P80H)
            }
            Method (_Q05, 0, NotSerialized)
            {
                Store (0x05, P80H)
            }
            Method (_Q06, 0, NotSerialized)
            {
                Store (0x06, P80H)
            }
            Method (_Q07, 0, NotSerialized)
            {
                Store (0x07, P80H)
            }
            Method (_Q08, 0, NotSerialized)
            {
                Store (0x08, P80H)
            }
            Method (_Q09, 0, NotSerialized)
            {
                Store (0x09, P80H)
            }
            Method (_Q0A, 0, NotSerialized)
            {
                Store (0x0A, P80H)
            }
            Method (_Q0B, 0, NotSerialized)
            {
                Store (0x0B, P80H)
            }
            Method (_Q0C, 0, NotSerialized)
            {
                Store (0x0C, P80H)
            }
            Method (_Q0D, 0, NotSerialized)
            {
                Store (0x0D, P80H)
            }
            Method (_Q0E, 0, NotSerialized)
            {
                Store (0x0E, P80H)
            }
            Method (_Q0F, 0, NotSerialized)
            {
                Store (0x0F, P80H)
            }
            Method (_Q10, 0, NotSerialized)
            {
                Store (0x10, P80H)
                If (^HKEY.MHKK (One))
                {
                    ^HKEY.MHKQ (0x1001)
                }
            }
            Method (_Q11, 0, NotSerialized)
            {
                Store (0x11, P80H)
                If (^HKEY.MHKK (0x02))
                {
                    ^HKEY.MHKQ (0x1002)
                }
                Else
                {
                    Noop
                }
            }
            Method (_Q12, 0, NotSerialized)
            {
                Store (0x12, P80H)
                ^HKEY.MHKQ (0x1003)
            }
            Method (_Q13, 0, NotSerialized)
            {
                Store (0x13, P80H)
                If (^HKEY.DHKC)
                {
                    ^HKEY.MHKQ (0x1004)
                }
                Else
                {
                }
            }
            Method (_Q14, 0, NotSerialized)
            {
                Store (0x14, P80H)
            }
            Method (_Q15, 0, NotSerialized)
            {
                Store (0x15, P80H)
            }
            Method (_Q16, 0, NotSerialized)
            {
                Store (0x16, P80H)
                If (^HKEY.MHKK (0x00010000))
                {
                    ^HKEY.MHKQ (0x1011)
                }
                If (LGreaterEqual (OSYS, 0x07D6))
                {
                    If (IGDS)
                    {
                        Notify (^^^GFX0.DD02, 0x87)
                        Sleep (0x50)
                    }
                    Else
                    {
                        Notify (^^^GFX0.DD02, 0x87)
                        Notify (^^^PEG0.PEGP.DD02, 0x87)
                        Sleep (0x50)
                    }
                    UCMS (0x16)
                }
                Else
                {
                    Store (BRNS, Local0)
                    If (LGreater (Local0, Zero))
                    {
                        Decrement (Local0)
                        Store (Local0, BRNS)
                        VBRS (Local0)
                        Store (DerefOf (Index (IBCL, Add (Local0, 0x02))), EBRL)
                        IBCM (EBRL)
                    }
                    ^HKEY.MHKQ (0x6050)
                }
            }
            Method (_Q17, 0, NotSerialized)
            {
                Store (0x17, P80H)
                If (^HKEY.MHKK (0x8000))
                {
                    ^HKEY.MHKQ (0x1010)
                }
                If (LGreaterEqual (OSYS, 0x07D6))
                {
                    If (IGDS)
                    {
                        Notify (^^^GFX0.DD02, 0x86)
                        Sleep (0x50)
                    }
                    Else
                    {
                        Notify (^^^GFX0.DD02, 0x86)
                        Notify (^^^PEG0.PEGP.DD02, 0x86)
                        Sleep (0x50)
                    }
                    UCMS (0x16)
                }
                Else
                {
                    Store (BRNS, Local0)
                    If (LLessEqual (Local0, 0x0E))
                    {
                        Increment (Local0)
                        Store (Local0, BRNS)
                        VBRS (Local0)
                        Store (DerefOf (Index (IBCL, Add (Local0, 0x02))), EBRL)
                        IBCM (EBRL)
                    }
                    ^HKEY.MHKQ (0x6050)
                }
            }
            Method (_Q18, 0, NotSerialized)
            {
                Store (0x18, P80H)
                If (^HKEY.MHKK (0x10))
                {
                    ^HKEY.MHKQ (0x1005)
                }
                If (WWNA)
                {
                    Store (DCWW, GO71)
                    Store (Zero, WWNA)
                }
                Else
                {
                    If (WANA)
                    {
                        Store (DCWL, GO70)
                        Store (Zero, WANA)
                    }
                    Else
                    {
                        If (BTHA)
                        {
                            Store (DCBD, GO35)
                            Store (Zero, BTHA)
                        }
                    }
                }
            }
            Method (_Q19, 0, NotSerialized)
            {
                Store (0x19, P80H)
                If (^HKEY.MHKK (0x00800000))
                {
                    ^HKEY.MHKQ (0x1018)
                }
                UCMS (0x03)
            }
            Method (_Q1A, 0, NotSerialized)
            {
                If (^HKEY.MHKK (0x0400))
                {
                    ^HKEY.MHKQ (0x100B)
                }
            }
            Method (_Q1B, 0, NotSerialized)
            {
                ^HKEY.MHKQ (0x100C)
            }
            Method (_Q1C, 0, NotSerialized)
            {
                If (^HKEY.MHKK (0x00200000))
                {
                    ^HKEY.MHKQ (0x1016)
                }
                UCMS (Zero)
            }
            Method (_Q1D, 0, NotSerialized)
            {
                If (^HKEY.MHKK (0x00100000))
                {
                    ^HKEY.MHKQ (0x1015)
                }
                UCMS (One)
            }
            Method (_Q1E, 0, NotSerialized)
            {
                Store (One, ADO0)
                Store (One, ADO1)
            }
            Method (_Q1F, 0, NotSerialized)
            {
            }
            Method (_Q22, 0, NotSerialized)
            {
                Store (0x22, P80H)
                If (MBTS)
                {
                    Notify (BAT1, 0x80)
                    Notify (BAT1, Zero)
                }
            }
            Method (_Q24, 0, NotSerialized)
            {
                Notify (BAT1, 0x80)
            }
            Method (_Q26, 0, NotSerialized)
            {
                Store (0x26, P80H)
                Sleep (0x01F4)
                Notify (ACAD, 0x80)
                Notify (BAT1, 0x80)
                Notify (\_TZ.TZ00, 0x80)
                ^HKEY.MHKQ (0x6040)
                If (LEqual (AC65, 0x41))
                {
                    If (MBTS)
                    {
                        Store (Zero, \_PR.CPU0._PPC)
                    }
                    Else
                    {
                        Store (0x0D, \_PR.CPU0._PPC)
                    }
                }
                Else
                {
                    Store (Zero, \_PR.CPU0._PPC)
                }
                PNOT ()
            }
            Method (_Q27, 0, NotSerialized)
            {
                Store (0x27, P80H)
                Sleep (0x01F4)
                Notify (ACAD, 0x80)
                ^HKEY.MHKQ (0x6040)
                PNOT ()
            }
            Method (_Q28, 0, NotSerialized)
            {
                Store (0x28, P80H)
            }
            Method (_Q29, 0, NotSerialized)
            {
                Store (0x29, P80H)
            }
            Method (_Q2A, 0, NotSerialized)
            {
                ^HKEY.MHKQ (0x5002)
                Notify (LID, 0x80)
            }
            Method (_Q2B, 0, NotSerialized)
            {
                ^HKEY.MHKQ (0x5001)
                Notify (LID, 0x80)
            }
            Method (_Q34, 0, NotSerialized)
            {
                If (LAnd (LEqual (And (HB0S, 0x0F, Local1), Zero), LNot (ACPW)))
                {
                    Store (0x34, P80H)
                    ^HKEY.MHKQ (0x2313)
                }
                FNST ()
            }
            Method (_Q37, 0, NotSerialized)
            {
                Store (0x37, P80H)
                Sleep (0x01F4)
                If (DOKI)
                {
                    ^HKEY.MHKQ (0x4010)
                }
                Else
                {
                    ^HKEY.MHKQ (0x4011)
                }
            }
            Method (_Q3F, 0, NotSerialized)
            {
                Sleep (0x01F4)
                ^HKEY.MHKQ (0x6000)
            }
            Method (_Q40, 0, NotSerialized)
            {
                Store (0x40, P80H)
            }
            Method (_Q41, 0, NotSerialized)
            {
                Sleep (0x01F4)
                ^HKEY.MHKQ (0x7000)
                If (LNot (GSTS))
                {
                    Store (Zero, GO70)
                    Store (Zero, GO35)
                    Store (Zero, GO71)
                }
                Else
                {
                    Store (DCWL, GO70)
                    Store (DCBD, GO35)
                    Store (DCWW, GO71)
                }
            }
            Method (_Q43, 0, NotSerialized)
            {
                Store (0x43, P80H)
                UCMS (0x18)
            }
            Method (_Q44, 0, NotSerialized)
            {
                Store (0x44, P80H)
            }
            Method (_Q45, 0, NotSerialized)
            {
                Store (0x45, P80H)
                ^HKEY.MHKQ (0x3006)
                Notify (^^^SAT0.PRT1, One)
            }
            Method (_Q4A, 0, NotSerialized)
            {
                Store (0x4A, P80H)
                Store (One, BFAD)
                Sleep (0xC8)
                Notify (BAT1, Zero)
                PNOT ()
                If (LEqual (AC65, 0x41))
                {
                    If (MBTS)
                    {
                        Store (Zero, \_PR.CPU0._PPC)
                        PNOT ()
                    }
                    Else
                    {
                        Store (0x0D, \_PR.CPU0._PPC)
                        PNOT ()
                    }
                }
                Else
                {
                    Store (Zero, \_PR.CPU0._PPC)
                    PNOT ()
                }
            }
            Method (_Q4B, 0, NotSerialized)
            {
                Store (0x4B, P80H)
                Notify (BAT1, 0x80)
                PNOT ()
                If (LEqual (AC65, 0x41))
                {
                    If (MBTS)
                    {
                        Store (Zero, \_PR.CPU0._PPC)
                        PNOT ()
                    }
                    Else
                    {
                        Store (0x0D, \_PR.CPU0._PPC)
                        PNOT ()
                    }
                }
                Else
                {
                    Store (Zero, \_PR.CPU0._PPC)
                    PNOT ()
                }
            }
            Method (_Q4E, 0, NotSerialized)
            {
                Store (0x4E, P80H)
                ^HKEY.MHKQ (0x6011)
            }
            Method (_Q4F, 0, NotSerialized)
            {
                Store (0x4F, P80H)
                ^HKEY.MHKQ (0x6012)
            }
            Method (_Q60, 0, NotSerialized)
            {
                Store (0x60, P80H)
                If (^HKEY.MHKK (0x2000))
                {
                    ^HKEY.MHKQ (0x100E)
                }
            }
            Method (_Q61, 0, NotSerialized)
            {
                Store (0x61, P80H)
            }
            Method (_Q62, 0, NotSerialized)
            {
                Store (0x62, P80H)
            }
            Method (_Q63, 0, NotSerialized)
            {
                Store (0x63, P80H)
                If (^HKEY.MHKK (0x00020000))
                {
                    ^HKEY.MHKQ (0x1012)
                }
            }
            Method (_Q64, 0, NotSerialized)
            {
                Store (0x64, P80H)
                If (^HKEY.MHKK (0x20))
                {
                    ^HKEY.MHKQ (0x1006)
                }
            }
            Method (_Q65, 0, NotSerialized)
            {
                Store (0x65, P80H)
                If (^HKEY.MHKK (0x40))
                {
                    ^HKEY.MHKQ (0x1007)
                }
                Else
                {
                    If (IGDS)
                    {
                        ^^^GFX0.GHDS (Zero)
                    }
                }
            }
            Method (_Q66, 0, NotSerialized)
            {
                Store (0x66, P80H)
                If (^HKEY.MHKK (0x0200))
                {
                    ^HKEY.MHKQ (0x100A)
                }
                UCMS (0x02)
            }
            Method (_Q67, 0, NotSerialized)
            {
                If (^HKEY.MHKK (0x00040000))
                {
                    ^HKEY.MHKQ (0x1013)
                }
            }
            Method (_Q68, 0, NotSerialized)
            {
                Store (0x68, P80H)
            }
            Method (_Q69, 0, NotSerialized)
            {
                Store (0x69, P80H)
            }
            Method (_Q6A, 0, NotSerialized)
            {
                Store (0x6A, P80H)
                ^HKEY.MHKQ (0x101B)
            }
            Method (_Q6B, 0, NotSerialized)
            {
                Store (0x6B, P80H)
            }
            Method (_Q6C, 0, NotSerialized)
            {
                Store (0x6C, P80H)
            }
            Method (_Q6D, 0, NotSerialized)
            {
                Store (0x6D, P80H)
            }
            Method (_Q6E, 0, NotSerialized)
            {
                Store (0x6E, P80H)
            }
            Method (_Q6F, 0, NotSerialized)
            {
                Store (0x6F, P80H)
            }
            Method (_Q70, 0, NotSerialized)
            {
                Store (0x70, P80H)
                FNST ()
            }
            Method (_Q72, 0, NotSerialized)
            {
                Store (0x72, P80H)
                FNST ()
            }
            Method (_Q73, 0, NotSerialized)
            {
                Store (0x73, P80H)
                FNST ()
            }
            Method (_Q76, 0, NotSerialized)
            {
                Store (0x76, P80H)
            }
            Method (_Q77, 0, NotSerialized)
            {
                Store (0x77, P80H)
            }
            Method (_Q95, 0, NotSerialized)
            {
                Notify (\_TZ.TZ00, 0x80)
            }
            Method (_QEA, 0, NotSerialized)
            {
                Store (0xEA, P80H)
                If (LEqual (T4E4, Zero))
                {
                    Store (One, T4E4)
                    Store (Zero, T4E5)
                    THRO (0x91)
                    Sleep (0x1E)
                    THRO (0x95)
                }
                Else
                {
                    Store (One, T4E5)
                    THRO (0x92)
                    Sleep (0x1E)
                    THRO (0x95)
                }
            }
            Method (_QEC, 0, NotSerialized)
            {
                Store (0xEC, P80H)
                Store (One, T4E4)
                Store (Zero, T4E5)
                THRO (0x91)
                Sleep (0x1E)
                THRO (0x95)
            }
            Method (_QEB, 0, NotSerialized)
            {
                Store (0xEB, P80H)
                Store (One, ACOV)
                If (LEqual (THRO (0x93), 0x12))
                {
                    Store (One, RMCS)
                }
                Sleep (0x1E)
                THRO (0x95)
                If (LEqual (AC65, 0x41))
                {
                    If (LEqual (MBTS, Zero))
                    {
                        Store (0x0D, \_PR.CPU0._PPC)
                        PNOT ()
                    }
                }
            }
            Method (_QED, 0, NotSerialized)
            {
                Store (0xED, P80H)
                Store (Zero, ACOV)
                Store (Zero, RMCS)
                Store (Zero, T4E4)
                Store (Zero, T4E5)
                THRO (0x94)
                Sleep (0x1E)
                THRO (0x95)
            }
            Device (HKEY)
            {
                Name (_HID, EisaId ("LEN0068"))
                Method (_STA, 0, NotSerialized)
                {
                    Return (0x0F)
                }
                Method (MHKV, 0, NotSerialized)
                {
                    Return (0x0100)
                }
                Name (DHKC, Zero)
                Name (DHKB, One)
                Mutex (XDHK, 0x07)
                Name (DHKH, Zero)
                Name (DHKW, Zero)
                Name (DHKS, Zero)
                Name (DHKD, Zero)
                Name (DHKN, 0x0002080C)
                Name (DHKT, Zero)
                Name (DHWW, Zero)
                Name (FIRB, One)
                Method (MHKA, 0, NotSerialized)
                {
                    Return (0x04038070)
                }
                Method (MHKN, 0, NotSerialized)
                {
                    Return (DHKN)
                }
                Method (MHKK, 1, NotSerialized)
                {
                    If (DHKC)
                    {
                        Return (And (DHKN, Arg0))
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
                Method (MHKM, 2, NotSerialized)
                {
                    Acquire (XDHK, 0xFFFF)
                    If (LGreater (Arg0, 0x20))
                    {
                        Noop
                    }
                    Else
                    {
                        ShiftLeft (One, Decrement (Arg0), Local0)
                        If (And (Local0, 0x04038070))
                        {
                            If (Arg1)
                            {
                                Or (Local0, DHKN, DHKN)
                            }
                            Else
                            {
                                And (DHKN, XOr (Local0, 0xFFFFFFFF), DHKN)
                            }
                        }
                        Else
                        {
                            Noop
                        }
                    }
                    Release (XDHK)
                }
                Method (MHKS, 0, NotSerialized)
                {
                }
                Method (MHKC, 1, NotSerialized)
                {
                    Store (Arg0, DHKC)
                }
                Method (MHKP, 0, NotSerialized)
                {
                    Acquire (XDHK, 0xFFFF)
                    If (DHWW)
                    {
                        Store (DHWW, Local1)
                        Store (Zero, DHWW)
                    }
                    Else
                    {
                        If (DHKW)
                        {
                            Store (DHKW, Local1)
                            Store (Zero, DHKW)
                        }
                        Else
                        {
                            If (DHKD)
                            {
                                Store (DHKD, Local1)
                                Store (Zero, DHKD)
                            }
                            Else
                            {
                                If (DHKS)
                                {
                                    Store (DHKS, Local1)
                                    Store (Zero, DHKS)
                                }
                                Else
                                {
                                    If (DHKT)
                                    {
                                        Store (DHKT, Local1)
                                        Store (Zero, DHKT)
                                    }
                                    Else
                                    {
                                        Store (DHKH, Local1)
                                        Store (Zero, DHKH)
                                    }
                                }
                            }
                        }
                    }
                    Release (XDHK)
                    Return (Local1)
                }
                Method (KLCG, 1, NotSerialized)
                {
                    Return (Zero)
                }
                Method (MHKE, 1, NotSerialized)
                {
                    Store (Arg0, DHKB)
                    Acquire (XDHK, 0xFFFF)
                    Store (Zero, DHKH)
                    Store (Zero, DHKW)
                    Store (Zero, DHKS)
                    Store (Zero, DHKD)
                    Store (Zero, DHKT)
                    Store (Zero, DHWW)
                    Release (XDHK)
                }
                Method (MHKQ, 1, NotSerialized)
                {
                    If (DHKB)
                    {
                        If (DHKC)
                        {
                            Acquire (XDHK, 0xFFFF)
                            If (LLess (Arg0, 0x1000)) {}
                            Else
                            {
                                If (LLess (Arg0, 0x2000))
                                {
                                    Store (Arg0, DHKH)
                                }
                                Else
                                {
                                    If (LLess (Arg0, 0x3000))
                                    {
                                        Store (Arg0, DHKW)
                                    }
                                    Else
                                    {
                                        If (LLess (Arg0, 0x4000))
                                        {
                                            Store (Arg0, DHKS)
                                        }
                                        Else
                                        {
                                            If (LLess (Arg0, 0x5000))
                                            {
                                                Store (Arg0, DHKD)
                                            }
                                            Else
                                            {
                                                If (LLess (Arg0, 0x6000))
                                                {
                                                    Store (Arg0, DHKH)
                                                }
                                                Else
                                                {
                                                    If (LLess (Arg0, 0x7000))
                                                    {
                                                        Store (Arg0, DHKT)
                                                    }
                                                    Else
                                                    {
                                                        If (LLess (Arg0, 0x8000))
                                                        {
                                                            Store (Arg0, DHWW)
                                                        }
                                                        Else
                                                        {
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            Release (XDHK)
                            Notify (HKEY, 0x80)
                        }
                        Else
                        {
                            If (LEqual (Arg0, 0x1004)) {}
                        }
                    }
                }
                Method (MHKD, 0, NotSerialized)
                {
                }
                Method (MHQC, 1, NotSerialized)
                {
                    If (WNTF)
                    {
                        If (LEqual (Arg0, Zero))
                        {
                            Return (CWAC)
                        }
                        Else
                        {
                            If (LEqual (Arg0, One))
                            {
                                Return (CWAP)
                            }
                            Else
                            {
                                If (LEqual (Arg0, 0x02))
                                {
                                    Return (CWAT)
                                }
                                Else
                                {
                                    Noop
                                }
                            }
                        }
                    }
                    Else
                    {
                        Noop
                    }
                    Return (Zero)
                }
                Method (MHGC, 0, NotSerialized)
                {
                    If (WNTF)
                    {
                        Acquire (XDHK, 0xFFFF)
                        If (CKC4 (Zero))
                        {
                            Store (0x03, Local0)
                        }
                        Else
                        {
                            Store (0x04, Local0)
                        }
                        Release (XDHK)
                        Return (Local0)
                    }
                    Else
                    {
                        Noop
                    }
                    Return (Zero)
                }
                Method (MHSC, 1, NotSerialized)
                {
                    If (LAnd (CWAC, WNTF))
                    {
                        Acquire (XDHK, 0xFFFF)
                        If (OSC4)
                        {
                            If (LEqual (Arg0, 0x03))
                            {
                                If (LNot (CWAS))
                                {
                                    PNTF (0x81)
                                    Store (One, CWAS)
                                }
                            }
                            Else
                            {
                                If (LEqual (Arg0, 0x04))
                                {
                                    If (CWAS)
                                    {
                                        PNTF (0x81)
                                        Store (Zero, CWAS)
                                    }
                                }
                                Else
                                {
                                    Noop
                                }
                            }
                        }
                        Release (XDHK)
                    }
                    Else
                    {
                        Noop
                    }
                }
                Method (MHKG, 0, NotSerialized)
                {
                    Return (Zero)
                }
                Method (MHST, 0, NotSerialized)
                {
                }
                Method (MHTT, 0, NotSerialized)
                {
                }
                Method (MHBT, 0, NotSerialized)
                {
                }
                Method (MHFT, 1, NotSerialized)
                {
                }
                Method (MHCT, 1, NotSerialized)
                {
                }
                Method (MMTG, 0, NotSerialized)
                {
                    Store (Zero, Local0)
                    Or (Local0, One, Local0)
                    If (LNot (MCMU))
                    {
                        Or (Local0, 0x00010000, Local0)
                    }
                    Return (Local0)
                }
                Method (MMTS, 1, NotSerialized)
                {
                }
                Name (INDV, Zero)
                Method (MHQI, 0, NotSerialized)
                {
                    Return (Zero)
                }
                Method (MHGI, 1, NotSerialized)
                {
                    Return (Zero)
                }
                Method (MHSI, 2, NotSerialized)
                {
                }
                Method (IRDY, 0, NotSerialized)
                {
                    Store (0x01F4, Local0)
                    Store (0x3C, Local1)
                    Store (Zero, Local2)
                    While (Local1)
                    {
                        Sleep (Local0)
                        Store (BCHK (), Local3)
                        If (LNot (Local3))
                        {
                            Break
                        }
                        If (LEqual (Local3, 0x02))
                        {
                            Store (One, Local2)
                            Break
                        }
                        Decrement (Local1)
                    }
                    Return (Local2)
                }
                Mutex (BFWM, 0x07)
                Method (MHCF, 1, NotSerialized)
                {
                    Store (BFWC (Arg0), Local0)
                    Return (Local0)
                }
                Method (MHPF, 1, NotSerialized)
                {
                    Name (RETB, Buffer (0x25) {})
                    Acquire (BFWM, 0xFFFF)
                    If (LLessEqual (SizeOf (Arg0), 0x25))
                    {
                        Store (Arg0, BFWB)
                        If (BFWP ())
                        {
                            CHKS ()
                            BFWL ()
                        }
                        Store (BFWB, RETB)
                    }
                    Release (BFWM)
                    Return (RETB)
                }
                Method (MHIF, 1, NotSerialized)
                {
                    Name (RETB, Buffer (0x0A) {})
                    Acquire (BFWM, 0xFFFF)
                    BFWG (Arg0)
                    Store (BFWB, RETB)
                    Release (BFWM)
                    Return (RETB)
                }
                Method (MHDM, 1, NotSerialized)
                {
                    BDMC (Arg0)
                }
                Method (CKC4, 1, NotSerialized)
                {
                    Store (Zero, Local0)
                    If (One)
                    {
                        If (LNot (C4AC))
                        {
                            Or (Local0, One, Local0)
                        }
                    }
                    If (LNot (And (CFGD, 0x0200)))
                    {
                        Or (Local0, 0x02, Local0)
                    }
                    If (LAnd (CWAC, CWAS))
                    {
                        Or (Local0, 0x04, Local0)
                    }
                    If (LAnd (CWUE, CWUS))
                    {
                        Or (Local0, 0x08, Local0)
                    }
                    And (Local0, Not (Arg0), Local0)
                    Return (Local0)
                }
                Method (MHQE, 0, NotSerialized)
                {
                    Return (One)
                }
                Method (MHGE, 0, NotSerialized)
                {
                    If (LAnd (One, C4AC))
                    {
                        Return (0x04)
                    }
                    Store (Zero, C4AC)
                    PNTF (0x81)
                    Return (0x03)
                }
                Method (MHSE, 1, NotSerialized)
                {
                    If (One)
                    {
                        Store (C4AC, Local0)
                        If (LEqual (Arg0, 0x03))
                        {
                            Store (Zero, C4AC)
                            If (One)
                            {
                                If (One)
                                {
                                    PNTF (0x81)
                                }
                            }
                        }
                        Else
                        {
                            If (LEqual (Arg0, 0x04))
                            {
                                Store (One, C4AC)
                                If (One)
                                {
                                    If (One)
                                    {
                                        PNTF (0x81)
                                    }
                                }
                            }
                        }
                    }
                }
                Method (PWMC, 0, NotSerialized)
                {
                    Return (One)
                }
                Method (PWMG, 0, NotSerialized)
                {
                    Store (PWMH, Local0)
                    ShiftLeft (Local0, 0x08, Local0)
                    Or (Local0, PWML, Local0)
                    Return (Local0)
                }
                Method (UAWO, 1, NotSerialized)
                {
                    Return (UAWS (Arg0))
                }
                Name (CPUT, Zero)
                Name (SCRA, Zero)
                Method (MHAT, 1, NotSerialized)
                {
                    If (LAnd (WNTF, One))
                    {
                        Store (Arg0, Local0)
                        Store (FTPS, Local1)
                        If (And (Arg0, 0x00010000))
                        {
                            Store (One, FTPS)
                        }
                        Else
                        {
                            Store (Zero, FTPS)
                        }
                        If (XOr (FTPS, Local1))
                        {
                            PNTF (0x80)
                        }
                        If (And (Arg0, 0x00040000))
                        {
                            Store (One, SCRM)
                        }
                        Return (One)
                    }
                    Return (Zero)
                }
                Method (MHGT, 1, NotSerialized)
                {
                    If (LAnd (WNTF, One))
                    {
                        Store (0x01000000, Local0)
                        Or (Arg0, 0x00FFFFFF, Local0)
                        Or (Local0, 0x08000000, Local0)
                        If (SCRM)
                        {
                            Or (Local0, 0x10000000, Local0)
                        }
                        Else
                        {
                            And (Local0, 0xEFFFFFFF, Local0)
                        }
                        If (FTPS)
                        {
                            Or (Local0, 0x02000000, Local0)
                        }
                        Else
                        {
                            And (Local0, 0xFDFFFFFF, Local0)
                        }
                        Return (Local0)
                    }
                    Return (Zero)
                }
                Method (PSSG, 1, NotSerialized)
                {
                    Return (PSIF (Zero, Zero))
                }
                Method (PSSS, 1, NotSerialized)
                {
                    Return (PSIF (One, Arg0))
                }
                Method (PSBS, 1, NotSerialized)
                {
                    Return (PSIF (0x02, Arg0))
                }
                Method (BICG, 1, NotSerialized)
                {
                    Return (PSIF (0x03, Arg0))
                }
                Method (BICS, 1, NotSerialized)
                {
                    Return (PSIF (0x04, Arg0))
                }
                Method (BCTG, 1, NotSerialized)
                {
                    Return (PSIF (0x05, Arg0))
                }
                Method (BCCS, 1, NotSerialized)
                {
                    Return (PSIF (0x06, Arg0))
                }
                Method (BCSG, 1, NotSerialized)
                {
                    Return (PSIF (0x07, Arg0))
                }
                Method (BCSS, 1, NotSerialized)
                {
                    Return (PSIF (0x08, Arg0))
                }
                Method (BDSG, 1, NotSerialized)
                {
                    Return (PSIF (0x09, Arg0))
                }
                Method (BDSS, 1, NotSerialized)
                {
                    Return (PSIF (0x0A, Arg0))
                }
                Method (GHSL, 1, NotSerialized)
                {
                    Return (FNSC (Zero, Zero))
                }
                Method (SHSL, 1, NotSerialized)
                {
                    Return (FNSC (One, And (Arg0, One)))
                }
                Method (GSMS, 1, NotSerialized)
                {
                    Return (AUDC (Zero, Zero))
                }
                Method (SSMS, 1, NotSerialized)
                {
                    Return (AUDC (One, And (Arg0, One)))
                }
                Method (SHDA, 1, NotSerialized)
                {
                    Return (AUDC (0x02, Zero))
                }
                Method (SBSG, 1, NotSerialized)
                {
                    Return (SYBC (Zero, Zero))
                }
                Method (SBSS, 1, NotSerialized)
                {
                    Return (SYBC (One, Arg0))
                }
                Mutex (GSBM, 0x07)
                Name (BATI, Buffer (0x0100) {})
                Method (SBIG, 1, NotSerialized)
                {
                    CreateField (BATI, Zero, 0x80, BA00)
                    CreateField (BATI, 0x80, 0x80, BA01)
                    CreateField (BATI, 0x0100, 0x80, BA02)
                    CreateField (BATI, 0x0180, 0x80, BA03)
                    CreateField (BATI, 0x0200, 0x80, BA04)
                    CreateField (BATI, 0x0280, 0x80, BA05)
                    CreateField (BATI, 0x0300, 0x80, BA06)
                    CreateField (BATI, 0x0380, 0x80, BA07)
                    CreateField (BATI, 0x0400, 0x80, BA08)
                    CreateField (BATI, 0x0480, 0x80, BA09)
                    CreateField (BATI, 0x0500, 0x80, BA0A)
                    CreateField (BATI, 0x0580, 0x80, BA0B)
                    CreateField (BATI, 0x0600, 0x80, BA0C)
                    CreateField (BATI, 0x0680, 0x80, BA0D)
                    CreateField (BATI, 0x0700, 0x80, BA0E)
                    CreateField (BATI, 0x0780, 0x80, BA0F)
                    If (BFAD)
                    {
                        Sleep (0x03E8)
                    }
                    CBIF (Arg0, Zero)
                    Store (IF00, BA00)
                    CBIF (Arg0, 0x03)
                    Store (IF03, BA03)
                    CBIF (Arg0, 0x04)
                    Store (IF04, BA04)
                    CBIF (Arg0, 0x05)
                    Store (IF05, BA05)
                    CBIF (Arg0, 0x06)
                    Store (IF06, BA06)
                    CBIF (Arg0, 0x07)
                    Store (IF07, BA07)
                    CBIF (Arg0, 0x08)
                    Store (IF08, BA08)
                    CBIF (Arg0, 0x09)
                    Store (IF09, BA09)
                    If (BFAD)
                    {
                        Store (Zero, BFAD)
                        Sleep (0x07D0)
                    }
                    CBIF (Arg0, One)
                    Store (IF01, BA01)
                    CBIF (Arg0, 0x02)
                    Store (IF02, BA02)
                    CBIF (Arg0, 0x0A)
                    Store (IF03, BA0A)
                    CBIF (Arg0, 0x0B)
                    Store (IF0B, BA0B)
                    Store (IF0C, BA0C)
                    Store (IF0D, BA0D)
                    Store (IF0E, BA0E)
                    Store (IF0F, BA0F)
                    Return (BATI)
                }
                Method (PBLG, 1, NotSerialized)
                {
                    Store (BRNS, Local0)
                    Or (Local0, 0x0F00, Local1)
                    Return (Local1)
                }
                Method (PBLS, 1, NotSerialized)
                {
                    If (LAnd (LGreaterEqual (Arg0, Zero), LLessEqual (Arg0, 0x0F)))
                    {
                        Store (Arg0, BRNS)
                        VBRS (Arg0)
                        If (LAnd (LGreater (OSYS, 0x07D0), LLessEqual (OSYS, 0x07D6)))
                        {
                            Store (DerefOf (Index (IBCL, Add (Arg0, 0x02))), EBRL)
                            Store (EBRL, P80H)
                            IBCM (EBRL)
                            MHKQ (0x6050)
                        }
                        Return (Zero)
                    }
                    Return (0x80000000)
                }
                Method (PMSG, 1, NotSerialized)
                {
                    Return (PRSM (Zero, Zero))
                }
                Method (PMSS, 1, NotSerialized)
                {
                    PRSM (One, Arg0)
                    Return (Zero)
                }
                Name (WGFL, Zero)
                Name (SBTS, Zero)
                Method (WLSW, 0, NotSerialized)
                {
                    Return (GSTS)
                }
                Method (GWLS, 0, NotSerialized)
                {
                    If (And (WGSV (0x09), One))
                    {
                        Store (One, GSTS)
                    }
                    Else
                    {
                        Store (Zero, GSTS)
                    }
                    Return (GSTS)
                }
                Method (SWLS, 1, NotSerialized)
                {
                    If (And (Arg0, One))
                    {
                        Store (One, GSTS)
                        WGSV (0x07)
                        WLPC (One)
                        WPWC (One)
                        BPWC (SBTS)
                    }
                    Else
                    {
                        Store (Zero, GSTS)
                        WGSV (0x08)
                        Store (DCBD, SBTS)
                        WLPC (Zero)
                        WPWC (Zero)
                        BPWC (Zero)
                    }
                }
                Method (GWLN, 0, NotSerialized)
                {
                    Store (Zero, Local0)
                    If (WLNP)
                    {
                        Store (One, Local0)
                        Or (WGFL, 0x0100, WGFL)
                    }
                    Else
                    {
                        And (WGFL, 0xFFFFFEFF, WGFL)
                    }
                    If (LAnd (WLPS (), LNot (WOFF)))
                    {
                        Or (Local0, 0x02, Local0)
                    }
                    Else
                    {
                        And (Local0, 0xFFFFFFFD, Local0)
                    }
                    Return (Local0)
                }
                Method (SWLN, 1, NotSerialized)
                {
                    If (LAnd (And (Arg0, 0x02), LAnd (And (WGFL, 0x0100
                        ), One)))
                    {
                        Or (WGFL, 0x0400, WGFL)
                        WGSV (0x05)
                        Store (Zero, WOFF)
                        WLPC (One)
                    }
                    Else
                    {
                        And (WGFL, 0xFFFFFBFF, WGFL)
                        WGSV (0x06)
                        Store (One, WOFF)
                        WLPC (Zero)
                    }
                }
                Method (GWAN, 0, NotSerialized)
                {
                    Store (Zero, Local0)
                    If (WANP)
                    {
                        Store (One, Local0)
                        Or (WGFL, One, WGFL)
                    }
                    Else
                    {
                        And (WGFL, 0xFFFFFFFE, WGFL)
                    }
                    If (CWAI)
                    {
                        Or (WGFL, 0x08, WGFL)
                    }
                    If (And (WGFL, 0x08))
                    {
                        Return (Local0)
                    }
                    If (WPWS ())
                    {
                        Or (Local0, 0x02, Local0)
                    }
                    Else
                    {
                        And (Local0, 0xFFFFFFFD, Local0)
                    }
                    Or (Local0, 0x04, Local0)
                    Return (Local0)
                }
                Method (SWAN, 1, NotSerialized)
                {
                    If (LAnd (And (Arg0, 0x02), LAnd (And (WGFL, One
                        ), One)))
                    {
                        Or (WGFL, 0x04, WGFL)
                        WGSV (0x02)
                        WPWC (One)
                    }
                    Else
                    {
                        And (WGFL, 0xFFFFFFFB, WGFL)
                        WGSV (0x03)
                        WPWC (Zero)
                    }
                }
                Method (GBDC, 0, NotSerialized)
                {
                    Store (Zero, Local0)
                    If (BTMD)
                    {
                        Store (One, Local0)
                        Or (WGFL, 0x10, WGFL)
                    }
                    Else
                    {
                        And (WGFL, 0xFFFFFFEF, WGFL)
                    }
                    If (CBCI)
                    {
                        Store (0x80, WGFL)
                        Return (Local0)
                    }
                    If (BPWS ())
                    {
                        Or (Local0, 0x02, Local0)
                    }
                    Else
                    {
                        And (Local0, 0xFFFFFFFD, Local0)
                    }
                    Or (Local0, 0x04, Local0)
                    Return (Local0)
                }
                Method (SBDC, 1, NotSerialized)
                {
                    If (And (Arg0, 0x02))
                    {
                        BPWC (One)
                    }
                    Else
                    {
                        BPWC (Zero)
                    }
                    If (And (Arg0, 0x04))
                    {
                        Or (WGFL, 0x40, WGFL)
                    }
                    Else
                    {
                        And (WGFL, 0xFFFFFFFFFFFFFFBF, WGFL)
                    }
                }
                Method (WLPS, 0, NotSerialized)
                {
                    If (ECON)
                    {
                        Store (DCWL, Local0)
                    }
                    Else
                    {
                        Store (ShiftRight (And (RBEC (0x3A), 0x20), 0x06), Local0)
                    }
                    Return (Local0)
                }
                Method (WLTG, 0, NotSerialized)
                {
                    If (And (WGFL, 0x0100))
                    {
                        WLPC (LNot (WLPS ()))
                    }
                }
                Method (WLPC, 1, NotSerialized)
                {
                    Store (One, WANA)
                    If (LAnd (Arg0, LAnd (GSTS, And (WGSV (One), 0x0400))))
                    {
                        If (ECON)
                        {
                            Store (One, DCWL)
                        }
                        Else
                        {
                            MBEC (0x3A, 0xFF, 0x20)
                        }
                        Store (One, GO70)
                        Or (WGFL, 0x0200, WGFL)
                    }
                    Else
                    {
                        If (ECON)
                        {
                            Store (Zero, DCWL)
                        }
                        Else
                        {
                            MBEC (0x3A, 0xDF, Zero)
                        }
                        Store (Zero, GO70)
                        And (WGFL, 0xFFFFFDFF, WGFL)
                    }
                }
                Method (WPWS, 0, NotSerialized)
                {
                    If (ECON)
                    {
                        Store (DCWW, Local0)
                    }
                    Else
                    {
                        Store (ShiftRight (And (RBEC (0x3A), 0x40), 0x06), Local0)
                    }
                    Return (Local0)
                }
                Method (WTGL, 0, NotSerialized)
                {
                    If (And (WGFL, One))
                    {
                        WPWC (LNot (WPWS ()))
                    }
                }
                Method (WPWC, 1, NotSerialized)
                {
                    Store (One, WWNA)
                    If (LAnd (Arg0, LAnd (GSTS, And (WGSV (One), 0x04))))
                    {
                        If (ECON)
                        {
                            Store (One, DCWW)
                        }
                        Else
                        {
                            MBEC (0x3A, 0xFF, 0x40)
                        }
                        Store (One, GO71)
                        Or (WGFL, 0x02, WGFL)
                    }
                    Else
                    {
                        If (ECON)
                        {
                            Store (Zero, DCWW)
                        }
                        Else
                        {
                            MBEC (0x3A, 0xBF, Zero)
                        }
                        Store (Zero, GO71)
                        And (WGFL, 0xFFFFFFFD, WGFL)
                    }
                    Store (DCWW, WALA)
                }
                Method (BPWS, 0, NotSerialized)
                {
                    If (ECON)
                    {
                        Store (DCBD, Local0)
                    }
                    Else
                    {
                        Store (ShiftRight (And (RBEC (0x3A), 0x10), 0x04), Local0)
                    }
                    Return (Local0)
                }
                Method (BTGL, 0, NotSerialized)
                {
                    If (And (WGFL, 0x10))
                    {
                        BPWC (LNot (BPWS ()))
                    }
                }
                Method (BPWC, 1, NotSerialized)
                {
                    Store (One, BTHA)
                    If (LAnd (Arg0, LAnd (And (WGFL, 0x10), LNot (And (
                        WGFL, 0x80)))))
                    {
                        If (ECON)
                        {
                            Store (One, DCBD)
                            Store (DCBD, GO35)
                        }
                        Else
                        {
                            MBEC (0x3A, 0xFF, 0x10)
                        }
                        Or (WGFL, 0x20, WGFL)
                        BLTH (0x02)
                    }
                    Else
                    {
                        If (ECON)
                        {
                            Store (Zero, DCBD)
                            Store (DCBD, GO35)
                        }
                        Else
                        {
                            MBEC (0x3A, 0xEF, Zero)
                        }
                        And (WGFL, Zero, WGFL)
                        BLTH (0x03)
                    }
                }
                Method (WGPS, 1, NotSerialized)
                {
                    If (LGreaterEqual (Arg0, 0x04))
                    {
                        BLTH (0x05)
                    }
                    If (LNot (And (WGFL, 0x04)))
                    {
                        WPWC (Zero)
                    }
                    If (LNot (And (WGFL, 0x40)))
                    {
                        BPWC (Zero)
                    }
                }
                Method (WGWK, 1, NotSerialized)
                {
                    If (And (WGFL, 0x20))
                    {
                        BPWC (One)
                    }
                    If (And (WGFL, 0x02))
                    {
                        WPWC (One)
                    }
                }
                Method (TVLG, 0, NotSerialized)
                {
                    Store (Zero, Local0)
                    Return (Local0)
                }
                Method (TVLS, 1, NotSerialized)
                {
                    Store (Zero, Local0)
                    Store (Arg0, Local0)
                    And (Local0, 0x02, Local0)
                    If (Local0)
                    {
                        Store (Arg0, Local0)
                        And (Local0, One, Local0)
                        If (Local0)
                        {
                            Store (Arg0, Local0)
                            And (Local0, 0xFF00, Local0)
                            ShiftRight (Local0, 0x08, Local0)
                            If (LEqual (Local0, Zero)) {}
                            If (LEqual (Local0, One)) {}
                            If (LEqual (Local0, 0x02)) {}
                        }
                        Else
                        {
                        }
                    }
                    Else
                    {
                    }
                }
                Method (GLSI, 0, NotSerialized)
                {
                }
                Method (NUMG, 0, NotSerialized)
                {
                    Store (Zero, Local0)
                    Return (Local0)
                }
                Method (HKS3, 0, NotSerialized)
                {
                    If (BTMD)
                    {
                        If (DCBD)
                        {
                            Store (One, GO35)
                        }
                        Else
                        {
                            Store (Zero, GO35)
                        }
                    }
                    Else
                    {
                        Store (Zero, GO35)
                        Store (Zero, DCBD)
                    }
                    If (WANP)
                    {
                        If (DCWW)
                        {
                            Store (One, GO71)
                        }
                        Else
                        {
                            Store (Zero, GO71)
                        }
                    }
                    Else
                    {
                        Store (Zero, GO71)
                        Store (Zero, DCWW)
                    }
                    If (WLNP)
                    {
                        If (WOFF)
                        {
                            Store (Zero, GO70)
                        }
                        Else
                        {
                            If (DCWL)
                            {
                                Store (One, GO70)
                            }
                            Else
                            {
                                Store (Zero, GO70)
                            }
                        }
                    }
                    Else
                    {
                        Store (Zero, GO70)
                        Store (Zero, DCWL)
                    }
                }
            }
        }
    }
    Scope (_SB)
    {
        Device (ACAD)
        {
            Name (_HID, "ACPI0003")
            Name (_PCL, Package (0x01)
            {
                _SB
            })
            Method (_PSR, 0, NotSerialized)
            {
                If (ECON)
                {
                    Store (^^PCI0.LPCB.EC.ACPW, ACST)
                    Sleep (0x64)
                    Store (^^PCI0.LPCB.EC.ACPW, PWRS)
                }
                Return (PWRS)
            }
        }
    }
    Scope (_SB)
    {
        Mutex (BATM, 0x00)
        Name (BASC, One)
        Name (SBCM, Buffer (One)
        {
            0x00
        })
        Name (SBFC, Buffer (0x02)
        {
            0x00, 0x00
        })
        Name (SBDC, Buffer (0x02)
        {
            0x00, 0x00
        })
        Name (SBDV, Buffer (0x02)
        {
            0x00, 0x00
        })
        Name (SBSN, Buffer (0x02)
        {
            0x00, 0x00
        })
        Name (SBDN, Buffer (0x10)
        {
            /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        })
        Name (SBCH, Buffer (0x04)
        {
            0x00, 0x00, 0x00, 0x00
        })
        Name (SBMN, Buffer (0x10)
        {
            /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        })
        Method (GBFE, 3, NotSerialized)
        {
            CreateByteField (Arg0, Arg1, TIDX)
            Store (TIDX, Arg2)
        }
        Method (PBFE, 3, NotSerialized)
        {
            CreateByteField (Arg0, Arg1, TIDX)
            Store (Arg2, TIDX)
        }
        Method (ITOS, 1, NotSerialized)
        {
            Store (Buffer (0x09)
                {
                    /* 0000 */    0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                    /* 0008 */    0x00
                }, Local0)
            Store (Buffer (0x11)
                {
                    "0123456789ABCDEF"
                }, Local7)
            Store (0x08, Local1)
            Store (Zero, Local2)
            Store (Zero, Local3)
            While (Local1)
            {
                Decrement (Local1)
                And (ShiftRight (Arg0, ShiftLeft (Local1, 0x02)), 0x0F, Local4)
                If (Local4)
                {
                    Store (Ones, Local3)
                }
                If (Local3)
                {
                    GBFE (Local7, Local4, RefOf (Local5))
                    PBFE (Local0, Local2, Local5)
                    Increment (Local2)
                }
            }
            Return (Local0)
        }
        Method (WAEC, 0, NotSerialized)
        {
            Name (CUNT, 0x14)
            While (LEqual (^PCI0.LPCB.EC.HSID, Zero))
            {
                Sleep (0x05)
                Decrement (CUNT)
                If (LEqual (CUNT, Zero))
                {
                    Break
                }
            }
        }
        Method (GBIF, 3, NotSerialized)
        {
            If (Arg2)
            {
//rehabman: in the end you might want to re-enable this test of BASC (if everything works)
                //If (LNotEqual (BASC, Zero))
                If (1)  //make it always get from EC, not from cached
                {
                    Acquire (BATM, 0xFFFF)
                    Or (Arg0, One, ^PCI0.LPCB.EC.HIID)
                    WAEC ()
                    Store (^PCI0.LPCB.EC.SBCM, Local7)
                    Store (^PCI0.LPCB.EC.SBCM, SBCM)
                    XOr (Local7, One, Index (Arg1, Zero)) //output: Power Unit
                    Store (Arg0, ^PCI0.LPCB.EC.HIID)
                    WAEC ()
                    If (Local7)
                    {
                        Multiply (B1B2 (^PCI0.LPCB.EC.BFC0, ^PCI0.LPCB.EC.BFC1), 0x0A, Index (Arg1, 0x02)) //output: last full charge
                    }
                    Else
                    {
                        Store (B1B2 (^PCI0.LPCB.EC.BFC0, ^PCI0.LPCB.EC.BFC1), Index (Arg1, 0x02)) //output: last full charge
                    }
                    Store (B1B2 (^PCI0.LPCB.EC.BFC0, ^PCI0.LPCB.EC.BFC1), SBFC)
                    Or (Arg0, 0x02, ^PCI0.LPCB.EC.HIID)
                    WAEC ()
                    If (Local7)
                    {
                        Multiply (B1B2 (^PCI0.LPCB.EC.BDC0, ^PCI0.LPCB.EC.BDC1), 0x0A, Local0)
                    }
                    Else
                    {
                        Store (B1B2 (^PCI0.LPCB.EC.BDC0, ^PCI0.LPCB.EC.BDC1), Local0)
                    }
                    Store (B1B2 (^PCI0.LPCB.EC.BDC0, ^PCI0.LPCB.EC.BDC1), SBDC)
                    Store (Local0, Index (Arg1, One)) //output: design cap
                    Divide (Local0, 0x14, Local1, Index (Arg1, 0x05)) //output: warning capacity (5% of design)
                    Divide (Local0, 0x64, Local1, Index (Arg1, 0x06)) //output: low capacity (1% of design)
                    Store (B1B2 (^PCI0.LPCB.EC.BDV0, ^PCI0.LPCB.EC.BDV1), Index (Arg1, 0x04)) //output: design voltage
                    Store (B1B2 (^PCI0.LPCB.EC.BDV0, ^PCI0.LPCB.EC.BDV1), SBDV)
//rehabman: serial number
/*                    
                    Store (B1B2 (^PCI0.LPCB.EC.BSN0, ^PCI0.LPCB.EC.BSN1), Local0)
                    Store (B1B2 (^PCI0.LPCB.EC.BSN0, ^PCI0.LPCB.EC.BSN1), SBSN)
                    Name (SERN, Buffer (0x06)
                    {
                        "     "
                    })
                    Store (0x04, Local2)
                    While (Local0)
                    {
                        Divide (Local0, 0x0A, Local1, Local0)
                        Add (Local1, 0x30, Index (SERN, Local2))
                        Decrement (Local2)
                    }
                    Store (SERN, Index (Arg1, 0x0A))
*/
//rehabman: model number
                    Or (Arg0, 0x06, ^PCI0.LPCB.EC.HIID)
                    WAEC ()
                    //Store (^PCI0.LPCB.EC.SBDN, Index (Arg1, 0x09))
                    //Store (^PCI0.LPCB.EC.SBDN, SBDN)
/*                    
 Store (^PCI0.LPCB.EC.BDN0, Index(SBDN, 0))
 Store (^PCI0.LPCB.EC.BDN1, Index(SBDN, 1))
 Store (^PCI0.LPCB.EC.BDN2, Index(SBDN, 2))
 Store (^PCI0.LPCB.EC.BDN3, Index(SBDN, 3))
 Store (^PCI0.LPCB.EC.BDN4, Index(SBDN, 4))
 Store (^PCI0.LPCB.EC.BDN5, Index(SBDN, 5))
 Store (^PCI0.LPCB.EC.BDN6, Index(SBDN, 6))
 Store (^PCI0.LPCB.EC.BDN7, Index(SBDN, 7))
 Store (^PCI0.LPCB.EC.BDN8, Index(SBDN, 8))
 Store (^PCI0.LPCB.EC.BDN9, Index(SBDN, 9))
 Store (^PCI0.LPCB.EC.BDNA, Index(SBDN, 0xA))
 Store (^PCI0.LPCB.EC.BDNB, Index(SBDN, 0xB))
 Store (^PCI0.LPCB.EC.BDNC, Index(SBDN, 0xC))
 Store (^PCI0.LPCB.EC.BDND, Index(SBDN, 0xD))
 Store (^PCI0.LPCB.EC.BDNE, Index(SBDN, 0xE))
 Store (^PCI0.LPCB.EC.BDNF, Index(SBDN, 0xF))
 Store (SBDN, Index (Arg1, 0x09))
*/ 
//rehabman: battery type
/*
                    Or (Arg0, 0x04, ^PCI0.LPCB.EC.HIID)
                    WAEC ()
                    Name (BTYP, Buffer (0x05)
                    {
                        0x00, 0x00, 0x00, 0x00, 0x00
                    })
                    //Store (^PCI0.LPCB.EC.SBCH, BTYP)
 Store (^PCI0.LPCB.EC.BCH0, Index(BTYP, 0))
 Store (^PCI0.LPCB.EC.BCH1, Index(BTYP, 1))
 Store (^PCI0.LPCB.EC.BCH2, Index(BTYP, 2))
 Store (^PCI0.LPCB.EC.BCH3, Index(BTYP, 3))
                    //Store (^PCI0.LPCB.EC.SBCH, SBCH)
 Store (^PCI0.LPCB.EC.BCH0, Index(SBCH, 0))
 Store (^PCI0.LPCB.EC.BCH1, Index(SBCH, 1))
 Store (^PCI0.LPCB.EC.BCH2, Index(SBCH, 2))
 Store (^PCI0.LPCB.EC.BCH3, Index(SBCH, 3))
                    Store (BTYP, Index (Arg1, 0x0B))
*/
//rehabman: manufacturer
/*
                    Or (Arg0, 0x05, ^PCI0.LPCB.EC.HIID)
                    WAEC ()
                    //Store (^PCI0.LPCB.EC.SBMN, Index (Arg1, 0x0C))
                    //Store (^PCI0.LPCB.EC.SBMN, SBMN)
 Store (^PCI0.LPCB.EC.BMN0, Index(SBMN, 0))
 Store (^PCI0.LPCB.EC.BMN1, Index(SBMN, 1))
 Store (^PCI0.LPCB.EC.BMN2, Index(SBMN, 2))
 Store (^PCI0.LPCB.EC.BMN3, Index(SBMN, 3))
 Store (^PCI0.LPCB.EC.BMN4, Index(SBMN, 4))
 Store (^PCI0.LPCB.EC.BMN5, Index(SBMN, 5))
 Store (^PCI0.LPCB.EC.BMN6, Index(SBMN, 6))
 Store (^PCI0.LPCB.EC.BMN7, Index(SBMN, 7))
 Store (^PCI0.LPCB.EC.BMN8, Index(SBMN, 8))
 Store (^PCI0.LPCB.EC.BMN9, Index(SBMN, 9))
 Store (^PCI0.LPCB.EC.BMNA, Index(SBMN, 0xA))
 Store (^PCI0.LPCB.EC.BMNB, Index(SBMN, 0xB))
 Store (^PCI0.LPCB.EC.BMNC, Index(SBMN, 0xC))
 Store (^PCI0.LPCB.EC.BMND, Index(SBMN, 0xD))
 Store (^PCI0.LPCB.EC.BMNE, Index(SBMN, 0xE))
 Store (^PCI0.LPCB.EC.BMNF, Index(SBMN, 0xF))
 Store (SBMN, Index (Arg1, 0x0C))
*/                    
                    Store (Zero, BASC)
                    Release (BATM)
                }
                Else
                {
                    Store (ToInteger (SBCM), Local7)
                    XOr (Local7, One, Index (Arg1, Zero))
                    If (Local7)
                    {
                        Multiply (ToInteger (SBFC), 0x0A, Index (Arg1, 0x02))
                    }
                    Else
                    {
                        Store (ToInteger (SBFC), Index (Arg1, 0x02))
                    }
                    If (Local7)
                    {
                        Multiply (ToInteger (SBDC), 0x0A, Local0)
                    }
                    Else
                    {
                        Store (ToInteger (SBDC), Local0)
                    }
                    Store (Local0, Index (Arg1, One))
                    Divide (Local0, 0x14, Local1, Index (Arg1, 0x05))
                    Divide (Local0, 0x64, Local1, Index (Arg1, 0x06))
                    Store (ToInteger (SBDV), Index (Arg1, 0x04))
                    Store (ToInteger (SBSN), Local0)
                    Name (SRNB, Buffer (0x06)
                    {
                        "     "
                    })
                    Store (0x04, Local2)
                    While (Local0)
                    {
                        Divide (Local0, 0x0A, Local1, Local0)
                        Add (Local1, 0x30, Index (SRNB, Local2))
                        Decrement (Local2)
                    }
                    Store (SRNB, Index (Arg1, 0x0A))
                    Store (ToString (SBDN, Ones), Index (Arg1, 0x09))
                    Name (BTTP, Buffer (0x05)
                    {
                        0x00, 0x00, 0x00, 0x00, 0x00
                    })
                    Store (ToBuffer (SBCH), BTTP)
                    Store (BTTP, Index (Arg1, 0x0B))
                    Store (ToString (SBMN, Ones), Index (Arg1, 0x0C))
                }
            }
            Else
            {
                Store (0xFFFFFFFF, Index (Arg1, One))
                Store (Zero, Index (Arg1, 0x05))
                Store (Zero, Index (Arg1, 0x06))
                Store (0xFFFFFFFF, Index (Arg1, 0x02))
            }
            Return (Arg1)
        }
        Method (GBST, 4, NotSerialized)
        {
            If (^PCI0.LPCB.EC.BFUD)
            {
                BFUD ()
            }
            Acquire (BATM, 0xFFFF)
            If (And (Arg1, 0x20))
            {
                Store (0x02, Local0)
            }
            Else
            {
                If (And (Arg1, 0x40))
                {
                    Store (One, Local0)
                }
                Else
                {
                    Store (Zero, Local0)
                }
            }
            If (And (Arg1, 0x0F)) {}
            Else
            {
                Or (Local0, 0x04, Local0)
            }
            If (LEqual (And (Arg1, 0x0F), 0x0F))
            {
                Store (0x04, Local0)
                Store (Zero, Local1)
                Store (Zero, Local2)
                Store (Zero, Local3)
            }
            Else
            {
                Store (B1B2 (^PCI0.LPCB.EC.CVO0, ^PCI0.LPCB.EC.CVO1), Local3)
                If (Arg2)
                {
                    Multiply (B1B2 (^PCI0.LPCB.EC.CRC0, ^PCI0.LPCB.EC.CRC1), 0x0A, Local2)
                }
                Else
                {
                    Store (B1B2 (^PCI0.LPCB.EC.CRC0, ^PCI0.LPCB.EC.CRC1), Local2)
                }
                Store (B1B2 (^PCI0.LPCB.EC.CAC0, ^PCI0.LPCB.EC.CAC1), Local1)
                If (LGreaterEqual (Local1, 0x8000))
                {
                    If (And (Local0, One))
                    {
                        Subtract (0x00010000, Local1, Local1)
                    }
                    Else
                    {
                        Store (Zero, Local1)
                    }
                }
                Else
                {
                    If (LNot (And (Local0, 0x02)))
                    {
                        Store (Zero, Local1)
                    }
                }
                If (Arg2)
                {
                    Multiply (Local3, Local1, Local1)
                    Divide (Local1, 0x03E8, Local7, Local1)
                }
            }
            Store (Local0, Index (Arg3, Zero))
            Store (Local1, Index (Arg3, One))
            Store (Local2, Index (Arg3, 0x02))
            Store (Local3, Index (Arg3, 0x03))
            Release (BATM)
            Return (Arg3)
        }
        Device (BAT1)
        {
            Name (_HID, EisaId ("PNP0C0A"))
            Name (_UID, One)
            Name (_PCL, Package (0x01)
            {
                _SB
            })
            Name (B0ST, Zero)
            Name (BT0I, Package (0x0D)
            {
                Zero, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                One, 
                0x2A30, 
                Zero, 
                Zero, 
                One, 
                One, 
//rehabman: you could fill in with defaults instead of empty strings
                "123456",			//model number
                "54321", 			//serial number
                "LIon", 			//battery type
                "Lenovo"			//oem information
            })
            Name (BT0P, Package (0x04) {})
            Method (_STA, 0, NotSerialized)
            {
                If (ECON)
                {
                    If (LNotEqual (^^PCI0.LPCB.EC.MBTS, B0ST))
                    {
                        Store (One, BASC)
                    }
                    Store (^^PCI0.LPCB.EC.MBTS, B0ST)
                }
                Else
                {
                    If (And (RBEC (0x38), 0x80))
                    {
                        Store (One, B0ST)
                    }
                    Else
                    {
                        Store (Zero, B0ST)
                    }
                }
                If (B0ST)
                {
                    Return (0x1F)
                }
                Else
                {
                    Return (0x0F)
                }
            }
            Method (_BIF, 0, NotSerialized)
            {
                Store (Zero, Local7)
                Store (0x01F4, Local6)
                While (LAnd (LNot (Local7), Local6))
                {
                    If (^^PCI0.LPCB.EC.MBTS)
                    {
                        If (LEqual (And (^^PCI0.LPCB.EC.HB0S, 0x0F), 0x0F))
                        {
                            Sleep (0x14)
                            Decrement (Local6)
                        }
                        Else
                        {
                            Store (One, Local7)
                        }
                    }
                    Else
                    {
                        Store (Zero, Local6)
                    }
                }
                Return (GBIF (Zero, BT0I, Local7))
            }
            Method (_BST, 0, NotSerialized)
            {
                XOr (DerefOf (Index (BT0I, Zero)), One, Local0)
                Return (GBST (Zero, ^^PCI0.LPCB.EC.HB0S, Local0, BT0P))
            }
            Method (_BTP, 1, NotSerialized)
            {
                And (^^PCI0.LPCB.EC.HAM4, 0xEF, ^^PCI0.LPCB.EC.HAM4)
                If (Arg0)
                {
                    Store (Arg0, Local1)
                    If (LNot (DerefOf (Index (BT0I, Zero))))
                    {
                        Divide (Local1, 0x0A, Local0, Local1)
                    }
                    And (Local1, 0xFF, ^^PCI0.LPCB.EC.HT0L)
                    And (ShiftRight (Local1, 0x08), 0xFF, ^^PCI0.LPCB.EC.HT0H)
                    Or (^^PCI0.LPCB.EC.HAM4, 0x10, ^^PCI0.LPCB.EC.HAM4)
                }
            }
        }
    }
    Scope (_SB)
    {
        Device (LID)
        {
            Name (_HID, EisaId ("PNP0C0D"))
            Name (_PRW, Package (0x02)
            {
                0x18, 
                0x03
            })
            Method (_LID, 0, NotSerialized)
            {
                If (ECON)
                {
                    Store (^^PCI0.LPCB.EC.HPLD, Local0)
                    If (LAnd (LGreater (OSYS, 0x07D0), LLess (OSYS, 0x07D6)))
                    {
                        ^^PCI0.GFX0.GLID (Local0)
                    }
                    Else
                    {
                        Store (Local0, ^^PCI0.GFX0.CLID)
                    }
                    Return (Local0)
                }
                Else
                {
                    If (And (RBEC (0x46), 0x04))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }
            Method (_PSW, 1, NotSerialized)
            {
                If (ECON)
                {
                    If (Arg0)
                    {
                        Store (One, ^^PCI0.LPCB.EC.HWLO)
                        Store (One, LIDX)
                    }
                    Else
                    {
                        Store (Zero, ^^PCI0.LPCB.EC.HWLO)
                        Store (Zero, LIDX)
                    }
                }
                Else
                {
                    If (Arg0)
                    {
                        MBEC (0x32, 0xFF, 0x04)
                    }
                    Else
                    {
                        MBEC (0x32, 0xFB, Zero)
                    }
                }
            }
        }
    }
    Scope (_SB)
    {
        Device (WMI1)
        {
            Name (_HID, EisaId ("PNP0C14"))
            Name (_UID, One)
            Name (_WDG, Buffer (0xA0)
            {
                /* 0000 */    0x0E, 0x23, 0xF5, 0x51, 0x77, 0x96, 0xCD, 0x46, 
                /* 0008 */    0xA1, 0xCF, 0xC0, 0xB2, 0x3E, 0xE3, 0x4D, 0xB7, 
                /* 0010 */    0x41, 0x30, 0x80, 0x05, 0x64, 0x9A, 0x47, 0x98, 
                /* 0018 */    0xF5, 0x33, 0x33, 0x4E, 0xA7, 0x07, 0x8E, 0x25, 
                /* 0020 */    0x1E, 0xBB, 0xC3, 0xA1, 0x41, 0x31, 0x01, 0x06, 
                /* 0028 */    0xEF, 0x54, 0x4B, 0x6A, 0xED, 0xA5, 0x33, 0x4D, 
                /* 0030 */    0x94, 0x55, 0xB0, 0xD9, 0xB4, 0x8D, 0xF4, 0xB3, 
                /* 0038 */    0x41, 0x32, 0x01, 0x06, 0xB6, 0xEB, 0xF1, 0x74, 
                /* 0040 */    0x7A, 0x92, 0x7D, 0x4C, 0x95, 0xDF, 0x69, 0x8E, 
                /* 0048 */    0x21, 0xE8, 0x0E, 0xB5, 0x41, 0x33, 0x01, 0x06, 
                /* 0050 */    0xFF, 0x04, 0xEF, 0x7E, 0x28, 0x43, 0x7C, 0x44, 
                /* 0058 */    0xB5, 0xBB, 0xD4, 0x49, 0x92, 0x5D, 0x53, 0x8D, 
                /* 0060 */    0x41, 0x34, 0x01, 0x06, 0x9E, 0x15, 0xDB, 0x8A, 
                /* 0068 */    0x32, 0x1E, 0x5C, 0x45, 0xBC, 0x93, 0x30, 0x8A, 
                /* 0070 */    0x7E, 0xD9, 0x82, 0x46, 0x41, 0x35, 0x01, 0x01, 
                /* 0078 */    0xFD, 0xD9, 0x51, 0x26, 0x1C, 0x91, 0x69, 0x4B, 
                /* 0080 */    0xB9, 0x4E, 0xD0, 0xDE, 0xD5, 0x96, 0x3B, 0xD7, 
                /* 0088 */    0x41, 0x36, 0x01, 0x06, 0x21, 0x12, 0x90, 0x05, 
                /* 0090 */    0x66, 0xD5, 0xD1, 0x11, 0xB2, 0xF0, 0x00, 0xA0, 
                /* 0098 */    0xC9, 0x06, 0x29, 0x10, 0x42, 0x41, 0x01, 0x00
            })
            Name (RETN, Package (0x05)
            {
                "Success", 
                "Not Supported", 
                "Invalid Parameter", 
                "Access Denied", 
                "System Busy"
            })
            Name (ITEM, Package (0x68)
            {
                Package (0x02)
                {
                    0x1C, 
                    "WakeOnLAN"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "FlashOverLAN"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "EthernetLANOptionROM"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "HarddriveDMA"
                }, 
                Package (0x02)
                {
                    0x04, 
                    "WirelessLANandWiMAXRadios"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "SerialPort"
                }, 
                Package (0x02)
                {
                    0x10, 
                    "SerialPortIO"
                }, 
                Package (0x02)
                {
                    0x06, 
                    "SerialPortIRQ"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "ParallelPort"
                }, 
                Package (0x02)
                {
                    0x09, 
                    "ParallelPortMode"
                }, 
                Package (0x02)
                {
                    0x11, 
                    "ParallelPortIO"
                }, 
                Package (0x02)
                {
                    0x07, 
                    "ParallelPortIRQ"
                }, 
                Package (0x02)
                {
                    0x08, 
                    "ParallelPortDMA"
                }, 
                Package (0x02)
                {
                    0x12, 
                    "PCIINTA"
                }, 
                Package (0x02)
                {
                    0x12, 
                    "PCIINTB"
                }, 
                Package (0x02)
                {
                    0x12, 
                    "PCIINTC"
                }, 
                Package (0x02)
                {
                    0x12, 
                    "PCIINTD"
                }, 
                Package (0x02)
                {
                    0x12, 
                    "PCIINTE"
                }, 
                Package (0x02)
                {
                    0x12, 
                    "PCIINTF"
                }, 
                Package (0x02)
                {
                    0x12, 
                    "PCIINTG"
                }, 
                Package (0x02)
                {
                    0x12, 
                    "PCIINTH"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "USBBIOSSupport"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "AlwaysOnUSB"
                }, 
                Package (0x02)
                {
                    0x02, 
                    "TrackPoint"
                }, 
                Package (0x02)
                {
                    0x02, 
                    "TouchPad"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "FnKeyLock"
                }, 
                Package (0x02)
                {
                    0x0A, 
                    "ThinkPadNumLock"
                }, 
                Package (0x02)
                {
                    0x17, 
                    "PowerOnNumLock"
                }, 
                Package (0x02)
                {
                    0x0B, 
                    "PrimaryVideo"
                }, 
                Package (0x02)
                {
                    0x0C, 
                    "BootDisplayDevice"
                }, 
                Package (0x02)
                {
                    0x05, 
                    "LCDBrightness"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "TimerWakeWithBattery"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "SpeedStep"
                }, 
                Package (0x02)
                {
                    0x13, 
                    "SpeedStepModeAC"
                }, 
                Package (0x02)
                {
                    0x13, 
                    "SpeedStepModeBattery"
                }, 
                Package (0x02)
                {
                    0x14, 
                    "AdaptiveThermalManagementAC"
                }, 
                Package (0x02)
                {
                    0x14, 
                    "AdaptiveThermalManagementBattery"
                }, 
                Package (0x02)
                {
                    0x0D, 
                    "CDROMSpeed"
                }, 
                Package (0x02)
                {
                    0x02, 
                    "CPUPowerManagement"
                }, 
                Package (0x02)
                {
                    0x02, 
                    "PCIPowerManagement"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "PowerControlBeep"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "LowBatteryAlarm"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "PasswordBeep"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "KeyboardBeep"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "ExtendedMemoryTest"
                }, 
                Package (0x02)
                {
                    0x0E, 
                    "SATAControllerMode"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "CoreMultiProcessing"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "VirtualizationTechnology"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "LegacyDevicesOnMiniDock"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "Passphrase"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "LockBIOSSetting"
                }, 
                Package (0x02)
                {
                    0x16, 
                    "MinimumPasswordLength"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "BIOSPasswordAtUnattendedBoot"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "PasswordResetService"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "FingerprintPredesktopAuthentication"
                }, 
                Package (0x02)
                {
                    0x0F, 
                    "FingerprintReaderPriority"
                }, 
                Package (0x02)
                {
                    0x05, 
                    "FingerprintSecurityMode"
                }, 
                Package (0x02)
                {
                    0x03, 
                    "SecurityChip"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "BIOSUpdateByEndUsers"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "DataExecutionPrevention"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "EthernetLANAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "WirelessLANAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "WirelessWANAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "BluetoothAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "WirelessUSBAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "ModemAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "USBPortAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "IEEE1394Access"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "SerialPortAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "ParallelPortAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "CardBusSlotAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "ExpressCardAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "PCIExpressSlotAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "UltrabayAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "MemoryCardSlotAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "SmartCardSlotAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "IntegratedCameraAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "MicrophoneAccess"
                }, 
                Package (0x02)
                {
                    0x15, 
                    "BootMode"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "StartupOptionKeys"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "BootDeviceListF12Option"
                }, 
                Package (0x02)
                {
                    0x64, 
                    "BootOrder"
                }, 
                Package (0x02)
                {
                    0x64, 
                    "NetworkBootOrder"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "WiMAXAccess"
                }, 
                Package (0x02)
                {
                    0x18, 
                    "GraphicsDevice"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "TXTFeature"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "VTdFeature"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "AMTControl"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "FingerprintPasswordAuthentication"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "FingerprintReaderAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "OsDetectionForSwitchableGraphics"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "ComputraceModuleActivation"
                }, 
                Package (0x02)
                {
                    0x02, 
                    "PCIExpressPowerManagement"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "ATpModuleActivation"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "FullTheftProtectionModuleActivation"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "RemoteDisableModuleActivation"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "eSATAPortAccess"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "HardwarePasswordManager"
                }, 
                Package (0x02)
                {
                    0x1A, 
                    "AlwaysOnUSBMode"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "HyperThreadingTechnology"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "FnCtrlKeySwap"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "BIOSPasswordAtReboot"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "OnByAcAttach"
                }, 
                Package (0x02)
                {
                    Zero, 
                    "ChangeToF1F12Keys"
                }
            })
            Name (VSEL, Package (0x1D)
            {
                Package (0x02)
                {
                    "Disable", 
                    "Enable"
                }, 
                Package (0x02)
                {
                    "Enable", 
                    "Disable"
                }, 
                Package (0x02)
                {
                    "Disable", 
                    "Automatic"
                }, 
                Package (0x04)
                {
                    "Active", 
                    "Inactive", 
                    "Disable", 
                    ""
                }, 
                Package (0x02)
                {
                    "Off", 
                    "On"
                }, 
                Package (0x02)
                {
                    "Normal", 
                    "High"
                }, 
                Package (0x04)
                {
                    "3", 
                    "4", 
                    "5", 
                    "7"
                }, 
                Package (0x02)
                {
                    "5", 
                    "7"
                }, 
                Package (0x04)
                {
                    "0", 
                    "1", 
                    "3", 
                    ""
                }, 
                Package (0x03)
                {
                    "OutputOnly", 
                    "BiDirectional", 
                    "ECP"
                }, 
                Package (0x02)
                {
                    "Independent", 
                    "Synchronized"
                }, 
                Package (0x02)
                {
                    "PCIExpress", 
                    "Internal"
                }, 
                Package (0x10)
                {
                    "LCD", 
                    "VGA", 
                    "Digital", 
                    "Digital1onDock", 
                    "Digital2onDock", 
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    "", 
                    ""
                }, 
                Package (0x04)
                {
                    "High", 
                    "Normal", 
                    "Silent", 
                    ""
                }, 
                Package (0x02)
                {
                    "Compatibility", 
                    "AHCI"
                }, 
                Package (0x02)
                {
                    "External", 
                    "InternalOnly"
                }, 
                Package (0x04)
                {
                    "3F8", 
                    "2F8", 
                    "3E8", 
                    "2E8"
                }, 
                Package (0x04)
                {
                    "378", 
                    "278", 
                    "3BC", 
                    ""
                }, 
                Package (0x10)
                {
                    "Disable", 
                    "AutoSelect", 
                    "", 
                    "3", 
                    "4", 
                    "5", 
                    "6", 
                    "7", 
                    "", 
                    "9", 
                    "10", 
                    "11", 
                    "", 
                    "", 
                    "", 
                    ""
                }, 
                Package (0x04)
                {
                    "MaximumPerformance", 
                    "BatteryOptimized", 
                    "MaximumBattery", 
                    "Automatic"
                }, 
                Package (0x02)
                {
                    "MaximizePerformance", 
                    "Balanced"
                }, 
                Package (0x02)
                {
                    "Quick", 
                    "Diagnostics"
                }, 
                Package (0x0D)
                {
                    "Disable", 
                    "", 
                    "", 
                    "", 
                    "4", 
                    "5", 
                    "6", 
                    "7", 
                    "8", 
                    "9", 
                    "10", 
                    "11", 
                    "12"
                }, 
                Package (0x04)
                {
                    "Auto", 
                    "On", 
                    "Off", 
                    ""
                }, 
                Package (0x04)
                {
                    "IntegratedGfx", 
                    "DiscreteGfx", 
                    "SwitchableGfx", 
                    ""
                }, 
                Package (0x04)
                {
                    "Automatic", 
                    "BlackBerry", 
                    "iPodiPhone", 
                    "OtherUSBDevices"
                }, 
                Package (0x04)
                {
                    "Disable", 
                    "Enable", 
                    "ACOnly", 
                    "ACandBattery"
                }, 
                Package (0x04)
                {
                    "Compatibility", 
                    "AHCI", 
                    "", 
                    "RAID"
                }, 
                Package (0x04)
                {
                    "Disable", 
                    "Enable", 
                    "Enable", 
                    ""
                }
            })
            Name (VLST, Package (0x0E)
            {
                "HDD0", 
                "HDD1", 
                "HDD2", 
                "HDD3", 
                "HDD4", 
                "PCILAN", 
                "ATAPICD0", 
                "ATAPICD1", 
                "ATAPICD2", 
                "USBFDD", 
                "USBCD", 
                "USBHDD", 
                "OtherHDD", 
                "OtherCD"
            })
            Name (PENC, Package (0x02)
            {
                "ascii", 
                "scancode"
            })
            Name (PKBD, Package (0x03)
            {
                "us", 
                "fr", 
                "gr"
            })
            Name (PTYP, Package (0x08)
            {
                "pap", 
                "pop", 
                "uhdp1", 
                "mhdp1", 
                "uhdp2", 
                "mhdp2", 
                "uhdp3", 
                "mhdp3"
            })
            Mutex (MWMI, 0x07)
            Name (PCFG, Buffer (0x18) {})
            Name (IBUF, Buffer (0x0100) {})
            Name (ILEN, Zero)
            Name (PSTR, Buffer (0x81) {})
            Method (WQA0, 1, NotSerialized)
            {
                Acquire (MWMI, 0xFFFF)
                If (LNotEqual (WMIS (Zero, Arg0), Zero))
                {
                    Release (MWMI)
                    Return ("")
                }
                Store (DerefOf (Index (ITEM, WITM)), Local0)
                Store (DerefOf (Index (Local0, Zero)), Local1)
                Store (DerefOf (Index (Local0, One)), Local2)
                If (LLess (Local1, 0x64))
                {
                    Concatenate (Local2, ",", Local6)
                    Store (DerefOf (Index (VSEL, Local1)), Local3)
                    Concatenate (Local6, DerefOf (Index (Local3, WSEL)), Local7)
                }
                Else
                {
                    Store (SizeOf (VLST), Local3)
                    If (LLessEqual (WLS0, Local3))
                    {
                        Concatenate (Local2, ",", Local7)
                        Concatenate (Local7, DerefOf (Index (VLST, WLS0)), Local2)
                    }
                    If (LLessEqual (WLS1, Local3))
                    {
                        Concatenate (Local2, ":", Local7)
                        Concatenate (Local7, DerefOf (Index (VLST, WLS1)), Local2)
                    }
                    If (LLessEqual (WLS2, Local3))
                    {
                        Concatenate (Local2, ":", Local7)
                        Concatenate (Local7, DerefOf (Index (VLST, WLS2)), Local2)
                    }
                    If (LLessEqual (WLS3, Local3))
                    {
                        Concatenate (Local2, ":", Local7)
                        Concatenate (Local7, DerefOf (Index (VLST, WLS3)), Local2)
                    }
                    If (LLessEqual (WLS4, Local3))
                    {
                        Concatenate (Local2, ":", Local7)
                        Concatenate (Local7, DerefOf (Index (VLST, WLS4)), Local2)
                    }
                    If (LLessEqual (WLS5, Local3))
                    {
                        Concatenate (Local2, ":", Local7)
                        Concatenate (Local7, DerefOf (Index (VLST, WLS5)), Local2)
                    }
                    If (LLessEqual (WLS6, Local3))
                    {
                        Concatenate (Local2, ":", Local7)
                        Concatenate (Local7, DerefOf (Index (VLST, WLS6)), Local2)
                    }
                    If (LLessEqual (WLS7, Local3))
                    {
                        Concatenate (Local2, ":", Local7)
                        Concatenate (Local7, DerefOf (Index (VLST, WLS7)), Local2)
                    }
                    Store (Local2, Local7)
                }
                Release (MWMI)
                Return (Local7)
            }
            Method (WMA1, 3, NotSerialized)
            {
                Acquire (MWMI, 0xFFFF)
                If (LEqual (SizeOf (Arg2), Zero))
                {
                    Store (0x02, Local0)
                }
                Else
                {
                    Store (CARG (Arg2), Local0)
                    If (LEqual (Local0, Zero))
                    {
                        Store (WSET (), Local0)
                    }
                }
                Release (MWMI)
                Return (DerefOf (Index (RETN, Local0)))
            }
            Method (WMA2, 3, NotSerialized)
            {
                Acquire (MWMI, 0xFFFF)
                Store (CARG (Arg2), Local0)
                If (LEqual (Local0, Zero))
                {
                    If (LNotEqual (ILEN, Zero))
                    {
                        Store (CPAS (IBUF, Zero), Local0)
                    }
                    If (LEqual (Local0, Zero))
                    {
                        Store (WMIS (0x02, Zero), Local0)
                    }
                }
                Release (MWMI)
                Return (DerefOf (Index (RETN, Local0)))
            }
            Method (WMA3, 3, NotSerialized)
            {
                Acquire (MWMI, 0xFFFF)
                Store (CARG (Arg2), Local0)
                If (LEqual (Local0, Zero))
                {
                    If (LNotEqual (ILEN, Zero))
                    {
                        Store (CPAS (IBUF, Zero), Local0)
                    }
                    If (LEqual (Local0, Zero))
                    {
                        Store (WMIS (0x03, Zero), Local0)
                    }
                }
                Release (MWMI)
                Return (DerefOf (Index (RETN, Local0)))
            }
            Method (WMA4, 3, NotSerialized)
            {
                Acquire (MWMI, 0xFFFF)
                Store (CARG (Arg2), Local0)
                If (LEqual (Local0, Zero))
                {
                    If (LNotEqual (ILEN, Zero))
                    {
                        Store (CPAS (IBUF, Zero), Local0)
                    }
                    If (LEqual (Local0, Zero))
                    {
                        Store (WMIS (0x04, Zero), Local0)
                    }
                }
                Release (MWMI)
                Return (DerefOf (Index (RETN, Local0)))
            }
            Method (WQA5, 1, NotSerialized)
            {
                Acquire (MWMI, 0xFFFF)
                Store (WMIS (0x05, Zero), Local0)
                Store (WSPM, Index (PCFG, Zero))
                Store (WSPS, Index (PCFG, 0x04))
                Store (WSMN, Index (PCFG, 0x08))
                Store (WSMX, Index (PCFG, 0x0C))
                Store (WSEN, Index (PCFG, 0x10))
                Store (WSKB, Index (PCFG, 0x14))
                Release (MWMI)
                Return (PCFG)
            }
            Method (WMA6, 3, NotSerialized)
            {
                Acquire (MWMI, 0xFFFF)
                If (LEqual (SizeOf (Arg2), Zero))
                {
                    Store (0x02, Local0)
                }
                Else
                {
                    Store (CARG (Arg2), Local0)
                    If (LEqual (Local0, Zero))
                    {
                        If (LNotEqual (ILEN, Zero))
                        {
                            Store (SPAS (IBUF), Local0)
                        }
                        If (LEqual (Local0, Zero))
                        {
                            Store (WMIS (0x06, Zero), Local0)
                        }
                    }
                }
                Release (MWMI)
                Return (DerefOf (Index (RETN, Local0)))
            }
            Method (CARG, 1, NotSerialized)
            {
                Store (SizeOf (Arg0), Local0)
                If (LEqual (Local0, Zero))
                {
                    Store (Zero, IBUF)
                    Store (Zero, ILEN)
                    Return (Zero)
                }
                If (LNotEqual (ObjectType (Arg0), 0x02))
                {
                    Return (0x02)
                }
                If (LGreaterEqual (Local0, 0xFF))
                {
                    Return (0x02)
                }
                Store (Arg0, IBUF)
                Decrement (Local0)
                Store (DerefOf (Index (IBUF, Local0)), Local1)
                If (LOr (LEqual (Local1, 0x3B), LEqual (Local1, 0x2A)))
                {
                    Store (Zero, Index (IBUF, Local0))
                    Store (Local0, ILEN)
                }
                Else
                {
                    Store (SizeOf (Arg0), ILEN)
                }
                Return (Zero)
            }
            Method (SCMP, 3, NotSerialized)
            {
                Store (SizeOf (Arg0), Local0)
                If (LEqual (Local0, Zero))
                {
                    Return (Zero)
                }
                Increment (Local0)
                Name (STR1, Buffer (Local0) {})
                Store (Arg0, STR1)
                Decrement (Local0)
                Store (Zero, Local1)
                Store (Arg2, Local2)
                While (LLess (Local1, Local0))
                {
                    Store (DerefOf (Index (STR1, Local1)), Local3)
                    Store (DerefOf (Index (Arg1, Local2)), Local4)
                    If (LNotEqual (Local3, Local4))
                    {
                        Return (Zero)
                    }
                    Increment (Local1)
                    Increment (Local2)
                }
                Store (DerefOf (Index (Arg1, Local2)), Local4)
                If (LEqual (Local4, Zero))
                {
                    Return (One)
                }
                If (LOr (LEqual (Local4, 0x2C), LEqual (Local4, 0x3A)))
                {
                    Return (One)
                }
                Return (Zero)
            }
            Method (GITM, 1, NotSerialized)
            {
                Store (Zero, Local0)
                Store (SizeOf (ITEM), Local1)
                While (LLess (Local0, Local1))
                {
                    Store (DerefOf (Index (DerefOf (Index (ITEM, Local0)), One)), 
                        Local3)
                    If (SCMP (Local3, Arg0, Zero))
                    {
                        Return (Local0)
                    }
                    Increment (Local0)
                }
                Return (Ones)
            }
            Method (GSEL, 3, NotSerialized)
            {
                Store (Zero, Local0)
                Store (SizeOf (Arg0), Local1)
                While (LLess (Local0, Local1))
                {
                    Store (DerefOf (Index (Arg0, Local0)), Local2)
                    If (SCMP (Local2, Arg1, Arg2))
                    {
                        Return (Local0)
                    }
                    Increment (Local0)
                }
                Return (Ones)
            }
            Method (SLEN, 2, NotSerialized)
            {
                Store (DerefOf (Index (Arg0, Arg1)), Local0)
                Return (SizeOf (Local0))
            }
            Method (CLRP, 0, NotSerialized)
            {
                Store (Zero, WPAS)
                Store (Zero, WPNW)
            }
            Method (GPAS, 2, NotSerialized)
            {
                Store (Arg1, Local0)
                Store (Zero, Local1)
                While (LLessEqual (Local1, 0x80))
                {
                    Store (DerefOf (Index (Arg0, Local0)), Local2)
                    If (LOr (LEqual (Local2, 0x2C), LEqual (Local2, Zero)))
                    {
                        Store (Zero, Index (PSTR, Local1))
                        Return (Local1)
                    }
                    Store (Local2, Index (PSTR, Local1))
                    Increment (Local0)
                    Increment (Local1)
                }
                Store (Zero, Index (PSTR, Local1))
                Return (Ones)
            }
            Method (CPAS, 2, NotSerialized)
            {
                CLRP ()
                Store (Arg1, Local0)
                Store (GPAS (Arg0, Local0), Local1)
                If (LEqual (Local1, Ones))
                {
                    Return (0x02)
                }
                If (LEqual (Local1, Zero))
                {
                    Return (0x02)
                }
                Store (PSTR, WPAS)
                Add (Local0, Local1, Local0)
                Increment (Local0)
                Store (GSEL (PENC, Arg0, Local0), Local6)
                If (LEqual (Local6, Ones))
                {
                    Return (0x02)
                }
                Store (Local6, WENC)
                If (LEqual (Local6, Zero))
                {
                    Add (Local0, SLEN (PENC, Zero), Local0)
                    If (LNotEqual (DerefOf (Index (Arg0, Local0)), 0x2C))
                    {
                        Return (0x02)
                    }
                    Increment (Local0)
                    Store (GSEL (PKBD, Arg0, Local0), Local6)
                    If (LEqual (Local6, Ones))
                    {
                        Return (0x02)
                    }
                    Store (Local6, WKBD)
                }
                Return (Zero)
            }
            Method (SPAS, 1, NotSerialized)
            {
                CLRP ()
                Store (GSEL (PTYP, Arg0, Zero), Local6)
                If (LEqual (Local6, Ones))
                {
                    Return (0x02)
                }
                Store (Local6, WPTY)
                Store (SLEN (PTYP, Local6), Local0)
                If (LNotEqual (DerefOf (Index (Arg0, Local0)), 0x2C))
                {
                    Return (0x02)
                }
                Increment (Local0)
                Store (GPAS (Arg0, Local0), Local1)
                If (LOr (LEqual (Local1, Ones), LEqual (Local1, Zero)))
                {
                    Return (0x02)
                }
                Store (PSTR, WPAS)
                Add (Local0, Local1, Local0)
                If (LNotEqual (DerefOf (Index (Arg0, Local0)), 0x2C))
                {
                    Return (0x02)
                }
                Increment (Local0)
                Store (GPAS (Arg0, Local0), Local1)
                If (LEqual (Local1, Ones))
                {
                    Return (0x02)
                }
                If (LEqual (Local1, Zero))
                {
                    Store (Zero, PSTR)
                }
                Store (PSTR, WPNW)
                Add (Local0, Local1, Local0)
                Increment (Local0)
                Store (GSEL (PENC, Arg0, Local0), Local6)
                If (LEqual (Local6, Ones))
                {
                    Return (0x02)
                }
                Store (Local6, WENC)
                If (LEqual (Local6, Zero))
                {
                    Add (Local0, SLEN (PENC, Zero), Local0)
                    If (LNotEqual (DerefOf (Index (Arg0, Local0)), 0x2C))
                    {
                        Return (0x02)
                    }
                    Increment (Local0)
                    Store (GSEL (PKBD, Arg0, Local0), Local6)
                    If (LEqual (Local6, Ones))
                    {
                        Return (0x02)
                    }
                    Store (Local6, WKBD)
                }
                Return (Zero)
            }
            Method (WSET, 0, NotSerialized)
            {
                Store (ILEN, Local0)
                Increment (Local0)
                Store (GITM (IBUF), Local1)
                If (LEqual (Local1, Ones))
                {
                    Return (0x02)
                }
                Store (Local1, WITM)
                Store (DerefOf (Index (ITEM, Local1)), Local3)
                Store (DerefOf (Index (Local3, One)), Local4)
                Store (SizeOf (Local4), Local2)
                Increment (Local2)
                Store (DerefOf (Index (Local3, Zero)), Local4)
                If (LLess (Local4, 0x64))
                {
                    Store (DerefOf (Index (VSEL, Local4)), Local5)
                    Store (GSEL (Local5, IBUF, Local2), Local6)
                    If (LEqual (Local6, Ones))
                    {
                        Return (0x02)
                    }
                    Store (Local6, WSEL)
                    Add (Local2, SLEN (Local5, Local6), Local2)
                    Store (DerefOf (Index (IBUF, Local2)), Local4)
                }
                Else
                {
                    Store (0x3F, WLS0)
                    Store (0x3F, WLS1)
                    Store (0x3F, WLS2)
                    Store (0x3F, WLS3)
                    Store (0x3F, WLS4)
                    Store (0x3F, WLS5)
                    Store (0x3F, WLS6)
                    Store (0x3F, WLS7)
                    Store (GSEL (VLST, IBUF, Local2), Local6)
                    If (LEqual (Local6, Ones))
                    {
                        Return (0x02)
                    }
                    Store (Local6, WLS0)
                    Add (Local2, SLEN (VLST, Local6), Local2)
                    Store (DerefOf (Index (IBUF, Local2)), Local4)
                    If (LAnd (LLess (Local2, Local0), LEqual (Local4, 0x3A)))
                    {
                        Increment (Local2)
                        Store (GSEL (VLST, IBUF, Local2), Local6)
                        If (LEqual (Local6, Ones))
                        {
                            Return (0x02)
                        }
                        Store (Local6, WLS1)
                        Add (Local2, SLEN (VLST, Local6), Local2)
                        Store (DerefOf (Index (IBUF, Local2)), Local4)
                    }
                    If (LAnd (LLess (Local2, Local0), LEqual (Local4, 0x3A)))
                    {
                        Increment (Local2)
                        Store (GSEL (VLST, IBUF, Local2), Local6)
                        If (LEqual (Local6, Ones))
                        {
                            Return (0x02)
                        }
                        Store (Local6, WLS2)
                        Add (Local2, SLEN (VLST, Local6), Local2)
                        Store (DerefOf (Index (IBUF, Local2)), Local4)
                    }
                    If (LAnd (LLess (Local2, Local0), LEqual (Local4, 0x3A)))
                    {
                        Increment (Local2)
                        Store (GSEL (VLST, IBUF, Local2), Local6)
                        If (LEqual (Local6, Ones))
                        {
                            Return (0x02)
                        }
                        Store (Local6, WLS3)
                        Add (Local2, SLEN (VLST, Local6), Local2)
                        Store (DerefOf (Index (IBUF, Local2)), Local4)
                    }
                    If (LAnd (LLess (Local2, Local0), LEqual (Local4, 0x3A)))
                    {
                        Increment (Local2)
                        Store (GSEL (VLST, IBUF, Local2), Local6)
                        If (LEqual (Local6, Ones))
                        {
                            Return (0x02)
                        }
                        Store (Local6, WLS4)
                        Add (Local2, SLEN (VLST, Local6), Local2)
                        Store (DerefOf (Index (IBUF, Local2)), Local4)
                    }
                    If (LAnd (LLess (Local2, Local0), LEqual (Local4, 0x3A)))
                    {
                        Increment (Local2)
                        Store (GSEL (VLST, IBUF, Local2), Local6)
                        If (LEqual (Local6, Ones))
                        {
                            Return (0x02)
                        }
                        Store (Local6, WLS5)
                        Add (Local2, SLEN (VLST, Local6), Local2)
                        Store (DerefOf (Index (IBUF, Local2)), Local4)
                    }
                    If (LAnd (LLess (Local2, Local0), LEqual (Local4, 0x3A)))
                    {
                        Increment (Local2)
                        Store (GSEL (VLST, IBUF, Local2), Local6)
                        If (LEqual (Local6, Ones))
                        {
                            Return (0x02)
                        }
                        Store (Local6, WLS6)
                        Add (Local2, SLEN (VLST, Local6), Local2)
                        Store (DerefOf (Index (IBUF, Local2)), Local4)
                    }
                    If (LAnd (LLess (Local2, Local0), LEqual (Local4, 0x3A)))
                    {
                        Increment (Local2)
                        Store (GSEL (VLST, IBUF, Local2), Local6)
                        If (LEqual (Local6, Ones))
                        {
                            Return (0x02)
                        }
                        Store (Local6, WLS7)
                        Add (Local2, SLEN (VLST, Local6), Local2)
                        Store (DerefOf (Index (IBUF, Local2)), Local4)
                    }
                }
                If (LAnd (LEqual (Local4, 0x2C), LLess (Local2, Local0)))
                {
                    Increment (Local2)
                    Store (CPAS (IBUF, Local2), Local0)
                    If (LNotEqual (Local0, Zero))
                    {
                        Return (Local0)
                    }
                }
                Return (WMIS (One, Zero))
            }
            Name (WQBA, Buffer (0x07C1)
            {
                /* 0000 */    0x46, 0x4F, 0x4D, 0x42, 0x01, 0x00, 0x00, 0x00, 
                /* 0008 */    0xB1, 0x07, 0x00, 0x00, 0x5A, 0x30, 0x00, 0x00, 
                /* 0010 */    0x44, 0x53, 0x00, 0x01, 0x1A, 0x7D, 0xDA, 0x54, 
                /* 0018 */    0x98, 0x51, 0x97, 0x00, 0x01, 0x06, 0x18, 0x42, 
                /* 0020 */    0x10, 0x11, 0x10, 0x0A, 0x0D, 0x21, 0x02, 0x0B, 
                /* 0028 */    0x83, 0x50, 0x4C, 0x18, 0x14, 0xA0, 0x45, 0x41, 
                /* 0030 */    0xC8, 0x05, 0x14, 0x95, 0x02, 0x21, 0xC3, 0x02, 
                /* 0038 */    0x14, 0x0B, 0x70, 0x2E, 0x40, 0xBA, 0x00, 0xE5, 
                /* 0040 */    0x28, 0x72, 0x0C, 0x22, 0x02, 0xF7, 0xEF, 0x0F, 
                /* 0048 */    0x31, 0x0E, 0x88, 0x14, 0x40, 0x48, 0xE6, 0x28, 
                /* 0050 */    0x28, 0x81, 0x85, 0xC0, 0x11, 0x82, 0x7E, 0x05, 
                /* 0058 */    0x20, 0x74, 0x88, 0x26, 0x83, 0x02, 0x9C, 0x22, 
                /* 0060 */    0x08, 0xD2, 0x96, 0x05, 0xE8, 0x16, 0xE0, 0x5B, 
                /* 0068 */    0x80, 0x76, 0x08, 0xA1, 0x55, 0x28, 0xC0, 0xA4, 
                /* 0070 */    0x00, 0x9F, 0x60, 0xB2, 0x28, 0x40, 0x36, 0x98, 
                /* 0078 */    0x6C, 0xC3, 0x91, 0x61, 0x30, 0x91, 0x63, 0x40, 
                /* 0080 */    0x89, 0x19, 0x03, 0x4A, 0xE7, 0x14, 0x64, 0x13, 
                /* 0088 */    0x58, 0xD0, 0x85, 0xA2, 0x68, 0x1A, 0x51, 0x12, 
                /* 0090 */    0x1C, 0xD4, 0x31, 0x44, 0x08, 0x5E, 0xAE, 0x00, 
                /* 0098 */    0xC9, 0x13, 0x90, 0xE6, 0x79, 0xC9, 0xFA, 0x20, 
                /* 00A0 */    0x34, 0x04, 0x36, 0x02, 0x1E, 0x45, 0x02, 0x08, 
                /* 00A8 */    0x8B, 0xB1, 0x4C, 0x89, 0x87, 0x41, 0x79, 0x00, 
                /* 00B0 */    0x91, 0x9C, 0xA1, 0xA2, 0x80, 0xED, 0x75, 0x22, 
                /* 00B8 */    0x1A, 0xD6, 0x71, 0x32, 0x49, 0x70, 0xA8, 0x51, 
                /* 00C0 */    0x5A, 0xA2, 0x00, 0xF3, 0x23, 0xD3, 0x44, 0x8E, 
                /* 00C8 */    0xAD, 0xE9, 0x11, 0x0B, 0x92, 0x49, 0x1B, 0x0A, 
                /* 00D0 */    0x6A, 0xE8, 0x9E, 0xD6, 0x49, 0x79, 0xA2, 0x11, 
                /* 00D8 */    0x0F, 0xCA, 0x30, 0x09, 0x3C, 0x0A, 0x86, 0xC6, 
                /* 00E0 */    0x09, 0xCA, 0x82, 0x90, 0x83, 0x81, 0xA2, 0x00, 
                /* 00E8 */    0x4F, 0xC2, 0x73, 0x2C, 0x5E, 0x80, 0xF0, 0x19, 
                /* 00F0 */    0x93, 0xA3, 0x40, 0x8C, 0x04, 0x3E, 0x12, 0x78, 
                /* 00F8 */    0x34, 0xC7, 0x8C, 0x05, 0x0A, 0x17, 0xF0, 0x7C, 
                /* 0100 */    0x8E, 0x21, 0x72, 0xDC, 0x43, 0x8D, 0x71, 0x14, 
                /* 0108 */    0x91, 0x13, 0xBC, 0x03, 0x44, 0x31, 0x5A, 0x41, 
                /* 0110 */    0xF3, 0x16, 0x62, 0xB0, 0x68, 0x06, 0xEB, 0x19, 
                /* 0118 */    0x9C, 0x0C, 0x3A, 0xC1, 0xFF, 0xFF, 0x08, 0xB8, 
                /* 0120 */    0x0C, 0x08, 0x79, 0x14, 0x60, 0x75, 0x50, 0x9A, 
                /* 0128 */    0x86, 0x09, 0xBA, 0x17, 0x60, 0x4D, 0x80, 0x31, 
                /* 0130 */    0x01, 0x1A, 0x31, 0xA4, 0x4C, 0x80, 0xB3, 0xFB, 
                /* 0138 */    0x82, 0x66, 0xD4, 0x96, 0x00, 0x73, 0x02, 0xB4, 
                /* 0140 */    0x09, 0xF0, 0x86, 0x20, 0x94, 0xF3, 0x8C, 0x72, 
                /* 0148 */    0x2C, 0xA7, 0x18, 0xE5, 0x61, 0x20, 0xE6, 0xCB, 
                /* 0150 */    0x40, 0xD0, 0x28, 0x31, 0x62, 0x9E, 0x4B, 0x5C, 
                /* 0158 */    0xC3, 0x46, 0x88, 0x11, 0xF2, 0x14, 0x02, 0xC5, 
                /* 0160 */    0x6D, 0x7F, 0x10, 0x64, 0xD0, 0xB8, 0xD1, 0xFB, 
                /* 0168 */    0xB4, 0x70, 0x56, 0x27, 0x70, 0xF4, 0x4F, 0x0A, 
                /* 0170 */    0x26, 0xF0, 0x94, 0x0F, 0xEC, 0xD9, 0xE0, 0x04, 
                /* 0178 */    0x8E, 0x35, 0x6A, 0x8C, 0x53, 0x49, 0xE0, 0xD8, 
                /* 0180 */    0x0F, 0x08, 0x69, 0x00, 0x51, 0x24, 0x78, 0xD4, 
                /* 0188 */    0x69, 0xC1, 0xE7, 0x02, 0x0F, 0xED, 0xA0, 0x3D, 
                /* 0190 */    0xC7, 0x13, 0x08, 0x72, 0x08, 0x47, 0xF0, 0xC4, 
                /* 0198 */    0xF0, 0x40, 0xE0, 0x31, 0xB0, 0x9B, 0x82, 0x8F, 
                /* 01A0 */    0x00, 0x3E, 0x21, 0xE0, 0x5D, 0x03, 0xEA, 0x6A, 
                /* 01A8 */    0xF0, 0x60, 0xC0, 0x06, 0x1D, 0x0E, 0x33, 0x5E, 
                /* 01B0 */    0x0F, 0x3F, 0xDC, 0x09, 0x9C, 0xE4, 0x03, 0x06, 
                /* 01B8 */    0x3F, 0x6C, 0x78, 0x70, 0xB8, 0x79, 0x9E, 0xCC, 
                /* 01C0 */    0x91, 0x95, 0x2A, 0xC0, 0xEC, 0xE1, 0x40, 0x07, 
                /* 01C8 */    0x09, 0x9F, 0x36, 0xD8, 0x19, 0x00, 0x23, 0x7F, 
                /* 01D0 */    0x10, 0xA8, 0x91, 0x19, 0xDA, 0xE3, 0x7E, 0xE9, 
                /* 01D8 */    0x30, 0xE4, 0x73, 0xC2, 0x61, 0x31, 0xB1, 0xA7, 
                /* 01E0 */    0x0E, 0x3A, 0x1E, 0xF0, 0x5F, 0x46, 0x9E, 0x33, 
                /* 01E8 */    0x3C, 0x7D, 0xCF, 0xD7, 0x04, 0xC3, 0x0E, 0x1C, 
                /* 01F0 */    0x3D, 0x10, 0x43, 0x3F, 0x6C, 0x1C, 0xC6, 0x69, 
                /* 01F8 */    0xF8, 0xFE, 0xE1, 0xF3, 0x02, 0x8C, 0x53, 0x80, 
                /* 0200 */    0x47, 0xEE, 0xFF, 0xFF, 0x21, 0xC5, 0xA7, 0x09, 
                /* 0208 */    0x7E, 0xB4, 0xF0, 0x69, 0x82, 0x5D, 0x0F, 0x4E, 
                /* 0210 */    0xE3, 0x39, 0xC0, 0xC3, 0x39, 0x2B, 0x1F, 0x26, 
                /* 0218 */    0xC0, 0x76, 0x3F, 0x61, 0x23, 0x7A, 0xB7, 0xF0, 
                /* 0220 */    0x68, 0xB0, 0xA7, 0x00, 0xF0, 0x9D, 0x5F, 0xC0, 
                /* 0228 */    0x79, 0xD7, 0x60, 0x83, 0x85, 0x71, 0x7E, 0x01, 
                /* 0230 */    0x1E, 0x27, 0x04, 0x0F, 0x81, 0x1F, 0x24, 0x3C, 
                /* 0238 */    0x04, 0x3E, 0x80, 0xE7, 0x8F, 0x33, 0xB4, 0xD2, 
                /* 0240 */    0x79, 0x21, 0x07, 0x06, 0xEF, 0x9C, 0x03, 0x63, 
                /* 0248 */    0x14, 0x3C, 0xCF, 0x63, 0xC3, 0x04, 0x0A, 0xF2, 
                /* 0250 */    0x1A, 0x50, 0xA8, 0x67, 0x01, 0x85, 0xF1, 0xA9, 
                /* 0258 */    0x06, 0x78, 0xFD, 0xFF, 0x4F, 0x35, 0xC0, 0xE5, 
                /* 0260 */    0x70, 0x80, 0x3B, 0x39, 0xC0, 0xBD, 0x17, 0xB0, 
                /* 0268 */    0x8B, 0xC3, 0x73, 0x0D, 0x5C, 0xD1, 0xE7, 0x1A, 
                /* 0270 */    0xA8, 0xF7, 0x96, 0xE2, 0xC6, 0xA8, 0x6B, 0x4C, 
                /* 0278 */    0x90, 0x47, 0x81, 0x47, 0x9A, 0x28, 0xCF, 0x33, 
                /* 0280 */    0xEF, 0x32, 0x11, 0x9E, 0x6D, 0x7C, 0xAD, 0xF1, 
                /* 0288 */    0x14, 0xE2, 0xF8, 0x5A, 0x63, 0xC4, 0x97, 0x89, 
                /* 0290 */    0x77, 0x1B, 0xE3, 0x1E, 0xDC, 0x63, 0xCD, 0x43, 
                /* 0298 */    0x8E, 0x41, 0x8E, 0x26, 0xC2, 0x8B, 0x41, 0xC0, 
                /* 02A0 */    0xC7, 0x1B, 0x1F, 0x6B, 0xC0, 0x2B, 0xE6, 0x85, 
                /* 02A8 */    0x22, 0x0B, 0xC7, 0x1A, 0x40, 0xE3, 0xFF, 0xFF, 
                /* 02B0 */    0x58, 0x03, 0xDC, 0xB0, 0x1E, 0x50, 0xC0, 0x77, 
                /* 02B8 */    0x64, 0x60, 0x37, 0x14, 0x78, 0x27, 0x14, 0xC0, 
                /* 02C0 */    0x4F, 0xE2, 0x17, 0x80, 0x8E, 0x1C, 0x4E, 0x0B, 
                /* 02C8 */    0x22, 0x1B, 0x6F, 0x00, 0x9F, 0x02, 0xA8, 0x1A, 
                /* 02D0 */    0x20, 0x4D, 0x13, 0x36, 0xC1, 0xF4, 0xE4, 0x82, 
                /* 02D8 */    0xF7, 0x91, 0xC0, 0xB9, 0x49, 0x94, 0x7C, 0x58, 
                /* 02E0 */    0x14, 0xCE, 0x59, 0x0F, 0x22, 0x14, 0xC4, 0x80, 
                /* 02E8 */    0x0E, 0x72, 0x9C, 0x40, 0x9F, 0x51, 0x7C, 0x10, 
                /* 02F0 */    0x39, 0xD1, 0x27, 0x42, 0x0F, 0xCA, 0xC3, 0x78, 
                /* 02F8 */    0x47, 0x61, 0x27, 0x10, 0x1F, 0x26, 0x3C, 0x76, 
                /* 0300 */    0x1F, 0x13, 0xF8, 0x3F, 0xC6, 0xB3, 0x31, 0xBA, 
                /* 0308 */    0xD5, 0x60, 0xE8, 0xFF, 0x7F, 0x4E, 0xE1, 0x60, 
                /* 0310 */    0x3E, 0x88, 0x70, 0x82, 0x8F, 0x46, 0xDD, 0x24, 
                /* 0318 */    0x40, 0xA5, 0xEF, 0xA8, 0x00, 0x0A, 0x20, 0xDF, 
                /* 0320 */    0x0B, 0x7C, 0x0E, 0x78, 0x36, 0x60, 0x63, 0x78, 
                /* 0328 */    0x14, 0x30, 0x9A, 0xD1, 0x79, 0xF8, 0xC9, 0xA2, 
                /* 0330 */    0xE2, 0x4E, 0x96, 0x82, 0x78, 0xB2, 0x8E, 0x32, 
                /* 0338 */    0x59, 0xF4, 0x4C, 0x7C, 0xAF, 0xF0, 0x8C, 0xDE, 
                /* 0340 */    0xB4, 0x3C, 0x47, 0x4F, 0xD8, 0xF7, 0x10, 0x58, 
                /* 0348 */    0x87, 0x81, 0x90, 0x0F, 0x06, 0x9E, 0x86, 0xE1, 
                /* 0350 */    0x3C, 0x59, 0x0E, 0xE7, 0xC9, 0xF2, 0xB1, 0xF8, 
                /* 0358 */    0x1A, 0x02, 0x3E, 0x81, 0xB3, 0x05, 0x39, 0x3C, 
                /* 0360 */    0x26, 0xD6, 0xA8, 0xE8, 0x55, 0xC8, 0xC3, 0xE3, 
                /* 0368 */    0x97, 0x03, 0xCF, 0xE7, 0x19, 0xE1, 0x28, 0x9F, 
                /* 0370 */    0x24, 0x70, 0x18, 0xCF, 0x24, 0x1E, 0xA2, 0x6F, 
                /* 0378 */    0x45, 0xB0, 0x26, 0x72, 0xD2, 0xBE, 0x2D, 0x9C, 
                /* 0380 */    0x6C, 0xD0, 0xD7, 0x33, 0xCC, 0xAD, 0x08, 0xF6, 
                /* 0388 */    0xFF, 0xFF, 0x56, 0x04, 0xE7, 0x82, 0x06, 0x33, 
                /* 0390 */    0xD3, 0xBD, 0x0A, 0x15, 0xEB, 0x5E, 0x05, 0x88, 
                /* 0398 */    0x1D, 0xD6, 0x6B, 0x8F, 0x0F, 0x56, 0x70, 0xEF, 
                /* 03A0 */    0x55, 0x70, 0x2F, 0x55, 0xCF, 0x0A, 0xC7, 0x18, 
                /* 03A8 */    0xFE, 0x61, 0x2A, 0xC6, 0x29, 0xBD, 0x76, 0x1A, 
                /* 03B0 */    0x28, 0x4C, 0x94, 0x78, 0xEF, 0x55, 0x1E, 0xE3, 
                /* 03B8 */    0x7B, 0x15, 0xBB, 0x42, 0x85, 0x89, 0xF5, 0x72, 
                /* 03C0 */    0x65, 0xD4, 0xD7, 0x89, 0x70, 0x81, 0x82, 0x44, 
                /* 03C8 */    0x7A, 0xB5, 0x8A, 0x12, 0x39, 0xBE, 0x21, 0xDF, 
                /* 03D0 */    0xAB, 0xC0, 0x2B, 0xE7, 0x5E, 0x05, 0xB2, 0xFF, 
                /* 03D8 */    0xFF, 0xBD, 0x0A, 0x30, 0x8F, 0xF6, 0x5E, 0x05, 
                /* 03E0 */    0xC6, 0x6B, 0x03, 0xBB, 0x21, 0xC1, 0x02, 0x7A, 
                /* 03E8 */    0xB1, 0x02, 0x0C, 0x65, 0xBE, 0x58, 0xD1, 0xBC, 
                /* 03F0 */    0x17, 0x2B, 0xC4, 0xFF, 0xFF, 0x5C, 0xC2, 0xF4, 
                /* 03F8 */    0x5C, 0xAC, 0xC8, 0x3C, 0xE1, 0xDF, 0xAC, 0x00, 
                /* 0400 */    0x4E, 0xFF, 0xFF, 0x6F, 0x56, 0x80, 0xB1, 0x7B, 
                /* 0408 */    0x11, 0xE6, 0x68, 0x05, 0x2F, 0xE5, 0xCD, 0x8A, 
                /* 0410 */    0xC6, 0x59, 0x86, 0x02, 0x2E, 0x88, 0xC2, 0xF8, 
                /* 0418 */    0x66, 0x05, 0x38, 0xBA, 0xAE, 0xE0, 0x86, 0x0C, 
                /* 0420 */    0x17, 0x2C, 0x4A, 0x30, 0x1F, 0x42, 0x3C, 0x9D, 
                /* 0428 */    0x23, 0x7E, 0x48, 0x78, 0x09, 0x78, 0xCC, 0xF1, 
                /* 0430 */    0x80, 0x1F, 0x08, 0x7C, 0xB9, 0x02, 0xD3, 0xFF, 
                /* 0438 */    0x9F, 0xC0, 0x27, 0xDF, 0xB3, 0x7C, 0x9B, 0x7A, 
                /* 0440 */    0xEF, 0xE5, 0x07, 0xAC, 0xF7, 0x2A, 0x1F, 0x7E, 
                /* 0448 */    0x63, 0xBD, 0x33, 0xBC, 0x5C, 0x79, 0x24, 0x51, 
                /* 0450 */    0x4E, 0x22, 0x94, 0xEF, 0x56, 0xEF, 0x55, 0x46, 
                /* 0458 */    0x89, 0xF8, 0x42, 0xEC, 0x53, 0xB0, 0xA1, 0x8D, 
                /* 0460 */    0xF2, 0x54, 0x11, 0xDD, 0x78, 0x2F, 0x57, 0xE0, 
                /* 0468 */    0x95, 0x74, 0xB9, 0x02, 0x68, 0x32, 0xFC, 0x97, 
                /* 0470 */    0x2B, 0xF0, 0xDD, 0x1C, 0xB0, 0xD7, 0x24, 0x38, 
                /* 0478 */    0xFF, 0xFF, 0x6B, 0x12, 0xBF, 0x5E, 0x01, 0x7E, 
                /* 0480 */    0xB2, 0x5F, 0xAF, 0x68, 0xEE, 0xEB, 0x15, 0x4A, 
                /* 0488 */    0x14, 0x84, 0x14, 0x01, 0x69, 0xA6, 0xE0, 0xB9, 
                /* 0490 */    0x5F, 0x01, 0x9C, 0xF8, 0xFF, 0xDF, 0xAF, 0x00, 
                /* 0498 */    0xCB, 0xE1, 0xEE, 0x57, 0x40, 0xEF, 0x76, 0x04, 
                /* 04A0 */    0x5E, 0x94, 0xB7, 0x23, 0xEC, 0x15, 0x0B, 0x9F, 
                /* 04A8 */    0xF1, 0x8A, 0x45, 0xC3, 0xAC, 0x44, 0xF1, 0xD6, 
                /* 04B0 */    0x44, 0x61, 0x7C, 0xC5, 0x02, 0x26, 0xFF, 0xFF, 
                /* 04B8 */    0x2B, 0x16, 0x30, 0x3B, 0x88, 0xE2, 0x46, 0x0D, 
                /* 04C0 */    0xF7, 0xE2, 0xE4, 0x5B, 0x8F, 0xE7, 0x1B, 0xD1, 
                /* 04C8 */    0x77, 0x18, 0xCC, 0x09, 0x0B, 0xC6, 0x0D, 0x0B, 
                /* 04D0 */    0xFE, 0x90, 0x1E, 0x86, 0x7D, 0x92, 0x78, 0xC7, 
                /* 04D8 */    0xF2, 0xD1, 0xCA, 0x20, 0x6F, 0xC0, 0x4F, 0x56, 
                /* 04E0 */    0x0F, 0x56, 0x51, 0x8C, 0x10, 0xF0, 0x78, 0xDE, 
                /* 04E8 */    0x85, 0x7D, 0xB4, 0x7A, 0xD3, 0x32, 0x4A, 0xEC, 
                /* 04F0 */    0x58, 0xBE, 0x50, 0x3D, 0x6B, 0xF9, 0x9A, 0x65, 
                /* 04F8 */    0x88, 0xB8, 0x0F, 0xC4, 0xBE, 0x61, 0x01, 0xB6, 
                /* 0500 */    0xFF, 0xFF, 0x37, 0x2C, 0xC0, 0xD1, 0xC5, 0x81, 
                /* 0508 */    0x1F, 0x1C, 0xB0, 0x37, 0x2C, 0xC0, 0xE7, 0x4C, 
                /* 0510 */    0xC1, 0x73, 0xC3, 0x02, 0x36, 0xFF, 0xFF, 0x1B, 
                /* 0518 */    0x16, 0xC0, 0xFF, 0xFF, 0xFF, 0x0D, 0x0B, 0x38, 
                /* 0520 */    0xDC, 0xAE, 0xB0, 0xB7, 0x2C, 0xEC, 0xED, 0x85, 
                /* 0528 */    0xAC, 0x82, 0x86, 0x5A, 0x89, 0x82, 0x7F, 0xAF, 
                /* 0530 */    0x0C, 0x43, 0x6F, 0x58, 0x80, 0xA3, 0x71, 0x7B, 
                /* 0538 */    0xD4, 0xE0, 0x38, 0x1B, 0x3C, 0x49, 0x60, 0xCE, 
                /* 0540 */    0xD5, 0xB8, 0xD9, 0x1C, 0x5C, 0xE0, 0x08, 0xBD, 
                /* 0548 */    0x83, 0x6A, 0xEE, 0xEC, 0x92, 0x02, 0xE3, 0x96, 
                /* 0550 */    0x05, 0xF7, 0x52, 0xF5, 0xD0, 0x10, 0xE5, 0x20, 
                /* 0558 */    0x5E, 0x85, 0x1F, 0xAC, 0x1E, 0xA5, 0x8E, 0xEC, 
                /* 0560 */    0xF1, 0xEA, 0x69, 0xD8, 0xC7, 0x2C, 0xDF, 0xB2, 
                /* 0568 */    0x0C, 0x15, 0xE1, 0x2D, 0x8B, 0x9D, 0x21, 0xE2, 
                /* 0570 */    0xC5, 0x8A, 0x12, 0xE2, 0xBD, 0x22, 0xB4, 0xEF, 
                /* 0578 */    0x5C, 0x06, 0x7F, 0x34, 0x36, 0x6A, 0xD0, 0x97, 
                /* 0580 */    0xE3, 0xB7, 0x2C, 0x78, 0xFF, 0xFF, 0x5B, 0x16, 
                /* 0588 */    0x7C, 0x91, 0x7F, 0x15, 0x9D, 0x08, 0x7C, 0xCB, 
                /* 0590 */    0x02, 0xF8, 0x11, 0x0C, 0x42, 0x4E, 0x06, 0x8E, 
                /* 0598 */    0x3E, 0x2F, 0xE0, 0x07, 0xF0, 0x30, 0xE2, 0x21, 
                /* 05A0 */    0xB1, 0x00, 0x03, 0xA7, 0xF7, 0x25, 0x9F, 0x29, 
                /* 05A8 */    0xF8, 0x01, 0xC3, 0x67, 0x0A, 0x76, 0x3D, 0x88, 
                /* 05B0 */    0xFE, 0x18, 0xE0, 0x73, 0x09, 0x66, 0x70, 0xE0, 
                /* 05B8 */    0xBF, 0x56, 0x1C, 0xBA, 0x47, 0xF1, 0xFA, 0x60, 
                /* 05C0 */    0x02, 0x0F, 0x8E, 0xFF, 0xFF, 0x07, 0x07, 0xF7, 
                /* 05C8 */    0xCE, 0x70, 0x44, 0xBE, 0xC3, 0x78, 0x70, 0x60, 
                /* 05D0 */    0x3B, 0x08, 0x00, 0x87, 0xC1, 0xE1, 0x43, 0x0D, 
                /* 05D8 */    0x0E, 0x3D, 0x1E, 0x03, 0x87, 0xF4, 0x79, 0x8C, 
                /* 05E0 */    0x5D, 0x18, 0x1E, 0x72, 0x3C, 0x34, 0xB0, 0x01, 
                /* 05E8 */    0x7A, 0x68, 0xC0, 0x72, 0x12, 0x4F, 0x21, 0x87, 
                /* 05F0 */    0x06, 0x66, 0x09, 0x43, 0x03, 0x4A, 0xF1, 0x86, 
                /* 05F8 */    0x46, 0xFF, 0xFF, 0x43, 0xE3, 0x43, 0xF2, 0x61, 
                /* 0600 */    0x21, 0xE6, 0x53, 0x4E, 0x84, 0xF7, 0x05, 0x9F, 
                /* 0608 */    0xA0, 0x18, 0xFA, 0x6B, 0x8A, 0x6F, 0x17, 0xBE, 
                /* 0610 */    0x09, 0xE2, 0xC6, 0x07, 0xAE, 0x4B, 0xA7, 0xC7, 
                /* 0618 */    0x07, 0x7C, 0x8E, 0x5C, 0x1E, 0x1F, 0xEE, 0xE8, 
                /* 0620 */    0xE4, 0xF1, 0xC1, 0x70, 0x79, 0x95, 0x21, 0x47, 
                /* 0628 */    0x13, 0x1F, 0xAD, 0xD8, 0xF0, 0xC0, 0x76, 0xD3, 
                /* 0630 */    0xF3, 0xF0, 0x80, 0xCF, 0x75, 0x13, 0x8C, 0x57, 
                /* 0638 */    0x48, 0x7E, 0x2D, 0x81, 0x71, 0x82, 0xC2, 0x5F, 
                /* 0640 */    0x37, 0xC1, 0xFB, 0xFF, 0xBF, 0x6E, 0x02, 0xCF, 
                /* 0648 */    0x51, 0x70, 0xAD, 0x97, 0x6C, 0x1A, 0xE4, 0x95, 
                /* 0650 */    0xA3, 0x58, 0x2F, 0x02, 0x0A, 0xE3, 0x33, 0x1B, 
                /* 0658 */    0xE0, 0x68, 0xAC, 0xCF, 0x6C, 0x60, 0xB9, 0x17, 
                /* 0660 */    0xB0, 0x1B, 0x1B, 0xDC, 0xD3, 0x1A, 0xEC, 0xBB, 
                /* 0668 */    0xC3, 0xC3, 0xD9, 0x63, 0xDA, 0xA3, 0xDA, 0x03, 
                /* 0670 */    0x9A, 0x8F, 0xD8, 0x31, 0xDE, 0xD2, 0x82, 0xC4, 
                /* 0678 */    0x89, 0xF0, 0x3A, 0xF0, 0xB4, 0xE6, 0x4B, 0x46, 
                /* 0680 */    0xBC, 0x40, 0x4F, 0x6B, 0xC6, 0x88, 0xF3, 0xD2, 
                /* 0688 */    0x66, 0xC4, 0x57, 0x8A, 0x10, 0x0F, 0x6B, 0x3E, 
                /* 0690 */    0xB9, 0x19, 0xEF, 0x61, 0x22, 0x5C, 0x98, 0x17, 
                /* 0698 */    0xB6, 0xA7, 0x35, 0x70, 0xFC, 0xFF, 0x4F, 0x6B, 
                /* 06A0 */    0x70, 0xE4, 0x5C, 0xB1, 0x01, 0x9A, 0x5C, 0xF4, 
                /* 06A8 */    0x71, 0x87, 0x14, 0xB0, 0x5C, 0x1B, 0xD8, 0x2D, 
                /* 06B0 */    0x05, 0xDE, 0x05, 0x1B, 0x38, 0xFF, 0xFF, 0x8F, 
                /* 06B8 */    0x28, 0xE0, 0xCB, 0x72, 0xC1, 0xA6, 0x39, 0x2E, 
                /* 06C0 */    0xD8, 0x28, 0x0E, 0xAB, 0x01, 0xD2, 0x3C, 0xE1, 
                /* 06C8 */    0x5F, 0xAF, 0xC1, 0x3F, 0x09, 0x5F, 0xAF, 0x01, 
                /* 06D0 */    0xDB, 0xB7, 0x58, 0xDC, 0xF5, 0x1A, 0x58, 0xFD, 
                /* 06D8 */    0xFF, 0xAF, 0xD7, 0xC0, 0x52, 0xF0, 0x48, 0xE9, 
                /* 06E0 */    0x9D, 0x1A, 0x5C, 0x37, 0x6D, 0x3C, 0xE8, 0x9B, 
                /* 06E8 */    0x36, 0x4C, 0x85, 0x36, 0x7D, 0x6A, 0x34, 0x6A, 
                /* 06F0 */    0xD5, 0xA0, 0x4C, 0x8D, 0x32, 0x0D, 0x6A, 0xF5, 
                /* 06F8 */    0xA9, 0xD4, 0x98, 0xB1, 0xA1, 0x5A, 0xDA, 0x5D, 
                /* 0700 */    0x82, 0x8A, 0x59, 0x8C, 0x46, 0xE3, 0x28, 0x20, 
                /* 0708 */    0x54, 0xF6, 0x1F, 0x50, 0x20, 0x0E, 0xF9, 0xD1, 
                /* 0710 */    0x11, 0xA0, 0x83, 0x7D, 0xA7, 0x74, 0x0B, 0x27, 
                /* 0718 */    0x6B, 0x13, 0x88, 0xE3, 0x9B, 0x80, 0x68, 0x04, 
                /* 0720 */    0x44, 0x5A, 0x54, 0x00, 0xB1, 0xDC, 0x20, 0x02, 
                /* 0728 */    0xB2, 0x8A, 0x35, 0x09, 0xC8, 0x9A, 0xBF, 0x2F, 
                /* 0730 */    0x02, 0xB7, 0x4E, 0x1D, 0x40, 0x2C, 0x25, 0x08, 
                /* 0738 */    0x4D, 0xB4, 0x70, 0x81, 0x3A, 0x1E, 0x88, 0x06, 
                /* 0740 */    0x43, 0x68, 0x04, 0xE4, 0x60, 0x14, 0x02, 0xB2, 
                /* 0748 */    0x8C, 0xCF, 0x9D, 0xC0, 0x2D, 0xC0, 0x0A, 0x10, 
                /* 0750 */    0x93, 0x0F, 0x42, 0x05, 0x7B, 0x01, 0x65, 0xEA, 
                /* 0758 */    0x41, 0x04, 0x64, 0xA5, 0x6B, 0x15, 0x90, 0x75, 
                /* 0760 */    0x83, 0x08, 0xC8, 0x59, 0xCD, 0x80, 0xB3, 0x8C, 
                /* 0768 */    0x6E, 0x80, 0x98, 0xC2, 0x87, 0x82, 0x40, 0xAC, 
                /* 0770 */    0x49, 0x0F, 0x28, 0x13, 0x08, 0xA2, 0x0B, 0x07, 
                /* 0778 */    0xF1, 0x03, 0xC4, 0xA4, 0x81, 0x08, 0xC8, 0x71, 
                /* 0780 */    0x7E, 0x25, 0x02, 0x77, 0x1C, 0x45, 0x80, 0xD4, 
                /* 0788 */    0xD1, 0x70, 0x29, 0x08, 0x15, 0xFF, 0x09, 0x13, 
                /* 0790 */    0xC8, 0xFF, 0xFF, 0xFD, 0x44, 0x96, 0xC0, 0x28, 
                /* 0798 */    0x08, 0x8D, 0xA0, 0x09, 0x84, 0xC9, 0xF3, 0x04, 
                /* 07A0 */    0xC2, 0x42, 0xFD, 0xFD, 0x34, 0x04, 0x07, 0x51, 
                /* 07A8 */    0x35, 0x44, 0xEA, 0x0A, 0x84, 0x05, 0x7E, 0x18, 
                /* 07B0 */    0x68, 0x30, 0x4E, 0x0F, 0x22, 0x20, 0x27, 0x7D, 
                /* 07B8 */    0x52, 0x05, 0x22, 0xB9, 0x41, 0x04, 0xE4, 0xFF, 
                /* 07C0 */    0x3F
            })
        }
        Device (WMI2)
        {
            Name (_HID, EisaId ("PNP0C14"))
            Name (_UID, 0x02)
            Name (_WDG, Buffer (0x3C)
            {
                /* 0000 */    0xF1, 0x24, 0xB4, 0xFC, 0x5A, 0x07, 0x0E, 0x4E, 
                /* 0008 */    0xBF, 0xC4, 0x62, 0xF3, 0xE7, 0x17, 0x71, 0xFA, 
                /* 0010 */    0x41, 0x37, 0x01, 0x01, 0xE3, 0x5E, 0xBE, 0xE2, 
                /* 0018 */    0xDA, 0x42, 0xDB, 0x49, 0x83, 0x78, 0x1F, 0x52, 
                /* 0020 */    0x47, 0x38, 0x82, 0x02, 0x41, 0x38, 0x01, 0x02, 
                /* 0028 */    0x21, 0x12, 0x90, 0x05, 0x66, 0xD5, 0xD1, 0x11, 
                /* 0030 */    0xB2, 0xF0, 0x00, 0xA0, 0xC9, 0x06, 0x29, 0x10, 
                /* 0038 */    0x42, 0x42, 0x01, 0x00
            })
            Name (PREL, Buffer (0x08)
            {
                /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
            })
            Method (WQA7, 1, NotSerialized)
            {
                Acquire (^^WMI1.MWMI, 0xFFFF)
                WMIS (0x07, Zero)
                Store (WLS0, Index (PREL, Zero))
                Store (WLS1, Index (PREL, One))
                Store (WLS2, Index (PREL, 0x02))
                Store (WLS3, Index (PREL, 0x03))
                Store (WLS4, Index (PREL, 0x04))
                Store (WLS5, Index (PREL, 0x05))
                Store (WLS6, Index (PREL, 0x06))
                Store (WLS7, Index (PREL, 0x07))
                Release (^^WMI1.MWMI)
                Return (PREL)
            }
            Method (WMA8, 3, NotSerialized)
            {
                Acquire (^^WMI1.MWMI, 0xFFFF)
                Store (Index (Arg2, Zero), WLS0)
                Store (Index (Arg2, One), WLS1)
                Store (Index (Arg2, 0x02), WLS2)
                Store (Index (Arg2, 0x03), WLS3)
                Store (Index (Arg2, 0x04), WLS4)
                Store (Index (Arg2, 0x05), WLS5)
                Store (Index (Arg2, 0x06), WLS6)
                Store (Index (Arg2, 0x07), WLS7)
                WMIS (0x08, Zero)
                Release (^^WMI1.MWMI)
                Return (Zero)
            }
            Name (WQBB, Buffer (0x037C)
            {
                /* 0000 */    0x46, 0x4F, 0x4D, 0x42, 0x01, 0x00, 0x00, 0x00, 
                /* 0008 */    0x6C, 0x03, 0x00, 0x00, 0xC8, 0x0B, 0x00, 0x00, 
                /* 0010 */    0x44, 0x53, 0x00, 0x01, 0x1A, 0x7D, 0xDA, 0x54, 
                /* 0018 */    0x28, 0xDB, 0x85, 0x00, 0x01, 0x06, 0x18, 0x42, 
                /* 0020 */    0x10, 0x07, 0x10, 0x8A, 0x0D, 0x21, 0x02, 0x0B, 
                /* 0028 */    0x83, 0x50, 0x50, 0x18, 0x14, 0xA0, 0x45, 0x41, 
                /* 0030 */    0x88, 0x57, 0x04, 0x44, 0x0A, 0x84, 0x0C, 0x0B, 
                /* 0038 */    0x50, 0x2C, 0xC0, 0xB9, 0x00, 0xE9, 0x02, 0x94, 
                /* 0040 */    0xA3, 0xC8, 0x31, 0x88, 0x08, 0xDC, 0xBF, 0x3F, 
                /* 0048 */    0xC4, 0x40, 0x20, 0x52, 0x00, 0x21, 0xA1, 0x10, 
                /* 0050 */    0x12, 0x01, 0x4C, 0x85, 0xC0, 0x11, 0x82, 0x7E, 
                /* 0058 */    0x05, 0x20, 0x74, 0x28, 0x40, 0xA6, 0x00, 0x83, 
                /* 0060 */    0x02, 0x9C, 0x22, 0x88, 0x20, 0x4A, 0xCB, 0x02, 
                /* 0068 */    0x74, 0x0B, 0xF0, 0x2D, 0x40, 0x3B, 0x84, 0xD0, 
                /* 0070 */    0x22, 0x57, 0x2A, 0xC0, 0x22, 0x94, 0x7C, 0x02, 
                /* 0078 */    0x4A, 0x22, 0x8A, 0x64, 0xE3, 0xC9, 0x36, 0x22, 
                /* 0080 */    0x99, 0x87, 0x45, 0x0E, 0x02, 0x25, 0x66, 0x10, 
                /* 0088 */    0x28, 0x9D, 0xB8, 0xB2, 0x89, 0xAB, 0x41, 0x1C, 
                /* 0090 */    0x40, 0x94, 0xF3, 0x88, 0x92, 0xE0, 0xA8, 0x0E, 
                /* 0098 */    0x22, 0x42, 0xEC, 0x72, 0x05, 0x48, 0x1E, 0x80, 
                /* 00A0 */    0x34, 0x4F, 0x4C, 0xD6, 0xE7, 0xA0, 0x91, 0xB1, 
                /* 00A8 */    0x11, 0xF0, 0x38, 0x12, 0x40, 0x58, 0x94, 0x75, 
                /* 00B0 */    0x2A, 0x00, 0x0C, 0xCA, 0x03, 0x88, 0xE4, 0x8C, 
                /* 00B8 */    0x15, 0x05, 0x6C, 0xAF, 0x13, 0x91, 0xC9, 0x81, 
                /* 00C0 */    0x52, 0x49, 0x70, 0xA8, 0x61, 0x7A, 0x6A, 0xCD, 
                /* 00C8 */    0x4F, 0x4C, 0x13, 0x39, 0xB5, 0xA6, 0x87, 0x2C, 
                /* 00D0 */    0x48, 0x26, 0x6D, 0x28, 0xA8, 0xB1, 0x7B, 0x5A, 
                /* 00D8 */    0x27, 0xE5, 0x99, 0x46, 0x3C, 0x28, 0xC3, 0x24, 
                /* 00E0 */    0xF0, 0x28, 0x18, 0x1A, 0x27, 0x28, 0xEB, 0x44, 
                /* 00E8 */    0x40, 0x07, 0xCA, 0x01, 0x4F, 0xC2, 0x73, 0x2C, 
                /* 00F0 */    0x5E, 0x80, 0xF0, 0x11, 0x93, 0xB3, 0x40, 0x8C, 
                /* 00F8 */    0x04, 0x3E, 0x13, 0x78, 0xE4, 0xC7, 0x8C, 0x1D, 
                /* 0100 */    0x51, 0xB8, 0x80, 0xE7, 0x73, 0x0C, 0x91, 0xE3, 
                /* 0108 */    0x1E, 0x6A, 0x8C, 0xA3, 0x88, 0x7C, 0x38, 0x0C, 
                /* 0110 */    0xED, 0x74, 0xE3, 0x1C, 0xD8, 0xE9, 0x14, 0x04, 
                /* 0118 */    0x2E, 0x90, 0x60, 0x3D, 0xCF, 0x59, 0x20, 0xFF, 
                /* 0120 */    0xFF, 0x18, 0x07, 0xC1, 0xF0, 0x8E, 0x01, 0x23, 
                /* 0128 */    0x03, 0x42, 0x1E, 0x05, 0x58, 0x1D, 0x96, 0x26, 
                /* 0130 */    0x91, 0xC0, 0xEE, 0x05, 0x68, 0xBC, 0x04, 0x48, 
                /* 0138 */    0xE1, 0x20, 0xA5, 0x0C, 0x42, 0x30, 0x8D, 0x09, 
                /* 0140 */    0xB0, 0x75, 0x68, 0x90, 0x37, 0x01, 0xD6, 0xAE, 
                /* 0148 */    0x02, 0x42, 0x89, 0x74, 0x02, 0x71, 0x42, 0x44, 
                /* 0150 */    0x89, 0x18, 0xD4, 0x40, 0x51, 0x6A, 0x43, 0x15, 
                /* 0158 */    0x4C, 0x67, 0xC3, 0x13, 0x66, 0xDC, 0x10, 0x31, 
                /* 0160 */    0x0C, 0x14, 0xB7, 0xFD, 0x41, 0x90, 0x61, 0xE3, 
                /* 0168 */    0xC6, 0xEF, 0x41, 0x9D, 0xD6, 0xD9, 0x1D, 0xD3, 
                /* 0170 */    0xAB, 0x82, 0x09, 0x3C, 0xE9, 0x37, 0x84, 0xA7, 
                /* 0178 */    0x83, 0xA3, 0x38, 0xDA, 0xA8, 0x31, 0x9A, 0x83, 
                /* 0180 */    0x22, 0xB1, 0xDF, 0x10, 0xD2, 0x00, 0xA2, 0x48, 
                /* 0188 */    0xF0, 0xA8, 0xF3, 0x82, 0x4F, 0x06, 0x1E, 0xDA, 
                /* 0190 */    0x61, 0x7B, 0xB0, 0x67, 0xE9, 0x21, 0x1C, 0xC1, 
                /* 0198 */    0x33, 0xC3, 0x23, 0x81, 0xC7, 0xC0, 0xEE, 0x0A, 
                /* 01A0 */    0x3E, 0x04, 0xF8, 0x8C, 0x80, 0x77, 0x0D, 0xA8, 
                /* 01A8 */    0xCB, 0xC1, 0xA3, 0x01, 0x9B, 0x74, 0x38, 0xCC, 
                /* 01B0 */    0x78, 0x3D, 0x77, 0x4F, 0xDD, 0x67, 0x0C, 0x7E, 
                /* 01B8 */    0xDE, 0xF0, 0xE0, 0x70, 0x23, 0x3D, 0x99, 0x23, 
                /* 01C0 */    0x2B, 0x55, 0x80, 0xD9, 0x6B, 0x80, 0x8E, 0x12, 
                /* 01C8 */    0x3E, 0x70, 0xB0, 0xBB, 0xC0, 0x53, 0x80, 0x09, 
                /* 01D0 */    0x2C, 0x7F, 0x10, 0xA8, 0x91, 0x19, 0xDA, 0xE3, 
                /* 01D8 */    0x7D, 0xEF, 0x30, 0xE4, 0x93, 0xC2, 0x61, 0x31, 
                /* 01E0 */    0xB1, 0x07, 0x0F, 0x3A, 0x1E, 0xF0, 0xDF, 0x47, 
                /* 01E8 */    0x9E, 0x34, 0x3C, 0x7D, 0xCF, 0xD7, 0x04, 0x63, 
                /* 01F0 */    0x42, 0xC8, 0xCA, 0x78, 0x50, 0xA3, 0xB0, 0xD6, 
                /* 01F8 */    0x73, 0x00, 0xB9, 0x2B, 0x9C, 0x8E, 0x63, 0x0D, 
                /* 0200 */    0x9A, 0x1E, 0x51, 0x0C, 0xE2, 0xFF, 0xFF, 0xB9, 
                /* 0208 */    0x82, 0x1F, 0x25, 0xD8, 0x61, 0x21, 0xEA, 0x23, 
                /* 0210 */    0x80, 0x47, 0x72, 0x42, 0x3E, 0x49, 0x00, 0x0B, 
                /* 0218 */    0x88, 0x37, 0x09, 0x3E, 0x46, 0xF8, 0xB0, 0x4F, 
                /* 0220 */    0x00, 0x1E, 0xC5, 0xFB, 0xC3, 0x8B, 0x83, 0x09, 
                /* 0228 */    0xA2, 0x3D, 0xBF, 0x80, 0x71, 0x46, 0xB8, 0xA3, 
                /* 0230 */    0x06, 0x9C, 0x03, 0x0C, 0xF0, 0x80, 0x3A, 0x04, 
                /* 0238 */    0xCC, 0x39, 0xC2, 0x43, 0xE0, 0x03, 0x78, 0xFC, 
                /* 0240 */    0x38, 0x47, 0x9F, 0x70, 0xCE, 0x0C, 0x77, 0xD2, 
                /* 0248 */    0x01, 0xDB, 0x30, 0x78, 0x50, 0x0B, 0x27, 0x1B, 
                /* 0250 */    0xFA, 0x24, 0x50, 0xC0, 0xB7, 0x01, 0x85, 0xF1, 
                /* 0258 */    0xB9, 0x06, 0xB8, 0xFC, 0xFF, 0xCF, 0x35, 0xC0, 
                /* 0260 */    0xEB, 0x7C, 0x80, 0x3B, 0x3E, 0xC0, 0x9D, 0x77, 
                /* 0268 */    0xB0, 0x38, 0x0F, 0x0F, 0x4F, 0x36, 0xC0, 0x60, 
                /* 0270 */    0x48, 0x4F, 0x33, 0x2F, 0x34, 0x31, 0xDE, 0x6A, 
                /* 0278 */    0x42, 0x44, 0x78, 0x9E, 0x79, 0xAD, 0x31, 0x52, 
                /* 0280 */    0xBC, 0x27, 0x1B, 0x76, 0x83, 0x39, 0x8B, 0x67, 
                /* 0288 */    0x8F, 0x28, 0xC5, 0xA1, 0xE9, 0x4E, 0x13, 0x23, 
                /* 0290 */    0xCA, 0x4B, 0x8D, 0x61, 0x5F, 0x72, 0x0C, 0x14, 
                /* 0298 */    0x2A, 0x52, 0x84, 0x30, 0x2F, 0x16, 0x21, 0x9E, 
                /* 02A0 */    0x6C, 0xC0, 0x2C, 0xE9, 0x91, 0xA2, 0xCF, 0x81, 
                /* 02A8 */    0x4F, 0x36, 0x80, 0xAB, 0xFF, 0xFF, 0xC9, 0x06, 
                /* 02B0 */    0x38, 0x0F, 0xC3, 0xC7, 0x14, 0xB0, 0xDD, 0x1C, 
                /* 02B8 */    0xD8, 0x3D, 0x05, 0xFE, 0x39, 0x05, 0x70, 0x14, 
                /* 02C0 */    0xFF, 0xDD, 0xA1, 0x83, 0x87, 0xA3, 0x53, 0xC8, 
                /* 02C8 */    0xC6, 0x33, 0xC0, 0x67, 0x22, 0x2A, 0x0B, 0x48, 
                /* 02D0 */    0x33, 0x05, 0x0B, 0x41, 0x09, 0x23, 0xA0, 0x10, 
                /* 02D8 */    0x0E, 0x3F, 0x06, 0x8F, 0x8C, 0xC2, 0x39, 0x2C, 
                /* 02E0 */    0x18, 0x05, 0xF1, 0xF9, 0xC0, 0x41, 0x0E, 0x4D, 
                /* 02E8 */    0xD0, 0xFF, 0xFF, 0x67, 0x92, 0xE7, 0x09, 0x58, 
                /* 02F0 */    0x57, 0x07, 0x1F, 0x14, 0x38, 0x9C, 0x8F, 0x2B, 
                /* 02F8 */    0x1C, 0xCE, 0xA7, 0x11, 0x7E, 0x6C, 0xE4, 0xA7, 
                /* 0300 */    0x24, 0x70, 0x09, 0x3C, 0x2F, 0x80, 0x02, 0xC8, 
                /* 0308 */    0x57, 0x03, 0x1F, 0x01, 0x1E, 0x0F, 0xD8, 0x1C, 
                /* 0310 */    0x9E, 0x06, 0x7C, 0x16, 0x60, 0xF0, 0x3C, 0xDA, 
                /* 0318 */    0xA8, 0xE8, 0xA9, 0xC6, 0xC3, 0xE3, 0xA7, 0x05, 
                /* 0320 */    0xCF, 0xE7, 0x59, 0xE0, 0x28, 0x9F, 0x06, 0x70, 
                /* 0328 */    0x18, 0xAF, 0x16, 0x1E, 0xA2, 0x0F, 0x38, 0xB0, 
                /* 0330 */    0x26, 0xF2, 0x36, 0x60, 0xD1, 0x87, 0x01, 0x81, 
                /* 0338 */    0x3E, 0x6E, 0x61, 0x0E, 0x38, 0xC0, 0x49, 0xA1, 
                /* 0340 */    0x4D, 0x9F, 0x1A, 0x8D, 0x5A, 0x35, 0x28, 0x53, 
                /* 0348 */    0xA3, 0x4C, 0x83, 0x5A, 0x7D, 0x2A, 0x35, 0x66, 
                /* 0350 */    0xCC, 0x04, 0x94, 0xC4, 0x9D, 0x11, 0xA8, 0xA4, 
                /* 0358 */    0x65, 0x69, 0x5C, 0x0E, 0x04, 0x42, 0x65, 0x9F, 
                /* 0360 */    0x29, 0x05, 0xE2, 0xA8, 0x8F, 0x18, 0x01, 0x3A, 
                /* 0368 */    0xE4, 0x6B, 0x49, 0x40, 0x96, 0xB8, 0x2A, 0x81, 
                /* 0370 */    0x58, 0x92, 0x0A, 0x88, 0x46, 0x0E, 0x01, 0x06, 
                /* 0378 */    0x11, 0x90, 0xFF, 0xFF
            })
        }
        Device (PWRB)
        {
            Name (_HID, EisaId ("PNP0C0C"))
        }
    }
    Scope (_SB.PCI0.RP06)
    {
        Device (BLAN)
        {
            Name (_ADR, Zero)
            OperationRegion (PXCS, PCI_Config, 0x40, 0xC0)
            Field (PXCS, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                L0SE,   1, 
                        Offset (0x11), 
                        Offset (0x12), 
                    ,   13, 
                LASX,   1, 
                        Offset (0x1A), 
                ABPX,   1, 
                    ,   2, 
                PDCX,   1, 
                    ,   2, 
                PDSX,   1, 
                        Offset (0x1B), 
                LSCX,   1, 
                        Offset (0x20), 
                        Offset (0x22), 
                PSPX,   1, 
                        Offset (0x98), 
                    ,   30, 
                HPEX,   1, 
                PMEX,   1, 
                    ,   30, 
                HPSX,   1, 
                PMSX,   1
            }
            Device (PXSX)
            {
                Name (_ADR, Zero)
                Name (_PRW, Package (0x02)
                {
                    0x09, 
                    0x04
                })
            }
            Method (HPME, 0, Serialized)
            {
                If (PMSX)
                {
                    Store (0xC8, Local0)
                    While (Local0)
                    {
                        Store (One, PMSX)
                        If (PMSX)
                        {
                            Decrement (Local0)
                        }
                        Else
                        {
                            Store (Zero, Local0)
                        }
                    }
                    Notify (PXSX, 0x02)
                }
            }
            Name (_PRW, Package (0x02)
            {
                0x09, 
                0x04
            })
            Method (_PSW, 1, NotSerialized)
            {
                If (WOLN)
                {
                    Store (One, ^^PMSX)
                    Store (Arg0, LANO)
                }
                Else
                {
                    Store (Zero, LANO)
                }
            }
        }
    }
    Name (SPS, Zero)
    Name (OSIF, Zero)
    Name (W98F, Zero)
    Name (WNTF, Zero)
    Name (WMEF, Zero)
    Name (WXPF, Zero)
    Name (WVIS, Zero)
    Name (WSPV, Zero)
    Name (LNUX, Zero)
    Name (H8DR, Zero)
    Name (MEMX, Zero)
    Name (FNID, Zero)
    Name (RRBF, Zero)
    Name (NBCF, Zero)
    Scope (_SB.PCI0.LPCB.EC)
    {
        Method (DGSY, 1, NotSerialized)
        {
            Store (DB1E, DB1F)
            Store (DB1D, DB1E)
            Store (DB1C, DB1D)
            Store (DB1B, DB1C)
            Store (DB1A, DB1B)
            Store (DB19, DB1A)
            Store (DB18, DB19)
            Store (DB17, DB18)
            Store (DB16, DB17)
            Store (DB15, DB16)
            Store (DB14, DB15)
            Store (DB13, DB14)
            Store (DB12, DB13)
            Store (DB11, DB12)
            Store (DB10, DB11)
            Store (DB0F, DB10)
            Store (DB0E, DB0F)
            Store (DB0D, DB0E)
            Store (DB0C, DB0D)
            Store (DB0B, DB0C)
            Store (DB0A, DB0B)
            Store (DB09, DB0A)
            Store (DB08, DB09)
            Store (DB07, DB08)
            Store (DB06, DB07)
            Store (DB05, DB06)
            Store (DB04, DB05)
            Store (DB03, DB04)
            Store (DB02, DB03)
            Store (DB01, DB02)
            Store (DB00, DB01)
            Store (Arg0, DB00)
        }
    }
    Method (B1B2, 2, NotSerialized)
    {
    	// byte Arg0 is LSB, byte Arg1 is MSB
    	Return (Or (ShiftLeft (Arg1, 8), Arg0))
    }
}
